unit BRCplLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:17:04 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\brcpl.dll (1)
// LIBID: {A32BEBF3-237C-42FD-91DC-DE6C3F486432}
// LCID: 0
// Helpfile: 
// HelpString: Backup and Restore Control Panel Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  BRCplLibMajorVersion = 2;
  BRCplLibMinorVersion = 0;

  LIBID_BRCplLib: TGUID = '{A32BEBF3-237C-42FD-91DC-DE6C3F486432}';

  IID_IBRCplBackupAppDynamicInfo: TGUID = '{4236A434-5995-43C0-B6D4-330344B0E9A0}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum _BRCPL_BACKUP_MEDIA_TYPE
type
  _BRCPL_BACKUP_MEDIA_TYPE = TOleEnum;
const
  BRCPL_BACKUP_MEDIA_TYPE_UNDEFINED = $00000000;
  BRCPL_BACKUP_MEDIA_TYPE_CDROM = $00000001;
  BRCPL_BACKUP_MEDIA_TYPE_SMALL_FLOOPY = $00000002;
  BRCPL_BACKUP_MEDIA_TYPE_BIG_FLOOPY = $00000003;
  BRCPL_BACKUP_MEDIA_TYPE_FIXED = $00000004;
  BRCPL_BACKUP_MEDIA_TYPE_NETWORK_SHARE = $00000005;
  BRCPL_BACKUP_MEDIA_TYPE_MO = $00000006;
  BRCPL_BACKUP_MEDIA_TYPE_REMOVABLE = $00000007;
  BRCPL_BACKUP_MEDIA_TYPE_HOTPLUG_HD = $00000008;
  BRCPL_BACKUP_MEDIA_TYPE_UDF_WRITE = $00000009;
  BRCPL_BACKUP_MEDIA_TYPE_DVD = $0000000A;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IBRCplBackupAppDynamicInfo = interface;

// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PUserType1 = ^TGUID; {*}
  PUserType2 = ^BRCPL_BACKUP_CONFIG; {*}

  BRCPL_BACKUP_MEDIA_TYPE = _BRCPL_BACKUP_MEDIA_TYPE; 

  _BRCPL_BACKUP_CONFIG = packed record
    Size: Integer;
    Configured: Integer;
    LastBackupTime: TDateTime;
    NextBackupTime: TDateTime;
    MediaType: BRCPL_BACKUP_MEDIA_TYPE;
    MediaLocation: array[0..259] of Word;
    BackupInProgress: Integer;
    BackupDisabledByAdmin: Integer;
    RestoreDisabledByAdmin: Integer;
  end;

  BRCPL_BACKUP_CONFIG = _BRCPL_BACKUP_CONFIG; 

// *********************************************************************//
// Interface: IBRCplBackupAppDynamicInfo
// Flags:     (256) OleAutomation
// GUID:      {4236A434-5995-43C0-B6D4-330344B0E9A0}
// *********************************************************************//
  IBRCplBackupAppDynamicInfo = interface(IUnknown)
    ['{4236A434-5995-43C0-B6D4-330344B0E9A0}']
    function GetBackupConfig(var Id: TGUID; out Config: PUserType2): HResult; stdcall;
  end;

implementation

uses ComObj;

end.
