unit COMReplLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:18:29 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\comrepl.dll (1)
// LIBID: {98315905-7BE5-11D2-ADC1-00A02463D6E7}
// LCID: 0
// Helpfile: 
// HelpString: ComPlus 1.0 Catalog Replication Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  COMReplLibMajorVersion = 1;
  COMReplLibMinorVersion = 0;

  LIBID_COMReplLib: TGUID = '{98315905-7BE5-11D2-ADC1-00A02463D6E7}';

  IID_ICOMReplicate: TGUID = '{52F25063-A5F1-11D2-AE04-00A02463D6E7}';
  IID_ICOMReplicateCatalog: TGUID = '{98315904-7BE5-11D2-ADC1-00A02463D6E7}';
  IID_ICOMReplicate2: TGUID = '{64787FF9-ECA5-4BB4-9302-5E47218E0399}';
  CLASS_ReplicateCatalog: TGUID = '{8C836AF9-FFAC-11D0-8ED4-00C04FC2C17B}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ICOMReplicate = interface;
  ICOMReplicateDisp = dispinterface;
  ICOMReplicateCatalog = interface;
  ICOMReplicateCatalogDisp = dispinterface;
  ICOMReplicate2 = interface;
  ICOMReplicate2Disp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  ReplicateCatalog = ICOMReplicate2;


// *********************************************************************//
// Interface: ICOMReplicate
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {52F25063-A5F1-11D2-AE04-00A02463D6E7}
// *********************************************************************//
  ICOMReplicate = interface(IDispatch)
    ['{52F25063-A5F1-11D2-AE04-00A02463D6E7}']
    procedure Initialize(const bstrSourceComputer: WideString; lOptions: Integer); safecall;
    procedure ExportSourceCatalogFiles; safecall;
    procedure GetTargetStatus(const bstrTargetComputer: WideString; out plStatus: Integer; 
                              out pbstrMaster: WideString); safecall;
    procedure CopyFilesToTarget(const bstrTargetComputer: WideString); safecall;
    procedure InstallTarget(const bstrTargetComputer: WideString); safecall;
    procedure CleanupSourceShares; safecall;
    procedure GetLogFile(out pbstrLogFile: WideString); safecall;
    procedure RollbackTarget(const bstrTargetComputer: WideString); safecall;
  end;

// *********************************************************************//
// DispIntf:  ICOMReplicateDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {52F25063-A5F1-11D2-AE04-00A02463D6E7}
// *********************************************************************//
  ICOMReplicateDisp = dispinterface
    ['{52F25063-A5F1-11D2-AE04-00A02463D6E7}']
    procedure Initialize(const bstrSourceComputer: WideString; lOptions: Integer); dispid 1;
    procedure ExportSourceCatalogFiles; dispid 2;
    procedure GetTargetStatus(const bstrTargetComputer: WideString; out plStatus: Integer; 
                              out pbstrMaster: WideString); dispid 4;
    procedure CopyFilesToTarget(const bstrTargetComputer: WideString); dispid 5;
    procedure InstallTarget(const bstrTargetComputer: WideString); dispid 6;
    procedure CleanupSourceShares; dispid 7;
    procedure GetLogFile(out pbstrLogFile: WideString); dispid 8;
    procedure RollbackTarget(const bstrTargetComputer: WideString); dispid 9;
  end;

// *********************************************************************//
// Interface: ICOMReplicateCatalog
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {98315904-7BE5-11D2-ADC1-00A02463D6E7}
// *********************************************************************//
  ICOMReplicateCatalog = interface(IDispatch)
    ['{98315904-7BE5-11D2-ADC1-00A02463D6E7}']
    procedure Initialize(lOptions: Integer); safecall;
    procedure ExportSourceCatalogFiles(const bstrSourceComputer: WideString); safecall;
    procedure CopyCatalogFilesToTarget(const bstrTargetComputer: WideString); safecall;
    procedure InstallCatalogOnTarget(const bstrTargetComputer: WideString); safecall;
    procedure CleanupSource; safecall;
    procedure GetLogFilePath(out pbstrLogFile: WideString); safecall;
  end;

// *********************************************************************//
// DispIntf:  ICOMReplicateCatalogDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {98315904-7BE5-11D2-ADC1-00A02463D6E7}
// *********************************************************************//
  ICOMReplicateCatalogDisp = dispinterface
    ['{98315904-7BE5-11D2-ADC1-00A02463D6E7}']
    procedure Initialize(lOptions: Integer); dispid 1;
    procedure ExportSourceCatalogFiles(const bstrSourceComputer: WideString); dispid 2;
    procedure CopyCatalogFilesToTarget(const bstrTargetComputer: WideString); dispid 3;
    procedure InstallCatalogOnTarget(const bstrTargetComputer: WideString); dispid 4;
    procedure CleanupSource; dispid 5;
    procedure GetLogFilePath(out pbstrLogFile: WideString); dispid 6;
  end;

// *********************************************************************//
// Interface: ICOMReplicate2
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {64787FF9-ECA5-4BB4-9302-5E47218E0399}
// *********************************************************************//
  ICOMReplicate2 = interface(ICOMReplicate)
    ['{64787FF9-ECA5-4BB4-9302-5E47218E0399}']
    procedure GetOSVersion(const bstrTargetComputer: WideString; out plOSVersion: Integer); safecall;
  end;

// *********************************************************************//
// DispIntf:  ICOMReplicate2Disp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {64787FF9-ECA5-4BB4-9302-5E47218E0399}
// *********************************************************************//
  ICOMReplicate2Disp = dispinterface
    ['{64787FF9-ECA5-4BB4-9302-5E47218E0399}']
    procedure GetOSVersion(const bstrTargetComputer: WideString; out plOSVersion: Integer); dispid 10;
    procedure Initialize(const bstrSourceComputer: WideString; lOptions: Integer); dispid 1;
    procedure ExportSourceCatalogFiles; dispid 2;
    procedure GetTargetStatus(const bstrTargetComputer: WideString; out plStatus: Integer; 
                              out pbstrMaster: WideString); dispid 4;
    procedure CopyFilesToTarget(const bstrTargetComputer: WideString); dispid 5;
    procedure InstallTarget(const bstrTargetComputer: WideString); dispid 6;
    procedure CleanupSourceShares; dispid 7;
    procedure GetLogFile(out pbstrLogFile: WideString); dispid 8;
    procedure RollbackTarget(const bstrTargetComputer: WideString); dispid 9;
  end;

// *********************************************************************//
// The Class CoReplicateCatalog provides a Create and CreateRemote method to          
// create instances of the default interface ICOMReplicate2 exposed by              
// the CoClass ReplicateCatalog. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoReplicateCatalog = class
    class function Create: ICOMReplicate2;
    class function CreateRemote(const MachineName: string): ICOMReplicate2;
  end;

implementation

uses ComObj;

class function CoReplicateCatalog.Create: ICOMReplicate2;
begin
  Result := CreateComObject(CLASS_ReplicateCatalog) as ICOMReplicate2;
end;

class function CoReplicateCatalog.CreateRemote(const MachineName: string): ICOMReplicate2;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_ReplicateCatalog) as ICOMReplicate2;
end;

end.
