unit FindNetPrintersLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:24:02 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\findnetprinters.dll (1)
// LIBID: {0FFF9602-69CF-4728-9EA4-141514866CA2}
// LCID: 0
// Helpfile: 
// HelpString: Find Printers type library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  FindNetPrintersLibMajorVersion = 1;
  FindNetPrintersLibMinorVersion = 0;

  LIBID_FindNetPrintersLib: TGUID = '{0FFF9602-69CF-4728-9EA4-141514866CA2}';

  IID_IFindNetPrinters: TGUID = '{3741A885-71B8-49B4-8303-3EAB8628FF8A}';
  CLASS_CFindNetPrinters: TGUID = '{8FADC6A8-183E-4DFC-944A-84A323334B98}';
  IID_IFindNetPrintersCallback: TGUID = '{0075F3EA-AD58-4860-AC5B-302D9334A294}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum tagEPrinterStatus
type
  tagEPrinterStatus = TOleEnum;
const
  kPrinterDiscovered = $00000000;
  kPrinterReceived1284IDResponse = $00000001;
  kPrinterReceivedSystemDescriptionResponse = $00000002;
  kPrinterReceivedDeviceIDResponse = $00000003;
  kPrinterDiscoveryFailed = $00000004;
  kPrinterDiscoveryComplete = $00000005;

// Constants for enum tagEPrinterStatusDetails
type
  tagEPrinterStatusDetails = TOleEnum;
const
  kNone = $00000000;
  kPrinterResponseFailed = $00000001;
  kINIFileInfoIncomplete = $00000002;
  kNoDeviceIDFoundInINI = $00000003;
  kUnableToUpdateDeviceID = $00000004;
  kUnableToSetDeviceIdUnavailable = $00000005;
  kNoPrinterMIBSupport = $00000006;
  kUpdateSystemDescriptionFailed = $00000007;
  kErrorProcessingPrinterProbe = $00000008;
  kINIFileReadError = $00000009;

// Constants for enum tagEDiscoveryProgress
type
  tagEDiscoveryProgress = TOleEnum;
const
  kScanningIpAddresses = $00000000;
  kProcessingPrinterResponses = $00000001;
  kComplete = $00000002;
  kCanceled = $00000003;
  kFailed = $00000004;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IFindNetPrinters = interface;
  IFindNetPrintersCallback = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  CFindNetPrinters = IFindNetPrinters;


// *********************************************************************//
// Interface: IFindNetPrinters
// Flags:     (0)
// GUID:      {3741A885-71B8-49B4-8303-3EAB8628FF8A}
// *********************************************************************//
  IFindNetPrinters = interface(IUnknown)
    ['{3741A885-71B8-49B4-8303-3EAB8628FF8A}']
    function Init(const pCallback: IFindNetPrintersCallback; out pcIpsToPoll: LongWord): HResult; stdcall;
    function Start: HResult; stdcall;
    function Cancel: HResult; stdcall;
    function Running(out pbRunning: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IFindNetPrintersCallback
// Flags:     (0)
// GUID:      {0075F3EA-AD58-4860-AC5B-302D9334A294}
// *********************************************************************//
  IFindNetPrintersCallback = interface(IUnknown)
    ['{0075F3EA-AD58-4860-AC5B-302D9334A294}']
    function OnPrinterStatus(nPrinterId: SYSUINT; const bstrIP: WideString; 
                             const bstrManufacturerName: WideString; 
                             const bstrModelName: WideString; 
                             const bstrSystemDescriptionsta: WideString; 
                             nStatus: tagEPrinterStatus; nStatusDetails: tagEPrinterStatusDetails): HResult; stdcall;
    function OnDiscoveryProgress(__MIDL__IFindNetPrintersCallback0000: tagEDiscoveryProgress; 
                                 nCurrent: SYSUINT; nCount: SYSUINT): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoCFindNetPrinters provides a Create and CreateRemote method to          
// create instances of the default interface IFindNetPrinters exposed by              
// the CoClass CFindNetPrinters. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCFindNetPrinters = class
    class function Create: IFindNetPrinters;
    class function CreateRemote(const MachineName: string): IFindNetPrinters;
  end;

implementation

uses ComObj;

class function CoCFindNetPrinters.Create: IFindNetPrinters;
begin
  Result := CreateComObject(CLASS_CFindNetPrinters) as IFindNetPrinters;
end;

class function CoCFindNetPrinters.CreateRemote(const MachineName: string): IFindNetPrinters;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CFindNetPrinters) as IFindNetPrinters;
end;

end.
