unit HelpServiceTypeLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 3:52:40 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: MsraLegacy.tlb (1)
// LIBID: {833E4000-AFF7-4AC3-AAC2-9F24C1457BCE}
// LCID: 0
// Helpfile: 
// HelpString: Help Service 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  HelpServiceTypeLibMajorVersion = 1;
  HelpServiceTypeLibMinorVersion = 0;

  LIBID_HelpServiceTypeLib: TGUID = '{833E4000-AFF7-4AC3-AAC2-9F24C1457BCE}';

  IID_IPCHService: TGUID = '{833E4200-AFF7-4AC3-AAC2-9F24C1457BCE}';
  IID_IPCHCollection: TGUID = '{833E4100-AFF7-4AC3-AAC2-9F24C1457BCE}';
  IID_ISAFSession: TGUID = '{833E41AA-AFF7-4AC3-AAC2-9F24C1457BCE}';
  CLASS_PCHService: TGUID = '{833E4010-AFF7-4AC3-AAC2-9F24C1457BCE}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum __MIDL___MIDL_itf_msralegacy_0001_0000_0001
type
  __MIDL___MIDL_itf_msralegacy_0001_0000_0001 = TOleEnum;
const
  pchActive = $00000000;
  pchConnected = $00000001;
  pchConnectQuery = $00000002;
  pchShadow = $00000003;
  pchDisconnected = $00000004;
  pchIdle = $00000005;
  pchListen = $00000006;
  pchReset = $00000007;
  pchDown = $00000008;
  pchInit = $00000009;
  pchStateInvalid = $0000000A;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IPCHService = interface;
  IPCHServiceDisp = dispinterface;
  IPCHCollection = interface;
  IPCHCollectionDisp = dispinterface;
  ISAFSession = interface;
  ISAFSessionDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  PCHService = IPCHService;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PUserType1 = ^TGUID; {*}

  SessionStateEnum = __MIDL___MIDL_itf_msralegacy_0001_0000_0001; 

// *********************************************************************//
// Interface: IPCHService
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E4200-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  IPCHService = interface(IDispatch)
    ['{833E4200-AFF7-4AC3-AAC2-9F24C1457BCE}']
    function Get_RemoteSKUs: IPCHCollection; safecall;
    function IsTrusted(const bstrURL: WideString): WordBool; safecall;
    procedure Utility(const bstrSKU: WideString; lLCID: Integer; out pVal: IUnknown); safecall;
    procedure RemoteHelpContents(const bstrSKU: WideString; lLCID: Integer; out pVal: IUnknown); safecall;
    procedure RegisterHost(const bstrID: WideString; const pObj: IUnknown); safecall;
    procedure CreateScriptWrapper(var rclsid: TGUID; const bstrCode: WideString; 
                                  const bstrURL: WideString; out ppObj: IUnknown); safecall;
    procedure TriggerScheduledDataCollection(fStart: WordBool); safecall;
    procedure PrepareForShutdown; safecall;
    procedure ForceSystemRestore; safecall;
    procedure UpgradeDetected; safecall;
    procedure MUI_Install(LCID: Integer; const bstrFile: WideString); safecall;
    procedure MUI_Uninstall(LCID: Integer); safecall;
    function RemoteConnectionParms(const bstrUserName: WideString; 
                                   const bstrDomainName: WideString; lSessionID: Integer; 
                                   const bstrUserHelpBlob: WideString): WideString; safecall;
    function RemoteUserSessionInfo: IPCHCollection; safecall;
    property RemoteSKUs: IPCHCollection read Get_RemoteSKUs;
  end;

// *********************************************************************//
// DispIntf:  IPCHServiceDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E4200-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  IPCHServiceDisp = dispinterface
    ['{833E4200-AFF7-4AC3-AAC2-9F24C1457BCE}']
    property RemoteSKUs: IPCHCollection readonly dispid 134217728;
    function IsTrusted(const bstrURL: WideString): WordBool; dispid 134217744;
    procedure Utility(const bstrSKU: WideString; lLCID: Integer; out pVal: IUnknown); dispid 134217760;
    procedure RemoteHelpContents(const bstrSKU: WideString; lLCID: Integer; out pVal: IUnknown); dispid 134217761;
    procedure RegisterHost(const bstrID: WideString; const pObj: IUnknown); dispid 134217768;
    procedure CreateScriptWrapper(var rclsid: {??TGUID}OleVariant; const bstrCode: WideString; 
                                  const bstrURL: WideString; out ppObj: IUnknown); dispid 134217769;
    procedure TriggerScheduledDataCollection(fStart: WordBool); dispid 134217776;
    procedure PrepareForShutdown; dispid 134217777;
    procedure ForceSystemRestore; dispid 134217778;
    procedure UpgradeDetected; dispid 134217779;
    procedure MUI_Install(LCID: Integer; const bstrFile: WideString); dispid 134217780;
    procedure MUI_Uninstall(LCID: Integer); dispid 134217781;
    function RemoteConnectionParms(const bstrUserName: WideString; 
                                   const bstrDomainName: WideString; lSessionID: Integer; 
                                   const bstrUserHelpBlob: WideString): WideString; dispid 134217792;
    function RemoteUserSessionInfo: IPCHCollection; dispid 134217793;
  end;

// *********************************************************************//
// Interface: IPCHCollection
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E4100-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  IPCHCollection = interface(IDispatch)
    ['{833E4100-AFF7-4AC3-AAC2-9F24C1457BCE}']
    function Get__NewEnum: IUnknown; safecall;
    function Get_Item(vIndex: Integer): OleVariant; safecall;
    function Get_Count: Integer; safecall;
    property _NewEnum: IUnknown read Get__NewEnum;
    property Item[vIndex: Integer]: OleVariant read Get_Item; default;
    property Count: Integer read Get_Count;
  end;

// *********************************************************************//
// DispIntf:  IPCHCollectionDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E4100-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  IPCHCollectionDisp = dispinterface
    ['{833E4100-AFF7-4AC3-AAC2-9F24C1457BCE}']
    property _NewEnum: IUnknown readonly dispid -4;
    property Item[vIndex: Integer]: OleVariant readonly dispid 0; default;
    property Count: Integer readonly dispid 134283264;
  end;

// *********************************************************************//
// Interface: ISAFSession
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E41AA-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  ISAFSession = interface(IDispatch)
    ['{833E41AA-AFF7-4AC3-AAC2-9F24C1457BCE}']
    function Get_SessionID: LongWord; safecall;
    procedure Set_SessionID(pVal: LongWord); safecall;
    function Get_SessionState: SessionStateEnum; safecall;
    procedure Set_SessionState(pVal: SessionStateEnum); safecall;
    function Get_DomainName: WideString; safecall;
    procedure Set_DomainName(const pVal: WideString); safecall;
    function Get_UserName: WideString; safecall;
    procedure Set_UserName(const pVal: WideString); safecall;
    property SessionID: LongWord read Get_SessionID write Set_SessionID;
    property SessionState: SessionStateEnum read Get_SessionState write Set_SessionState;
    property DomainName: WideString read Get_DomainName write Set_DomainName;
    property UserName: WideString read Get_UserName write Set_UserName;
  end;

// *********************************************************************//
// DispIntf:  ISAFSessionDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {833E41AA-AFF7-4AC3-AAC2-9F24C1457BCE}
// *********************************************************************//
  ISAFSessionDisp = dispinterface
    ['{833E41AA-AFF7-4AC3-AAC2-9F24C1457BCE}']
    property SessionID: LongWord dispid 134352144;
    property SessionState: SessionStateEnum dispid 134352145;
    property DomainName: WideString dispid 134352146;
    property UserName: WideString dispid 134352147;
  end;

// *********************************************************************//
// The Class CoPCHService provides a Create and CreateRemote method to          
// create instances of the default interface IPCHService exposed by              
// the CoClass PCHService. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoPCHService = class
    class function Create: IPCHService;
    class function CreateRemote(const MachineName: string): IPCHService;
  end;

implementation

uses ComObj;

class function CoPCHService.Create: IPCHService;
begin
  Result := CreateComObject(CLASS_PCHService) as IPCHService;
end;

class function CoPCHService.CreateRemote(const MachineName: string): IPCHService;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_PCHService) as IPCHService;
end;

end.
