unit IASDataStoreComServerLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:25:57 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\iasdatastore.dll (1)
// LIBID: {DFDFB4EB-32B7-4B7F-A3D4-F798F75D3A46}
// LCID: 0
// Helpfile: 
// HelpString: IASDataStoreComServer 1.0 type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  IASDataStoreComServerLibMajorVersion = 1;
  IASDataStoreComServerLibMinorVersion = 0;

  LIBID_IASDataStoreComServerLib: TGUID = '{DFDFB4EB-32B7-4B7F-A3D4-F798F75D3A46}';

  IID_IIASDataStoreComServer: TGUID = '{83E05BD5-AEC1-4E58-AE50-E819C7296F67}';
  IID_IIASDataStoreComServer2: TGUID = '{C323BE28-E546-4C23-A81B-D6AD8D8FAC7B}';
  CLASS_IASDataStoreComServer: TGUID = '{48DA6741-1BF0-4A44-8325-293086C79077}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IIASDataStoreComServer = interface;
  IIASDataStoreComServer2 = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  IASDataStoreComServer = IIASDataStoreComServer;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PWord1 = ^Word; {*}

  tagIAS_PRODUCT_LIMITS = packed record
    maxClients: LongWord;
    allowSubnetSyntax: Integer;
    maxServerGroups: LongWord;
  end;


// *********************************************************************//
// Interface: IIASDataStoreComServer
// Flags:     (256) OleAutomation
// GUID:      {83E05BD5-AEC1-4E58-AE50-E819C7296F67}
// *********************************************************************//
  IIASDataStoreComServer = interface(IUnknown)
    ['{83E05BD5-AEC1-4E58-AE50-E819C7296F67}']
    function GetAttributeDictionarySchema(out size: SYSINT; out data: PWord1): HResult; stdcall;
    function GetAttributeDictionary(out size: SYSINT; out data: PWord1): HResult; stdcall;
    function GetConfiguration(xpathquery: PWideChar; out size: SYSINT; out data: PWord1): HResult; stdcall;
    function SetConfiguration(xpathquery: PWideChar; data: PWideChar): HResult; stdcall;
    function Get_ProductLimits(out pVal: tagIAS_PRODUCT_LIMITS): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IIASDataStoreComServer2
// Flags:     (256) OleAutomation
// GUID:      {C323BE28-E546-4C23-A81B-D6AD8D8FAC7B}
// *********************************************************************//
  IIASDataStoreComServer2 = interface(IIASDataStoreComServer)
    ['{C323BE28-E546-4C23-A81B-D6AD8D8FAC7B}']
    function GetTemplates(wszTemplatesXpathquery: PWideChar; out pcchTemplatesSize: SYSINT; 
                          out pwszTemplatesData: PWord1): HResult; stdcall;
    function SetTemplates(wszTemplatesXpathquery: PWideChar; wszTemplatesData: PWideChar): HResult; stdcall;
    function Reload: HResult; stdcall;
    function GetSystemInfo(out pwProcessorArchitecture: Word): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoIASDataStoreComServer provides a Create and CreateRemote method to          
// create instances of the default interface IIASDataStoreComServer exposed by              
// the CoClass IASDataStoreComServer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoIASDataStoreComServer = class
    class function Create: IIASDataStoreComServer;
    class function CreateRemote(const MachineName: string): IIASDataStoreComServer;
  end;

implementation

uses ComObj;

class function CoIASDataStoreComServer.Create: IIASDataStoreComServer;
begin
  Result := CreateComObject(CLASS_IASDataStoreComServer) as IIASDataStoreComServer;
end;

class function CoIASDataStoreComServer.CreateRemote(const MachineName: string): IIASDataStoreComServer;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_IASDataStoreComServer) as IIASDataStoreComServer;
end;

end.
