unit IASRadiusLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:26:04 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\iasrad.dll (1)
// LIBID: {6BC09890-0CE6-11D1-BAAE-00C04FC2E20D}
// LCID: 0
// Helpfile: 
// HelpString: IAS RADIUS Protocol 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  IASRadiusLibMajorVersion = 1;
  IASRadiusLibMinorVersion = 0;

  LIBID_IASRadiusLib: TGUID = '{6BC09890-0CE6-11D1-BAAE-00C04FC2E20D}';

  IID_IIasComponent: TGUID = '{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IRequestSource: TGUID = '{6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IPersist: TGUID = '{0000010C-0000-0000-C000-000000000046}';
  IID_IRequest: TGUID = '{6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IPersistPropertyBag2: TGUID = '{22F55881-280B-11D0-A8A9-00A0C90C2004}';
  CLASS_RadiusProtocol: TGUID = '{6BC09894-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IPropertyBag2: TGUID = '{22F55882-280B-11D0-A8A9-00A0C90C2004}';
  IID_IErrorLog: TGUID = '{3127CA40-446E-11CE-8135-00AA004BB851}';
  IID_IIasClient: TGUID = '{6BC096D9-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_CClient: TGUID = '{6BC096DA-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_ISdo: TGUID = '{56BC53DE-96DB-11D1-BF3F-000000000000}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum _IASPROTOCOL
type
  _IASPROTOCOL = TOleEnum;
const
  IAS_PROTOCOL_INVALID = $00000000;
  IAS_PROTOCOL_NONE = $00000001;
  IAS_PROTOCOL_RADIUS = $00000002;
  IAS_PROTOCOL_TACACSPLUS = $00000003;
  IAS_PROTOCOL_LDAP = $00000004;
  IAS_PROTOCOL_RAS = $00000005;

// Constants for enum _IASRESPONSE
type
  _IASRESPONSE = TOleEnum;
const
  IAS_RESPONSE_INVALID = $00000000;
  IAS_RESPONSE_ACCESS_ACCEPT = $00000001;
  IAS_RESPONSE_ACCESS_REJECT = $00000002;
  IAS_RESPONSE_ACCESS_CHALLENGE = $00000003;
  IAS_RESPONSE_ACCOUNTING = $00000004;
  IAS_RESPONSE_DISCARD_PACKET = $00000005;
  IAS_RESPONSE_FORWARD_PACKET = $000003E7;
  IAS_RESPONSE_RAS = $000003E8;
  IAS_RESPONSE_MAX = $00000800;

// Constants for enum _IASREQUESTSTATUS
type
  _IASREQUESTSTATUS = TOleEnum;
const
  IAS_REQUEST_STATUS_ABORT = $00000000;
  IAS_REQUEST_STATUS_CONTINUE = $00000001;
  IAS_REQUEST_STATUS_HANDLED = $00000002;
  IAS_REQUEST_STATUS_INVALID = $00000003;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IIasComponent = interface;
  IIasComponentDisp = dispinterface;
  IRequestSource = interface;
  IPersist = interface;
  IRequest = interface;
  IPersistPropertyBag2 = interface;
  IPropertyBag2 = interface;
  IErrorLog = interface;
  IIasClient = interface;
  ISdo = interface;
  ISdoDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  RadiusProtocol = IIasComponent;
  CClient = IIasClient;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireCLIPFORMAT = ^_userCLIPFORMAT; 
  POleVariant1 = ^OleVariant; {*}
  PUserType1 = ^tagPROPBAG2; {*}
  PUserType2 = ^EXCEPINFO; {*}
  PUserType3 = ^sockaddr; {*}
  PByte1 = ^Byte; {*}
  PUINT1 = ^LongWord; {*}

  IASREQUESTSTATUS = _IASREQUESTSTATUS; 

  tagPROPBAG2 = packed record
    dwType: LongWord;
    vt: Word;
    cfType: wireCLIPFORMAT;
    dwHint: LongWord;
    pstrName: PWideChar;
    clsid: TGUID;
  end;

  __MIDL_IWinTypes_0001 = record
    case Integer of
      0: (dwValue: LongWord);
      1: (pwszName: PWideChar);
  end;

  _userCLIPFORMAT = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0001;
  end;

  sockaddr = packed record
    sa_family: Word;
    sa_data: array[0..13] of Byte;
  end;


// *********************************************************************//
// Interface: IIasComponent
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IIasComponent = interface(IDispatch)
    ['{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure Initialize; safecall;
    procedure Shutdown; safecall;
    procedure GetProperty(Id: Integer; var pValue: OleVariant); safecall;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); safecall;
    procedure InitNew; safecall;
    procedure Suspend; safecall;
    procedure Resume; safecall;
  end;

// *********************************************************************//
// DispIntf:  IIasComponentDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IIasComponentDisp = dispinterface
    ['{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure Initialize; dispid 1;
    procedure Shutdown; dispid 2;
    procedure GetProperty(Id: Integer; var pValue: OleVariant); dispid 3;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); dispid 4;
    procedure InitNew; dispid 5;
    procedure Suspend; dispid 6;
    procedure Resume; dispid 7;
  end;

// *********************************************************************//
// Interface: IRequestSource
// Flags:     (256) OleAutomation
// GUID:      {6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequestSource = interface(IUnknown)
    ['{6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}']
    function OnRequestComplete(const pRequest: IRequest; eStatus: IASREQUESTSTATUS): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IPersist
// Flags:     (0)
// GUID:      {0000010C-0000-0000-C000-000000000046}
// *********************************************************************//
  IPersist = interface(IUnknown)
    ['{0000010C-0000-0000-C000-000000000046}']
    function GetClassID(out pClassID: TGUID): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IRequest
// Flags:     (0)
// GUID:      {6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequest = interface(IUnknown)
    ['{6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}']
    function Get_Request(out pVal: Integer): HResult; stdcall;
    function Set_Request(pVal: Integer): HResult; stdcall;
    function Get_Response(out pVal: Integer): HResult; stdcall;
    function Get_Reason(out pVal: Integer): HResult; stdcall;
    function Get_Protocol(out pVal: _IASPROTOCOL): HResult; stdcall;
    function Set_Protocol(pVal: _IASPROTOCOL): HResult; stdcall;
    function Get_Source(out pVal: IRequestSource): HResult; stdcall;
    function Set_Source(const pVal: IRequestSource): HResult; stdcall;
    function Get_RoutingType(out pVal: Integer): HResult; stdcall;
    function Set_RoutingType(pVal: Integer): HResult; stdcall;
    function SetResponse(eResponse: _IASRESPONSE; lReason: Integer): HResult; stdcall;
    function ReturnToSource(eStatus: IASREQUESTSTATUS): HResult; stdcall;
    function Get_ErrorCode(out pVal: HResult): HResult; stdcall;
    function Set_ErrorCode(pVal: HResult): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IPersistPropertyBag2
// Flags:     (0)
// GUID:      {22F55881-280B-11D0-A8A9-00A0C90C2004}
// *********************************************************************//
  IPersistPropertyBag2 = interface(IPersist)
    ['{22F55881-280B-11D0-A8A9-00A0C90C2004}']
    function InitNew: HResult; stdcall;
    function Load(const pPropBag: IPropertyBag2; const pErrLog: IErrorLog): HResult; stdcall;
    function Save(const pPropBag: IPropertyBag2; fClearDirty: Integer; fSaveAllProperties: Integer): HResult; stdcall;
    function IsDirty: HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IPropertyBag2
// Flags:     (0)
// GUID:      {22F55882-280B-11D0-A8A9-00A0C90C2004}
// *********************************************************************//
  IPropertyBag2 = interface(IUnknown)
    ['{22F55882-280B-11D0-A8A9-00A0C90C2004}']
    function Read(cProperties: LongWord; var pPropBag: tagPROPBAG2; const pErrLog: IErrorLog; 
                  out pvarValue: OleVariant; var phrError: HResult): HResult; stdcall;
    function Write(cProperties: LongWord; var pPropBag: tagPROPBAG2; var pvarValue: OleVariant): HResult; stdcall;
    function CountProperties(out pcProperties: LongWord): HResult; stdcall;
    function GetPropertyInfo(iProperty: LongWord; cProperties: LongWord; out pPropBag: tagPROPBAG2; 
                             out pcProperties: LongWord): HResult; stdcall;
    function LoadObject(pstrName: PWideChar; dwHint: LongWord; const pUnkObject: IUnknown; 
                        const pErrLog: IErrorLog): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IErrorLog
// Flags:     (0)
// GUID:      {3127CA40-446E-11CE-8135-00AA004BB851}
// *********************************************************************//
  IErrorLog = interface(IUnknown)
    ['{3127CA40-446E-11CE-8135-00AA004BB851}']
    function AddError(pszPropName: PWideChar; var pExcepInfo: EXCEPINFO): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IIasClient
// Flags:     (0)
// GUID:      {6BC096D9-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IIasClient = interface(IUnknown)
    ['{6BC096D9-0CE6-11D1-BAAE-00C04FC2E20D}']
    function GetAddress: PUserType3; stdcall;
    function NeedSignatureCheck: Integer; stdcall;
    function GetVendorType: Integer; stdcall;
    function GetClientNameW: PWideChar; stdcall;
    function GetClientAddressW: PWideChar; stdcall;
    function GetSecret(var pdwSecretSize: LongWord): PByte1; stdcall;
    function Init(const pISdo: ISdo): HResult; stdcall;
    function ResolveAddress: HResult; stdcall;
    function IsQuarantineCompatible: Integer; stdcall;
    function IsClientEnabled: Integer; stdcall;
  end;

// *********************************************************************//
// Interface: ISdo
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {56BC53DE-96DB-11D1-BF3F-000000000000}
// *********************************************************************//
  ISdo = interface(IDispatch)
    ['{56BC53DE-96DB-11D1-BF3F-000000000000}']
    function GetPropertyInfo(Id: Integer): IUnknown; safecall;
    function GetProperty(Id: Integer): OleVariant; safecall;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); safecall;
    procedure ResetProperty(Id: Integer); safecall;
    procedure Apply; safecall;
    procedure Restore; safecall;
    function Get__NewEnum: IUnknown; safecall;
    property _NewEnum: IUnknown read Get__NewEnum;
  end;

// *********************************************************************//
// DispIntf:  ISdoDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {56BC53DE-96DB-11D1-BF3F-000000000000}
// *********************************************************************//
  ISdoDisp = dispinterface
    ['{56BC53DE-96DB-11D1-BF3F-000000000000}']
    function GetPropertyInfo(Id: Integer): IUnknown; dispid 1;
    function GetProperty(Id: Integer): OleVariant; dispid 2;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); dispid 3;
    procedure ResetProperty(Id: Integer); dispid 4;
    procedure Apply; dispid 5;
    procedure Restore; dispid 6;
    property _NewEnum: IUnknown readonly dispid -4;
  end;

// *********************************************************************//
// The Class CoRadiusProtocol provides a Create and CreateRemote method to          
// create instances of the default interface IIasComponent exposed by              
// the CoClass RadiusProtocol. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoRadiusProtocol = class
    class function Create: IIasComponent;
    class function CreateRemote(const MachineName: string): IIasComponent;
  end;

// *********************************************************************//
// The Class CoCClient provides a Create and CreateRemote method to          
// create instances of the default interface IIasClient exposed by              
// the CoClass CClient. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCClient = class
    class function Create: IIasClient;
    class function CreateRemote(const MachineName: string): IIasClient;
  end;

implementation

uses ComObj;

class function CoRadiusProtocol.Create: IIasComponent;
begin
  Result := CreateComObject(CLASS_RadiusProtocol) as IIasComponent;
end;

class function CoRadiusProtocol.CreateRemote(const MachineName: string): IIasComponent;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_RadiusProtocol) as IIasComponent;
end;

class function CoCClient.Create: IIasClient;
begin
  Result := CreateComObject(CLASS_CClient) as IIasClient;
end;

class function CoCClient.CreateRemote(const MachineName: string): IIasClient;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CClient) as IIasClient;
end;

end.
