unit IClientSideRenderingLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:53:16 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\win32spl.dll (1)
// LIBID: {5BAB8658-A4A5-4EBB-9C57-C21A43925BBA}
// LCID: 0
// Helpfile: 
// HelpString: csrspl 1.0 Client Side Rendering Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  IClientSideRenderingLibMajorVersion = 1;
  IClientSideRenderingLibMinorVersion = 0;

  LIBID_IClientSideRenderingLib: TGUID = '{5BAB8658-A4A5-4EBB-9C57-C21A43925BBA}';

type

// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  CSRPrinterInfo2 = packed record
    pServerName: WideString;
    pPrinterName: WideString;
    pShareName: WideString;
    pPortName: WideString;
    pDriverName: WideString;
    pComment: WideString;
    pLocation: WideString;
    pDevMode: PSafeArray;
    pSepFile: WideString;
    pPrintProcessor: WideString;
    pDatatype: WideString;
    pParameters: WideString;
    pSecurityDescriptor: PSafeArray;
    Attributes: LongWord;
    Priority: LongWord;
    DefaultPriority: LongWord;
    StartTime: LongWord;
    UntilTime: LongWord;
    Status: LongWord;
    cJobs: LongWord;
    AveragePPM: LongWord;
  end;

  CSRPrinterInfo7 = packed record
    pszObjectGUID: WideString;
    dwAction: LongWord;
    dwReserved: LongWord;
  end;

  CSRPrinterExtra = packed record
    DriverState: LongWord;
    RemoteChangeId: LongWord;
    MergedAttributes: LongWord;
    CSRAttributes: LongWord;
    pFriendlyName: WideString;
    pRemotePrintProc: WideString;
    pLocalDriver: WideString;
  end;

  CSRPrinterCache = packed record
    PrinterInfo2: CSRPrinterInfo2;
    PrinterInfo7: CSRPrinterInfo7;
    PrinterExtra: CSRPrinterExtra;
  end;


implementation

uses ComObj;

end.
