unit IndeoTypeLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:28:00 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\ir50_32.dll (1)
// LIBID: {665A4446-D905-11D0-A30E-444553540000}
// LCID: 0
// Helpfile: 
// HelpString: Indeo video custom control type library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  IndeoTypeLibMajorVersion = 1;
  IndeoTypeLibMinorVersion = 0;

  LIBID_IndeoTypeLib: TGUID = '{665A4446-D905-11D0-A30E-444553540000}';

  IID_IIndeoDecodeOA: TGUID = '{665A4447-D905-11D0-A30E-444553540000}';
  CLASS_IndeoDecode: TGUID = '{665A4448-D905-11D0-A30E-444553540000}';
  IID_IIndeoEncodeOA: TGUID = '{665A4449-D905-11D0-A30E-444553540000}';
  CLASS_IndeoEncode: TGUID = '{665A444A-D905-11D0-A30E-444553540000}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum __MIDL_IIndeoDecodeOA_0003
type
  __MIDL_IIndeoDecodeOA_0003 = TOleEnum;
const
  INDEO_FALSE = $00000000;
  INDEO_TRUE = $00000001;

// Constants for enum __MIDL_IIndeoDecodeOA_0002
type
  __MIDL_IIndeoDecodeOA_0002 = TOleEnum;
const
  SCALABILITY_DONT_DROP_QUALITY = $00000000;
  SCALABILITY_ON = $00000001;
  SCALABILITY_DONT_DROP_FRAMES = $00000002;
  SCALABILITY_OFF = $00000003;

// Constants for enum __MIDL_IIndeoDecodeOA_0001
type
  __MIDL_IIndeoDecodeOA_0001 = TOleEnum;
const
  DITHER_OFF = $00000000;
  DITHER_LOW = $00000001;
  DITHER_MEDIUM = $00000002;
  DITHER_HIGH = $00000003;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IIndeoDecodeOA = interface;
  IIndeoDecodeOADisp = dispinterface;
  IIndeoEncodeOA = interface;
  IIndeoEncodeOADisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  IndeoDecode = IIndeoDecodeOA;
  IndeoEncode = IIndeoEncodeOA;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//

  INDEO_BOOL = __MIDL_IIndeoDecodeOA_0003; 
  SCALABILITY_SELECTIONS = __MIDL_IIndeoDecodeOA_0002; 
  DITHER_SELECTIONS = __MIDL_IIndeoDecodeOA_0001; 

// *********************************************************************//
// Interface: IIndeoDecodeOA
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {665A4447-D905-11D0-A30E-444553540000}
// *********************************************************************//
  IIndeoDecodeOA = interface(IDispatch)
    ['{665A4447-D905-11D0-A30E-444553540000}']
    procedure SetSequenceData; safecall;
    procedure ResetSequenceData; safecall;
    procedure SetFrameData; safecall;
    procedure ResetFrameData; safecall;
    procedure AssociateWith(const mifg: IUnknown); safecall;
    function Get_Key: Integer; safecall;
    procedure Set_Key(lKey: Integer); safecall;
    function Get_EnabledKey: INDEO_BOOL; safecall;
    procedure Set_EnabledKey(fEnabledKey: INDEO_BOOL); safecall;
    function Get_Scalability: SCALABILITY_SELECTIONS; safecall;
    procedure Set_Scalability(eScalability: SCALABILITY_SELECTIONS); safecall;
    function Get_FillTransparentPixels: INDEO_BOOL; safecall;
    procedure Set_FillTransparentPixels(fFillTransparentPixels: INDEO_BOOL); safecall;
    function Get_AltLine: INDEO_BOOL; safecall;
    procedure Set_AltLine(fAltLine: INDEO_BOOL); safecall;
    function Get_TimeLimit: Integer; safecall;
    procedure Set_TimeLimit(lTimeLimit: Integer); safecall;
    function Get_DecodeRectX: Integer; safecall;
    procedure Set_DecodeRectX(lX: Integer); safecall;
    function Get_DecodeRectY: Integer; safecall;
    procedure Set_DecodeRectY(lY: Integer); safecall;
    function Get_DecodeRectWidth: Integer; safecall;
    procedure Set_DecodeRectWidth(lWidth: Integer); safecall;
    function Get_DecodeRectHeight: Integer; safecall;
    procedure Set_DecodeRectHeight(lHeight: Integer); safecall;
    function Get_ViewRectX: Integer; safecall;
    procedure Set_ViewRectX(lX: Integer); safecall;
    function Get_ViewRectY: Integer; safecall;
    procedure Set_ViewRectY(lY: Integer); safecall;
    function Get_ViewRectWidth: Integer; safecall;
    procedure Set_ViewRectWidth(lWidth: Integer); safecall;
    function Get_ViewRectHeight: Integer; safecall;
    procedure Set_ViewRectHeight(lHeight: Integer); safecall;
    function Get_Brightness: Integer; safecall;
    procedure Set_Brightness(lBrightness: Integer); safecall;
    function Get_Saturation: Integer; safecall;
    procedure Set_Saturation(lSaturation: Integer); safecall;
    function Get_Contrast: Integer; safecall;
    procedure Set_Contrast(lContrast: Integer); safecall;
    function Get_TransparencyFillColor: Integer; safecall;
    procedure Set_TransparencyFillColor(dwFillColor: Integer); safecall;
    function Get_FirstPalIndex: Integer; safecall;
    procedure Set_FirstPalIndex(dwFirstPalIndex: Integer); safecall;
    function Get_LastPalIndex: Integer; safecall;
    procedure Set_LastPalIndex(dwLastPalIndex: Integer); safecall;
    function Get_Palette: Integer; safecall;
    procedure Set_Palette(prgbPalette: Integer); safecall;
    function Get_Dither: DITHER_SELECTIONS; safecall;
    procedure Set_Dither(eDither: DITHER_SELECTIONS); safecall;
    function Get_ViewRectOrigin: INDEO_BOOL; safecall;
    procedure Set_ViewRectOrigin(fViewRectOrigin: INDEO_BOOL); safecall;
    function Get_InputTransparencyBitmask: Integer; safecall;
    procedure Set_InputTransparencyBitmask(pbmInputTransparencyBitmask: Integer); safecall;
    property Key: Integer read Get_Key write Set_Key;
    property EnabledKey: INDEO_BOOL read Get_EnabledKey write Set_EnabledKey;
    property Scalability: SCALABILITY_SELECTIONS read Get_Scalability write Set_Scalability;
    property FillTransparentPixels: INDEO_BOOL read Get_FillTransparentPixels write Set_FillTransparentPixels;
    property AltLine: INDEO_BOOL read Get_AltLine write Set_AltLine;
    property TimeLimit: Integer read Get_TimeLimit write Set_TimeLimit;
    property DecodeRectX: Integer read Get_DecodeRectX write Set_DecodeRectX;
    property DecodeRectY: Integer read Get_DecodeRectY write Set_DecodeRectY;
    property DecodeRectWidth: Integer read Get_DecodeRectWidth write Set_DecodeRectWidth;
    property DecodeRectHeight: Integer read Get_DecodeRectHeight write Set_DecodeRectHeight;
    property ViewRectX: Integer read Get_ViewRectX write Set_ViewRectX;
    property ViewRectY: Integer read Get_ViewRectY write Set_ViewRectY;
    property ViewRectWidth: Integer read Get_ViewRectWidth write Set_ViewRectWidth;
    property ViewRectHeight: Integer read Get_ViewRectHeight write Set_ViewRectHeight;
    property Brightness: Integer read Get_Brightness write Set_Brightness;
    property Saturation: Integer read Get_Saturation write Set_Saturation;
    property Contrast: Integer read Get_Contrast write Set_Contrast;
    property TransparencyFillColor: Integer read Get_TransparencyFillColor write Set_TransparencyFillColor;
    property FirstPalIndex: Integer read Get_FirstPalIndex write Set_FirstPalIndex;
    property LastPalIndex: Integer read Get_LastPalIndex write Set_LastPalIndex;
    property Palette: Integer read Get_Palette write Set_Palette;
    property Dither: DITHER_SELECTIONS read Get_Dither write Set_Dither;
    property ViewRectOrigin: INDEO_BOOL read Get_ViewRectOrigin write Set_ViewRectOrigin;
    property InputTransparencyBitmask: Integer read Get_InputTransparencyBitmask write Set_InputTransparencyBitmask;
  end;

// *********************************************************************//
// DispIntf:  IIndeoDecodeOADisp
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {665A4447-D905-11D0-A30E-444553540000}
// *********************************************************************//
  IIndeoDecodeOADisp = dispinterface
    ['{665A4447-D905-11D0-A30E-444553540000}']
    procedure SetSequenceData; dispid 1610743808;
    procedure ResetSequenceData; dispid 1610743809;
    procedure SetFrameData; dispid 1610743810;
    procedure ResetFrameData; dispid 1610743811;
    procedure AssociateWith(const mifg: IUnknown); dispid 1610743812;
    property Key: Integer dispid 1610743813;
    property EnabledKey: INDEO_BOOL dispid 1610743815;
    property Scalability: SCALABILITY_SELECTIONS dispid 1610743817;
    property FillTransparentPixels: INDEO_BOOL dispid 1610743819;
    property AltLine: INDEO_BOOL dispid 1610743821;
    property TimeLimit: Integer dispid 1610743823;
    property DecodeRectX: Integer dispid 1610743825;
    property DecodeRectY: Integer dispid 1610743827;
    property DecodeRectWidth: Integer dispid 1610743829;
    property DecodeRectHeight: Integer dispid 1610743831;
    property ViewRectX: Integer dispid 1610743833;
    property ViewRectY: Integer dispid 1610743835;
    property ViewRectWidth: Integer dispid 1610743837;
    property ViewRectHeight: Integer dispid 1610743839;
    property Brightness: Integer dispid 1610743841;
    property Saturation: Integer dispid 1610743843;
    property Contrast: Integer dispid 1610743845;
    property TransparencyFillColor: Integer dispid 1610743847;
    property FirstPalIndex: Integer dispid 1610743849;
    property LastPalIndex: Integer dispid 1610743851;
    property Palette: Integer dispid 1610743853;
    property Dither: DITHER_SELECTIONS dispid 1610743855;
    property ViewRectOrigin: INDEO_BOOL dispid 1610743857;
    property InputTransparencyBitmask: Integer dispid 1610743859;
  end;

// *********************************************************************//
// Interface: IIndeoEncodeOA
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {665A4449-D905-11D0-A30E-444553540000}
// *********************************************************************//
  IIndeoEncodeOA = interface(IDispatch)
    ['{665A4449-D905-11D0-A30E-444553540000}']
    procedure SetCompressionData; safecall;
    procedure ResetCompressionData; safecall;
    procedure SetSequenceData; safecall;
    procedure ResetSequenceData; safecall;
    procedure AssociateWith(const mifg: IUnknown); safecall;
    function Get_KeyFrameInterval: Integer; safecall;
    procedure Set_KeyFrameInterval(lKeyFrameInterval: Integer); safecall;
    function Get_DataRate: Integer; safecall;
    procedure Set_DataRate(lDataRate: Integer); safecall;
    function Get_Quality: Integer; safecall;
    procedure Set_Quality(lQuality: Integer); safecall;
    function Get_Key: Integer; safecall;
    procedure Set_Key(lKey: Integer); safecall;
    function Get_MinViewportWidth: Integer; safecall;
    procedure Set_MinViewportWidth(lWidth: Integer); safecall;
    function Get_MinViewportHeight: Integer; safecall;
    procedure Set_MinViewportHeight(lHeight: Integer); safecall;
    function Get_TransparencyRangeBlueLow: Integer; safecall;
    procedure Set_TransparencyRangeBlueLow(lBlueLow: Integer); safecall;
    function Get_TransparencyRangeBlueHigh: Integer; safecall;
    procedure Set_TransparencyRangeBlueHigh(lBlueHigh: Integer); safecall;
    function Get_TransparencyRangeGreenLow: Integer; safecall;
    procedure Set_TransparencyRangeGreenLow(lGreenLow: Integer); safecall;
    function Get_TransparencyRangeGreenHigh: Integer; safecall;
    procedure Set_TransparencyRangeGreenHigh(lGreenHigh: Integer); safecall;
    function Get_TransparencyRangeRedLow: Integer; safecall;
    procedure Set_TransparencyRangeRedLow(lRedLow: Integer); safecall;
    function Get_TransparencyRangeRedHigh: Integer; safecall;
    procedure Set_TransparencyRangeRedHigh(lRedHigh: Integer); safecall;
    function Get_TransparencyMethod: Integer; safecall;
    procedure Set_TransparencyMethod(lTransparencyMethod: Integer); safecall;
    function Get_EnabledKey: INDEO_BOOL; safecall;
    procedure Set_EnabledKey(fEnabledKey: INDEO_BOOL); safecall;
    function Get_Scalability: INDEO_BOOL; safecall;
    procedure Set_Scalability(fScalability: INDEO_BOOL); safecall;
    function Get_QuickCompress: INDEO_BOOL; safecall;
    procedure Set_QuickCompress(QuickCompress: INDEO_BOOL); safecall;
    property KeyFrameInterval: Integer read Get_KeyFrameInterval write Set_KeyFrameInterval;
    property DataRate: Integer read Get_DataRate write Set_DataRate;
    property Quality: Integer read Get_Quality write Set_Quality;
    property Key: Integer read Get_Key write Set_Key;
    property MinViewportWidth: Integer read Get_MinViewportWidth write Set_MinViewportWidth;
    property MinViewportHeight: Integer read Get_MinViewportHeight write Set_MinViewportHeight;
    property TransparencyRangeBlueLow: Integer read Get_TransparencyRangeBlueLow write Set_TransparencyRangeBlueLow;
    property TransparencyRangeBlueHigh: Integer read Get_TransparencyRangeBlueHigh write Set_TransparencyRangeBlueHigh;
    property TransparencyRangeGreenLow: Integer read Get_TransparencyRangeGreenLow write Set_TransparencyRangeGreenLow;
    property TransparencyRangeGreenHigh: Integer read Get_TransparencyRangeGreenHigh write Set_TransparencyRangeGreenHigh;
    property TransparencyRangeRedLow: Integer read Get_TransparencyRangeRedLow write Set_TransparencyRangeRedLow;
    property TransparencyRangeRedHigh: Integer read Get_TransparencyRangeRedHigh write Set_TransparencyRangeRedHigh;
    property TransparencyMethod: Integer read Get_TransparencyMethod write Set_TransparencyMethod;
    property EnabledKey: INDEO_BOOL read Get_EnabledKey write Set_EnabledKey;
    property Scalability: INDEO_BOOL read Get_Scalability write Set_Scalability;
    property QuickCompress: INDEO_BOOL read Get_QuickCompress write Set_QuickCompress;
  end;

// *********************************************************************//
// DispIntf:  IIndeoEncodeOADisp
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {665A4449-D905-11D0-A30E-444553540000}
// *********************************************************************//
  IIndeoEncodeOADisp = dispinterface
    ['{665A4449-D905-11D0-A30E-444553540000}']
    procedure SetCompressionData; dispid 1610743808;
    procedure ResetCompressionData; dispid 1610743809;
    procedure SetSequenceData; dispid 1610743810;
    procedure ResetSequenceData; dispid 1610743811;
    procedure AssociateWith(const mifg: IUnknown); dispid 1610743812;
    property KeyFrameInterval: Integer dispid 1610743813;
    property DataRate: Integer dispid 1610743815;
    property Quality: Integer dispid 1610743817;
    property Key: Integer dispid 1610743819;
    property MinViewportWidth: Integer dispid 1610743821;
    property MinViewportHeight: Integer dispid 1610743823;
    property TransparencyRangeBlueLow: Integer dispid 1610743825;
    property TransparencyRangeBlueHigh: Integer dispid 1610743827;
    property TransparencyRangeGreenLow: Integer dispid 1610743829;
    property TransparencyRangeGreenHigh: Integer dispid 1610743831;
    property TransparencyRangeRedLow: Integer dispid 1610743833;
    property TransparencyRangeRedHigh: Integer dispid 1610743835;
    property TransparencyMethod: Integer dispid 1610743837;
    property EnabledKey: INDEO_BOOL dispid 1610743839;
    property Scalability: INDEO_BOOL dispid 1610743841;
    property QuickCompress: INDEO_BOOL dispid 1610743843;
  end;

// *********************************************************************//
// The Class CoIndeoDecode provides a Create and CreateRemote method to          
// create instances of the default interface IIndeoDecodeOA exposed by              
// the CoClass IndeoDecode. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoIndeoDecode = class
    class function Create: IIndeoDecodeOA;
    class function CreateRemote(const MachineName: string): IIndeoDecodeOA;
  end;

// *********************************************************************//
// The Class CoIndeoEncode provides a Create and CreateRemote method to          
// create instances of the default interface IIndeoEncodeOA exposed by              
// the CoClass IndeoEncode. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoIndeoEncode = class
    class function Create: IIndeoEncodeOA;
    class function CreateRemote(const MachineName: string): IIndeoEncodeOA;
  end;

implementation

uses ComObj;

class function CoIndeoDecode.Create: IIndeoDecodeOA;
begin
  Result := CreateComObject(CLASS_IndeoDecode) as IIndeoDecodeOA;
end;

class function CoIndeoDecode.CreateRemote(const MachineName: string): IIndeoDecodeOA;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_IndeoDecode) as IIndeoDecodeOA;
end;

class function CoIndeoEncode.Create: IIndeoEncodeOA;
begin
  Result := CreateComObject(CLASS_IndeoEncode) as IIndeoEncodeOA;
end;

class function CoIndeoEncode.CreateRemote(const MachineName: string): IIndeoEncodeOA;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_IndeoEncode) as IIndeoEncodeOA;
end;

end.
