unit MSDAOSP;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 3:53:07 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: simpdata.tlb (1)
// LIBID: {E0E270C2-C0BE-11D0-8FE4-00A0C90A6341}
// LCID: 409
// Helpfile: 
// HelpString: Microsoft OLE DB Simple Provider 1.5 Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// Errors:
//   Hint: Parameter 'Var' of OLEDBSimpleProvider.setVariant changed to 'Var_'
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  MSDAOSPMajorVersion = 1;
  MSDAOSPMinorVersion = 5;

  LIBID_MSDAOSP: TGUID = '{E0E270C2-C0BE-11D0-8FE4-00A0C90A6341}';

  IID_OLEDBSimpleProviderListener: TGUID = '{E0E270C1-C0BE-11D0-8FE4-00A0C90A6341}';
  IID_OLEDBSimpleProvider: TGUID = '{E0E270C0-C0BE-11D0-8FE4-00A0C90A6341}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum OSPFORMAT
type
  OSPFORMAT = TOleEnum;
const
  OSPFORMAT_RAW = $00000000;
  OSPFORMAT_DEFAULT = $00000000;
  OSPFORMAT_FORMATTED = $00000001;
  OSPFORMAT_HTML = $00000002;

// Constants for enum OSPRW
type
  OSPRW = TOleEnum;
const
  OSPRW_DEFAULT = $00000001;
  OSPRW_READONLY = $00000000;
  OSPRW_READWRITE = $00000001;
  OSPRW_MIXED = $00000002;

// Constants for enum OSPFIND
type
  OSPFIND = TOleEnum;
const
  OSPFIND_DEFAULT = $00000000;
  OSPFIND_UP = $00000001;
  OSPFIND_CASESENSITIVE = $00000002;
  OSPFIND_UPCASESENSITIVE = $00000003;

// Constants for enum OSPCOMP
type
  OSPCOMP = TOleEnum;
const
  OSPCOMP_EQ = $00000001;
  OSPCOMP_DEFAULT = $00000001;
  OSPCOMP_LT = $00000002;
  OSPCOMP_LE = $00000003;
  OSPCOMP_GE = $00000004;
  OSPCOMP_GT = $00000005;
  OSPCOMP_NE = $00000006;

// Constants for enum OSPXFER
type
  OSPXFER = TOleEnum;
const
  OSPXFER_COMPLETE = $00000000;
  OSPXFER_ABORT = $00000001;
  OSPXFER_ERROR = $00000002;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  OLEDBSimpleProviderListener = interface;
  OLEDBSimpleProvider = interface;

// *********************************************************************//
// Interface: OLEDBSimpleProviderListener
// Flags:     (256) OleAutomation
// GUID:      {E0E270C1-C0BE-11D0-8FE4-00A0C90A6341}
// *********************************************************************//
  OLEDBSimpleProviderListener = interface(IUnknown)
    ['{E0E270C1-C0BE-11D0-8FE4-00A0C90A6341}']
    function aboutToChangeCell(iRow: Integer; iColumn: Integer): HResult; stdcall;
    function cellChanged(iRow: Integer; iColumn: Integer): HResult; stdcall;
    function aboutToDeleteRows(iRow: Integer; cRows: Integer): HResult; stdcall;
    function deletedRows(iRow: Integer; cRows: Integer): HResult; stdcall;
    function aboutToInsertRows(iRow: Integer; cRows: Integer): HResult; stdcall;
    function insertedRows(iRow: Integer; cRows: Integer): HResult; stdcall;
    function rowsAvailable(iRow: Integer; cRows: Integer): HResult; stdcall;
    function transferComplete(xfer: OSPXFER): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: OLEDBSimpleProvider
// Flags:     (256) OleAutomation
// GUID:      {E0E270C0-C0BE-11D0-8FE4-00A0C90A6341}
// *********************************************************************//
  OLEDBSimpleProvider = interface(IUnknown)
    ['{E0E270C0-C0BE-11D0-8FE4-00A0C90A6341}']
    function getRowCount(out pcRows: Integer): HResult; stdcall;
    function getColumnCount(out pcColumns: Integer): HResult; stdcall;
    function getRWStatus(iRow: Integer; iColumn: Integer; out prwStatus: OSPRW): HResult; stdcall;
    function getVariant(iRow: Integer; iColumn: Integer; format: OSPFORMAT; out pVar: OleVariant): HResult; stdcall;
    function setVariant(iRow: Integer; iColumn: Integer; format: OSPFORMAT; Var_: OleVariant): HResult; stdcall;
    function getLocale(out pbstrLocale: WideString): HResult; stdcall;
    function deleteRows(iRow: Integer; cRows: Integer; out pcRowsDeleted: Integer): HResult; stdcall;
    function insertRows(iRow: Integer; cRows: Integer; out pcRowsInserted: Integer): HResult; stdcall;
    function find(iRowStart: Integer; iColumn: Integer; val: OleVariant; findFlags: OSPFIND; 
                  compType: OSPCOMP; out piRowFound: Integer): HResult; stdcall;
    function addOLEDBSimpleProviderListener(const pospIListener: OLEDBSimpleProviderListener): HResult; stdcall;
    function removeOLEDBSimpleProviderListener(const pospIListener: OLEDBSimpleProviderListener): HResult; stdcall;
    function isAsync(out pbAsynch: Integer): HResult; stdcall;
    function getEstimatedRows(out piRows: Integer): HResult; stdcall;
    function stopTransfer: HResult; stdcall;
  end;

implementation

uses ComObj;

end.
