unit TVRATINGSLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:49:41 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\tvratings.dll (1)
// LIBID: {C5C5C500-3ABC-11D6-B25B-00C04FA0C026}
// LCID: 0
// Helpfile: 
// HelpString: TvRatings 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  TVRATINGSLibMajorVersion = 1;
  TVRATINGSLibMinorVersion = 0;

  LIBID_TVRATINGSLib: TGUID = '{C5C5C500-3ABC-11D6-B25B-00C04FA0C026}';

  IID_IXDSToRat: TGUID = '{C5C5C5B0-3ABC-11D6-B25B-00C04FA0C026}';
  CLASS_XDSToRat: TGUID = '{C5C5C5F0-3ABC-11D6-B25B-00C04FA0C026}';
  IID_IEvalRat: TGUID = '{C5C5C5B1-3ABC-11D6-B25B-00C04FA0C026}';
  CLASS_EvalRat: TGUID = '{C5C5C5F1-3ABC-11D6-B25B-00C04FA0C026}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum EnTvRat_System
type
  EnTvRat_System = TOleEnum;
const
  MPAA = $00000000;
  US_TV = $00000001;
  Canadian_English = $00000002;
  Canadian_French = $00000003;
  Reserved4 = $00000004;
  System5 = $00000005;
  System6 = $00000006;
  Reserved7 = $00000007;
  TvRat_kSystems = $00000008;
  TvRat_SystemDontKnow = $000000FF;

// Constants for enum EnTvRat_GenericLevel
type
  EnTvRat_GenericLevel = TOleEnum;
const
  TvRat_0 = $00000000;
  TvRat_1 = $00000001;
  TvRat_2 = $00000002;
  TvRat_3 = $00000003;
  TvRat_4 = $00000004;
  TvRat_5 = $00000005;
  TvRat_6 = $00000006;
  TvRat_7 = $00000007;
  TvRat_kLevels = $00000008;
  TvRat_LevelDontKnow = $000000FF;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IXDSToRat = interface;
  IXDSToRatDisp = dispinterface;
  IEvalRat = interface;
  IEvalRatDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  XDSToRat = IXDSToRat;
  EvalRat = IEvalRat;


// *********************************************************************//
// Interface: IXDSToRat
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C5C5C5B0-3ABC-11D6-B25B-00C04FA0C026}
// *********************************************************************//
  IXDSToRat = interface(IDispatch)
    ['{C5C5C5B0-3ABC-11D6-B25B-00C04FA0C026}']
    procedure Init; safecall;
    procedure ParseXDSBytePair(byte1: Byte; byte2: Byte; out pEnSystem: EnTvRat_System; 
                               out pEnLevel: EnTvRat_GenericLevel; out plBfEnAttributes: Integer); safecall;
  end;

// *********************************************************************//
// DispIntf:  IXDSToRatDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C5C5C5B0-3ABC-11D6-B25B-00C04FA0C026}
// *********************************************************************//
  IXDSToRatDisp = dispinterface
    ['{C5C5C5B0-3ABC-11D6-B25B-00C04FA0C026}']
    procedure Init; dispid 1;
    procedure ParseXDSBytePair(byte1: Byte; byte2: Byte; out pEnSystem: EnTvRat_System; 
                               out pEnLevel: EnTvRat_GenericLevel; out plBfEnAttributes: Integer); dispid 2;
  end;

// *********************************************************************//
// Interface: IEvalRat
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C5C5C5B1-3ABC-11D6-B25B-00C04FA0C026}
// *********************************************************************//
  IEvalRat = interface(IDispatch)
    ['{C5C5C5B1-3ABC-11D6-B25B-00C04FA0C026}']
    function Get_BlockedRatingAttributes(enSystem: EnTvRat_System; enLevel: EnTvRat_GenericLevel): Integer; safecall;
    procedure Set_BlockedRatingAttributes(enSystem: EnTvRat_System; enLevel: EnTvRat_GenericLevel; 
                                          plbfAttrs: Integer); safecall;
    function Get_BlockUnRated: Integer; safecall;
    procedure Set_BlockUnRated(pfBlockUnRatedShows: Integer); safecall;
    procedure MostRestrictiveRating(enSystem1: EnTvRat_System; enEnLevel1: EnTvRat_GenericLevel; 
                                    lbfEnAttr1: Integer; enSystem2: EnTvRat_System; 
                                    enEnLevel2: EnTvRat_GenericLevel; lbfEnAttr2: Integer; 
                                    out pEnSystem: EnTvRat_System; 
                                    out penEnLevel: EnTvRat_GenericLevel; out plbfEnAttr: Integer); safecall;
    procedure TestRating(enShowSystem: EnTvRat_System; enShowLevel: EnTvRat_GenericLevel; 
                         lbfEnShowAttributes: Integer); safecall;
    property BlockedRatingAttributes[enSystem: EnTvRat_System; enLevel: EnTvRat_GenericLevel]: Integer read Get_BlockedRatingAttributes write Set_BlockedRatingAttributes;
    property BlockUnRated: Integer read Get_BlockUnRated write Set_BlockUnRated;
  end;

// *********************************************************************//
// DispIntf:  IEvalRatDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C5C5C5B1-3ABC-11D6-B25B-00C04FA0C026}
// *********************************************************************//
  IEvalRatDisp = dispinterface
    ['{C5C5C5B1-3ABC-11D6-B25B-00C04FA0C026}']
    property BlockedRatingAttributes[enSystem: EnTvRat_System; enLevel: EnTvRat_GenericLevel]: Integer dispid 1;
    property BlockUnRated: Integer dispid 2;
    procedure MostRestrictiveRating(enSystem1: EnTvRat_System; enEnLevel1: EnTvRat_GenericLevel; 
                                    lbfEnAttr1: Integer; enSystem2: EnTvRat_System; 
                                    enEnLevel2: EnTvRat_GenericLevel; lbfEnAttr2: Integer; 
                                    out pEnSystem: EnTvRat_System; 
                                    out penEnLevel: EnTvRat_GenericLevel; out plbfEnAttr: Integer); dispid 3;
    procedure TestRating(enShowSystem: EnTvRat_System; enShowLevel: EnTvRat_GenericLevel; 
                         lbfEnShowAttributes: Integer); dispid 4;
  end;

// *********************************************************************//
// The Class CoXDSToRat provides a Create and CreateRemote method to          
// create instances of the default interface IXDSToRat exposed by              
// the CoClass XDSToRat. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoXDSToRat = class
    class function Create: IXDSToRat;
    class function CreateRemote(const MachineName: string): IXDSToRat;
  end;

// *********************************************************************//
// The Class CoEvalRat provides a Create and CreateRemote method to          
// create instances of the default interface IEvalRat exposed by              
// the CoClass EvalRat. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoEvalRat = class
    class function Create: IEvalRat;
    class function CreateRemote(const MachineName: string): IEvalRat;
  end;

implementation

uses ComObj;

class function CoXDSToRat.Create: IXDSToRat;
begin
  Result := CreateComObject(CLASS_XDSToRat) as IXDSToRat;
end;

class function CoXDSToRat.CreateRemote(const MachineName: string): IXDSToRat;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_XDSToRat) as IXDSToRat;
end;

class function CoEvalRat.Create: IEvalRat;
begin
  Result := CreateComObject(CLASS_EvalRat) as IEvalRat;
end;

class function CoEvalRat.CreateRemote(const MachineName: string): IEvalRat;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_EvalRat) as IEvalRat;
end;

end.
