unit TouchxLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:49:28 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\TouchX.dll (1)
// LIBID: {CED735EE-2A19-4EB5-AA0C-8BFA8F775144}
// LCID: 0
// Helpfile: 
// HelpString: Touchx 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  TouchxLibMajorVersion = 1;
  TouchxLibMinorVersion = 0;

  LIBID_TouchxLib: TGUID = '{CED735EE-2A19-4EB5-AA0C-8BFA8F775144}';

  IID_ITouchBand: TGUID = '{9BDD23C3-340B-4505-8E92-3EBAA1E9DA43}';
  CLASS_TouchBand: TGUID = '{91ADC906-6722-4B05-A12B-471ADDCCE132}';
  CLASS_TouchUIElementsRing: TGUID = '{63F5EE0F-7DBE-45D4-B8C7-C6194423D7BA}';
  CLASS_TouchUIElementsMouse: TGUID = '{4C085D4D-66D6-4999-A149-E3E32ADA9B10}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ITouchBand = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  TouchBand = ITouchBand;
  TouchUIElementsRing = IUnknown;
  TouchUIElementsMouse = IUnknown;


// *********************************************************************//
// Interface: ITouchBand
// Flags:     (0)
// GUID:      {9BDD23C3-340B-4505-8E92-3EBAA1E9DA43}
// *********************************************************************//
  ITouchBand = interface(IUnknown)
    ['{9BDD23C3-340B-4505-8E92-3EBAA1E9DA43}']
  end;

// *********************************************************************//
// The Class CoTouchBand provides a Create and CreateRemote method to          
// create instances of the default interface ITouchBand exposed by              
// the CoClass TouchBand. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoTouchBand = class
    class function Create: ITouchBand;
    class function CreateRemote(const MachineName: string): ITouchBand;
  end;

// *********************************************************************//
// The Class CoTouchUIElementsRing provides a Create and CreateRemote method to          
// create instances of the default interface IUnknown exposed by              
// the CoClass TouchUIElementsRing. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoTouchUIElementsRing = class
    class function Create: IUnknown;
    class function CreateRemote(const MachineName: string): IUnknown;
  end;

// *********************************************************************//
// The Class CoTouchUIElementsMouse provides a Create and CreateRemote method to          
// create instances of the default interface IUnknown exposed by              
// the CoClass TouchUIElementsMouse. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoTouchUIElementsMouse = class
    class function Create: IUnknown;
    class function CreateRemote(const MachineName: string): IUnknown;
  end;

implementation

uses ComObj;

class function CoTouchBand.Create: ITouchBand;
begin
  Result := CreateComObject(CLASS_TouchBand) as ITouchBand;
end;

class function CoTouchBand.CreateRemote(const MachineName: string): ITouchBand;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_TouchBand) as ITouchBand;
end;

class function CoTouchUIElementsRing.Create: IUnknown;
begin
  Result := CreateComObject(CLASS_TouchUIElementsRing) as IUnknown;
end;

class function CoTouchUIElementsRing.CreateRemote(const MachineName: string): IUnknown;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_TouchUIElementsRing) as IUnknown;
end;

class function CoTouchUIElementsMouse.Create: IUnknown;
begin
  Result := CreateComObject(CLASS_TouchUIElementsMouse) as IUnknown;
end;

class function CoTouchUIElementsMouse.CreateRemote(const MachineName: string): IUnknown;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_TouchUIElementsMouse) as IUnknown;
end;

end.
