unit WAVEMSPLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:52:25 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\wavemsp.dll (1)
// LIBID: {4DDB6D35-3BC1-11D2-86F2-006008B0E5D2}
// LCID: 0
// Helpfile: 
// HelpString: Wave MSP 2.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WAVEMSPLibMajorVersion = 2;
  WAVEMSPLibMinorVersion = 0;

  LIBID_WAVEMSPLib: TGUID = '{4DDB6D35-3BC1-11D2-86F2-006008B0E5D2}';

  IID_ITMSPAddress: TGUID = '{EE3BD600-3868-11D2-A045-00C04FB6809F}';
  CLASS_WaveMSP: TGUID = '{4DDB6D36-3BC1-11D2-86F2-006008B0E5D2}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ITMSPAddress = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  WaveMSP = ITMSPAddress;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PInteger1 = ^Integer; {*}
  PByte1 = ^Byte; {*}


// *********************************************************************//
// Interface: ITMSPAddress
// Flags:     (0)
// GUID:      {EE3BD600-3868-11D2-A045-00C04FB6809F}
// *********************************************************************//
  ITMSPAddress = interface(IUnknown)
    ['{EE3BD600-3868-11D2-A045-00C04FB6809F}']
    function Initialize(var hEvent: Integer): HResult; stdcall;
    function Shutdown: HResult; stdcall;
    function CreateMSPCall(var hCall: Integer; dwReserved: LongWord; dwMediaType: LongWord; 
                           const pOuterUnknown: IUnknown; out ppStreamControl: IUnknown): HResult; stdcall;
    function ShutdownMSPCall(const pStreamControl: IUnknown): HResult; stdcall;
    function ReceiveTSPData(const pMSPCall: IUnknown; var pBuffer: Byte; dwSize: LongWord): HResult; stdcall;
    function GetEvent(var pdwSize: LongWord; var pEventBuffer: Byte): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoWaveMSP provides a Create and CreateRemote method to          
// create instances of the default interface ITMSPAddress exposed by              
// the CoClass WaveMSP. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWaveMSP = class
    class function Create: ITMSPAddress;
    class function CreateRemote(const MachineName: string): ITMSPAddress;
  end;

implementation

uses ComObj;

class function CoWaveMSP.Create: ITMSPAddress;
begin
  Result := CreateComObject(CLASS_WaveMSP) as ITMSPAddress;
end;

class function CoWaveMSP.CreateRemote(const MachineName: string): ITMSPAddress;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WaveMSP) as ITMSPAddress;
end;

end.
