unit WIAVIDEOLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:53:13 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\wiavideo.dll (1)
// LIBID: {1320AD9E-A50F-4ED0-B1A4-4E45EC25005E}
// LCID: 0
// Helpfile: 
// HelpString: WiaVideo 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WIAVIDEOLibMajorVersion = 1;
  WIAVIDEOLibMinorVersion = 0;

  LIBID_WIAVIDEOLib: TGUID = '{1320AD9E-A50F-4ED0-B1A4-4E45EC25005E}';

  IID_IWiaVideo: TGUID = '{D52920AA-DB88-41F0-946C-E00DC0A19CFA}';
  CLASS_WiaVideo: TGUID = '{3908C3CD-4478-4536-AF2F-10C25D4EF89A}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum __MIDL___MIDL_itf_wiavideo_xp_0000_0000_0001
type
  __MIDL___MIDL_itf_wiavideo_xp_0000_0000_0001 = TOleEnum;
const
  WIAVIDEO_NO_VIDEO = $00000001;
  WIAVIDEO_CREATING_VIDEO = $00000002;
  WIAVIDEO_VIDEO_CREATED = $00000003;
  WIAVIDEO_VIDEO_PLAYING = $00000004;
  WIAVIDEO_VIDEO_PAUSED = $00000005;
  WIAVIDEO_DESTROYING_VIDEO = $00000006;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IWiaVideo = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  WiaVideo = IWiaVideo;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;

  WIAVIDEO_STATE = __MIDL___MIDL_itf_wiavideo_xp_0000_0000_0001; 

// *********************************************************************//
// Interface: IWiaVideo
// Flags:     (0)
// GUID:      {D52920AA-DB88-41F0-946C-E00DC0A19CFA}
// *********************************************************************//
  IWiaVideo = interface(IUnknown)
    ['{D52920AA-DB88-41F0-946C-E00DC0A19CFA}']
    function Get_PreviewVisible(out pbPreviewVisible: Integer): HResult; stdcall;
    function Set_PreviewVisible(pbPreviewVisible: Integer): HResult; stdcall;
    function Get_ImagesDirectory(out pbstrImageDirectory: WideString): HResult; stdcall;
    function Set_ImagesDirectory(const pbstrImageDirectory: WideString): HResult; stdcall;
    function CreateVideoByWiaDevID(const bstrWiaDeviceID: WideString; 
                                   var hwndParent: _RemotableHandle; bStretchToFitParent: Integer; 
                                   bAutoBeginPlayback: Integer): HResult; stdcall;
    function CreateVideoByDevNum(uiDeviceNumber: SYSUINT; var hwndParent: _RemotableHandle; 
                                 bStretchToFitParent: Integer; bAutoBeginPlayback: Integer): HResult; stdcall;
    function CreateVideoByName(const bstrFriendlyName: WideString; 
                               var hwndParent: _RemotableHandle; bStretchToFitParent: Integer; 
                               bAutoBeginPlayback: Integer): HResult; stdcall;
    function DestroyVideo: HResult; stdcall;
    function Play: HResult; stdcall;
    function Pause: HResult; stdcall;
    function TakePicture(out pbstrNewImageFilename: WideString): HResult; stdcall;
    function ResizeVideo(bStretchToFitParent: Integer): HResult; stdcall;
    function GetCurrentState(out pState: WIAVIDEO_STATE): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoWiaVideo provides a Create and CreateRemote method to          
// create instances of the default interface IWiaVideo exposed by              
// the CoClass WiaVideo. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWiaVideo = class
    class function Create: IWiaVideo;
    class function CreateRemote(const MachineName: string): IWiaVideo;
  end;

implementation

uses ComObj;

class function CoWiaVideo.Create: IWiaVideo;
begin
  Result := CreateComObject(CLASS_WiaVideo) as IWiaVideo;
end;

class function CoWiaVideo.CreateRemote(const MachineName: string): IWiaVideo;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WiaVideo) as IWiaVideo;
end;

end.
