unit WSManAutomation;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:55:37 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\WsmAuto.dll (1)
// LIBID: {F010BE25-296D-4036-980F-5A0669A17577}
// LCID: 0
// Helpfile: 
// HelpString: Microsoft WSMAN Automation V1.0 Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// Errors:
//   Hint: Member 'Invoke' of 'IWSManSession' changed to 'Invoke_'
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WSManAutomationMajorVersion = 1;
  WSManAutomationMinorVersion = 0;

  LIBID_WSManAutomation: TGUID = '{F010BE25-296D-4036-980F-5A0669A17577}';

  IID_IWSMan: TGUID = '{190D8637-5CD3-496D-AD24-69636BB5A3B5}';
  IID_IWSManEx: TGUID = '{2D53BDAA-798E-49E6-A1AA-74D01256F411}';
  IID_IWSManEx2: TGUID = '{1D1B5AE0-42D9-4021-8261-3987619512E9}';
  IID_IWSManEx3: TGUID = '{6400E966-011D-4EAC-8474-049E0848AFAD}';
  IID_IWSManConnectionOptions: TGUID = '{F704E861-9E52-464F-B786-DA5EB2320FDD}';
  IID_IWSManConnectionOptionsEx: TGUID = '{EF43EDF7-2A48-4D93-9526-8BD6AB6D4A6B}';
  IID_IWSManConnectionOptionsEx2: TGUID = '{F500C9EC-24EE-48AB-B38D-FC9A164C658E}';
  IID_IWSManSession: TGUID = '{FC84FC58-1286-40C4-9DA0-C8EF6EC241E0}';
  IID_IWSManEnumerator: TGUID = '{F3457CA9-ABB9-4FA5-B850-90E8CA300E7F}';
  IID_IWSManResourceLocator: TGUID = '{A7A1BA28-DE41-466A-AD0A-C4059EAD7428}';
  IID_IWSManResourceLocatorInternal: TGUID = '{EFFAEAD7-7EC8-4716-B9BE-F2E7E9FB4ADB}';
  CLASS_WSMan: TGUID = '{BCED617B-EC03-420B-8508-977DC7A686BD}';
  IID_IWSManInternal: TGUID = '{04AE2B1D-9954-4D99-94A9-A961E72C3A13}';
  CLASS_WSManInternal: TGUID = '{7DE087A5-5DCB-4DF7-BB12-0924AD8FBD9A}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum _WSManSessionFlags
type
  _WSManSessionFlags = TOleEnum;
const
  WSManFlagUTF8 = $00000001;
  WSManFlagCredUsernamePassword = $00001000;
  WSManFlagSkipCACheck = $00002000;
  WSManFlagSkipCNCheck = $00004000;
  WSManFlagUseNoAuthentication = $00008000;
  WSManFlagUseDigest = $00010000;
  WSManFlagUseNegotiate = $00020000;
  WSManFlagUseBasic = $00040000;
  WSManFlagUseKerberos = $00080000;
  WSManFlagNoEncryption = $00100000;
  WSManFlagUseClientCertificate = $00200000;
  WSManFlagEnableSPNServerPort = $00400000;
  WSManFlagUTF16 = $00800000;
  WSManFlagUseCredSsp = $01000000;
  WSManFlagSkipRevocationCheck = $02000000;
  WSManFlagAllowNegotiateImplicitCredentials = $04000000;
  WSManFlagUseSsl = $08000000;

// Constants for enum _WSManEnumFlags
type
  _WSManEnumFlags = TOleEnum;
const
  WSManFlagNonXmlText = $00000001;
  WSManFlagReturnObject = $00000000;
  WSManFlagReturnEPR = $00000002;
  WSManFlagReturnObjectAndEPR = $00000004;
  WSManFlagHierarchyDeep = $00000000;
  WSManFlagHierarchyShallow = $00000020;
  WSManFlagHierarchyDeepBasePropsOnly = $00000040;
  WSManFlagAssociatedInstance = $00000000;
  WSManFlagAssociationInstance = $00000080;

// Constants for enum _WSManProxyAccessTypeFlags
type
  _WSManProxyAccessTypeFlags = TOleEnum;
const
  WSManProxyIEConfig = $00000001;
  WSManProxyWinHttpConfig = $00000002;
  WSManProxyAutoDetect = $00000004;
  WSManProxyNoProxyServer = $00000008;

// Constants for enum _WSManProxyAuthenticationFlags
type
  _WSManProxyAuthenticationFlags = TOleEnum;
const
  WSManFlagProxyAuthenticationUseNegotiate = $00000001;
  WSManFlagProxyAuthenticationUseBasic = $00000002;
  WSManFlagProxyAuthenticationUseDigest = $00000004;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IWSMan = interface;
  IWSManDisp = dispinterface;
  IWSManEx = interface;
  IWSManExDisp = dispinterface;
  IWSManEx2 = interface;
  IWSManEx2Disp = dispinterface;
  IWSManEx3 = interface;
  IWSManEx3Disp = dispinterface;
  IWSManConnectionOptions = interface;
  IWSManConnectionOptionsDisp = dispinterface;
  IWSManConnectionOptionsEx = interface;
  IWSManConnectionOptionsExDisp = dispinterface;
  IWSManConnectionOptionsEx2 = interface;
  IWSManConnectionOptionsEx2Disp = dispinterface;
  IWSManSession = interface;
  IWSManSessionDisp = dispinterface;
  IWSManEnumerator = interface;
  IWSManEnumeratorDisp = dispinterface;
  IWSManResourceLocator = interface;
  IWSManResourceLocatorDisp = dispinterface;
  IWSManResourceLocatorInternal = interface;
  IWSManInternal = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  WSMan = IWSManEx3;
  WSManInternal = IWSManInternal;


// *********************************************************************//
// Interface: IWSMan
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {190D8637-5CD3-496D-AD24-69636BB5A3B5}
// *********************************************************************//
  IWSMan = interface(IDispatch)
    ['{190D8637-5CD3-496D-AD24-69636BB5A3B5}']
    function CreateSession(const connection: WideString; flags: Integer; 
                           const connectionOptions: IDispatch): IDispatch; safecall;
    function CreateConnectionOptions: IDispatch; safecall;
    function Get_CommandLine: WideString; safecall;
    function Get_Error: WideString; safecall;
    property CommandLine: WideString read Get_CommandLine;
    property Error: WideString read Get_Error;
  end;

// *********************************************************************//
// DispIntf:  IWSManDisp
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {190D8637-5CD3-496D-AD24-69636BB5A3B5}
// *********************************************************************//
  IWSManDisp = dispinterface
    ['{190D8637-5CD3-496D-AD24-69636BB5A3B5}']
    function CreateSession(const connection: WideString; flags: Integer; 
                           const connectionOptions: IDispatch): IDispatch; dispid 1;
    function CreateConnectionOptions: IDispatch; dispid 2;
    property CommandLine: WideString readonly dispid 3;
    property Error: WideString readonly dispid 4;
  end;

// *********************************************************************//
// Interface: IWSManEx
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {2D53BDAA-798E-49E6-A1AA-74D01256F411}
// *********************************************************************//
  IWSManEx = interface(IWSMan)
    ['{2D53BDAA-798E-49E6-A1AA-74D01256F411}']
    function CreateResourceLocator(const strResourceLocator: WideString): IDispatch; safecall;
    function SessionFlagUTF8: Integer; safecall;
    function SessionFlagCredUsernamePassword: Integer; safecall;
    function SessionFlagSkipCACheck: Integer; safecall;
    function SessionFlagSkipCNCheck: Integer; safecall;
    function SessionFlagUseDigest: Integer; safecall;
    function SessionFlagUseNegotiate: Integer; safecall;
    function SessionFlagUseBasic: Integer; safecall;
    function SessionFlagUseKerberos: Integer; safecall;
    function SessionFlagNoEncryption: Integer; safecall;
    function SessionFlagEnableSPNServerPort: Integer; safecall;
    function SessionFlagUseNoAuthentication: Integer; safecall;
    function EnumerationFlagNonXmlText: Integer; safecall;
    function EnumerationFlagReturnEPR: Integer; safecall;
    function EnumerationFlagReturnObjectAndEPR: Integer; safecall;
    function GetErrorMessage(errorNumber: LongWord): WideString; safecall;
    function EnumerationFlagHierarchyDeep: Integer; safecall;
    function EnumerationFlagHierarchyShallow: Integer; safecall;
    function EnumerationFlagHierarchyDeepBasePropsOnly: Integer; safecall;
    function EnumerationFlagReturnObject: Integer; safecall;
  end;

// *********************************************************************//
// DispIntf:  IWSManExDisp
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {2D53BDAA-798E-49E6-A1AA-74D01256F411}
// *********************************************************************//
  IWSManExDisp = dispinterface
    ['{2D53BDAA-798E-49E6-A1AA-74D01256F411}']
    function CreateResourceLocator(const strResourceLocator: WideString): IDispatch; dispid 5;
    function SessionFlagUTF8: Integer; dispid 6;
    function SessionFlagCredUsernamePassword: Integer; dispid 7;
    function SessionFlagSkipCACheck: Integer; dispid 8;
    function SessionFlagSkipCNCheck: Integer; dispid 9;
    function SessionFlagUseDigest: Integer; dispid 10;
    function SessionFlagUseNegotiate: Integer; dispid 11;
    function SessionFlagUseBasic: Integer; dispid 12;
    function SessionFlagUseKerberos: Integer; dispid 13;
    function SessionFlagNoEncryption: Integer; dispid 14;
    function SessionFlagEnableSPNServerPort: Integer; dispid 15;
    function SessionFlagUseNoAuthentication: Integer; dispid 16;
    function EnumerationFlagNonXmlText: Integer; dispid 17;
    function EnumerationFlagReturnEPR: Integer; dispid 18;
    function EnumerationFlagReturnObjectAndEPR: Integer; dispid 19;
    function GetErrorMessage(errorNumber: LongWord): WideString; dispid 20;
    function EnumerationFlagHierarchyDeep: Integer; dispid 21;
    function EnumerationFlagHierarchyShallow: Integer; dispid 22;
    function EnumerationFlagHierarchyDeepBasePropsOnly: Integer; dispid 23;
    function EnumerationFlagReturnObject: Integer; dispid 24;
    function CreateSession(const connection: WideString; flags: Integer; 
                           const connectionOptions: IDispatch): IDispatch; dispid 1;
    function CreateConnectionOptions: IDispatch; dispid 2;
    property CommandLine: WideString readonly dispid 3;
    property Error: WideString readonly dispid 4;
  end;

// *********************************************************************//
// Interface: IWSManEx2
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {1D1B5AE0-42D9-4021-8261-3987619512E9}
// *********************************************************************//
  IWSManEx2 = interface(IWSManEx)
    ['{1D1B5AE0-42D9-4021-8261-3987619512E9}']
    function SessionFlagUseClientCertificate: Integer; safecall;
  end;

// *********************************************************************//
// DispIntf:  IWSManEx2Disp
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {1D1B5AE0-42D9-4021-8261-3987619512E9}
// *********************************************************************//
  IWSManEx2Disp = dispinterface
    ['{1D1B5AE0-42D9-4021-8261-3987619512E9}']
    function SessionFlagUseClientCertificate: Integer; dispid 25;
    function CreateResourceLocator(const strResourceLocator: WideString): IDispatch; dispid 5;
    function SessionFlagUTF8: Integer; dispid 6;
    function SessionFlagCredUsernamePassword: Integer; dispid 7;
    function SessionFlagSkipCACheck: Integer; dispid 8;
    function SessionFlagSkipCNCheck: Integer; dispid 9;
    function SessionFlagUseDigest: Integer; dispid 10;
    function SessionFlagUseNegotiate: Integer; dispid 11;
    function SessionFlagUseBasic: Integer; dispid 12;
    function SessionFlagUseKerberos: Integer; dispid 13;
    function SessionFlagNoEncryption: Integer; dispid 14;
    function SessionFlagEnableSPNServerPort: Integer; dispid 15;
    function SessionFlagUseNoAuthentication: Integer; dispid 16;
    function EnumerationFlagNonXmlText: Integer; dispid 17;
    function EnumerationFlagReturnEPR: Integer; dispid 18;
    function EnumerationFlagReturnObjectAndEPR: Integer; dispid 19;
    function GetErrorMessage(errorNumber: LongWord): WideString; dispid 20;
    function EnumerationFlagHierarchyDeep: Integer; dispid 21;
    function EnumerationFlagHierarchyShallow: Integer; dispid 22;
    function EnumerationFlagHierarchyDeepBasePropsOnly: Integer; dispid 23;
    function EnumerationFlagReturnObject: Integer; dispid 24;
    function CreateSession(const connection: WideString; flags: Integer; 
                           const connectionOptions: IDispatch): IDispatch; dispid 1;
    function CreateConnectionOptions: IDispatch; dispid 2;
    property CommandLine: WideString readonly dispid 3;
    property Error: WideString readonly dispid 4;
  end;

// *********************************************************************//
// Interface: IWSManEx3
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {6400E966-011D-4EAC-8474-049E0848AFAD}
// *********************************************************************//
  IWSManEx3 = interface(IWSManEx2)
    ['{6400E966-011D-4EAC-8474-049E0848AFAD}']
    function SessionFlagUTF16: Integer; safecall;
    function SessionFlagUseCredSsp: Integer; safecall;
    function EnumerationFlagAssociationInstance: Integer; safecall;
    function EnumerationFlagAssociatedInstance: Integer; safecall;
    function SessionFlagSkipRevocationCheck: Integer; safecall;
    function SessionFlagAllowNegotiateImplicitCredentials: Integer; safecall;
    function SessionFlagUseSsl: Integer; safecall;
  end;

// *********************************************************************//
// DispIntf:  IWSManEx3Disp
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {6400E966-011D-4EAC-8474-049E0848AFAD}
// *********************************************************************//
  IWSManEx3Disp = dispinterface
    ['{6400E966-011D-4EAC-8474-049E0848AFAD}']
    function SessionFlagUTF16: Integer; dispid 26;
    function SessionFlagUseCredSsp: Integer; dispid 27;
    function EnumerationFlagAssociationInstance: Integer; dispid 28;
    function EnumerationFlagAssociatedInstance: Integer; dispid 29;
    function SessionFlagSkipRevocationCheck: Integer; dispid 30;
    function SessionFlagAllowNegotiateImplicitCredentials: Integer; dispid 31;
    function SessionFlagUseSsl: Integer; dispid 32;
    function SessionFlagUseClientCertificate: Integer; dispid 25;
    function CreateResourceLocator(const strResourceLocator: WideString): IDispatch; dispid 5;
    function SessionFlagUTF8: Integer; dispid 6;
    function SessionFlagCredUsernamePassword: Integer; dispid 7;
    function SessionFlagSkipCACheck: Integer; dispid 8;
    function SessionFlagSkipCNCheck: Integer; dispid 9;
    function SessionFlagUseDigest: Integer; dispid 10;
    function SessionFlagUseNegotiate: Integer; dispid 11;
    function SessionFlagUseBasic: Integer; dispid 12;
    function SessionFlagUseKerberos: Integer; dispid 13;
    function SessionFlagNoEncryption: Integer; dispid 14;
    function SessionFlagEnableSPNServerPort: Integer; dispid 15;
    function SessionFlagUseNoAuthentication: Integer; dispid 16;
    function EnumerationFlagNonXmlText: Integer; dispid 17;
    function EnumerationFlagReturnEPR: Integer; dispid 18;
    function EnumerationFlagReturnObjectAndEPR: Integer; dispid 19;
    function GetErrorMessage(errorNumber: LongWord): WideString; dispid 20;
    function EnumerationFlagHierarchyDeep: Integer; dispid 21;
    function EnumerationFlagHierarchyShallow: Integer; dispid 22;
    function EnumerationFlagHierarchyDeepBasePropsOnly: Integer; dispid 23;
    function EnumerationFlagReturnObject: Integer; dispid 24;
    function CreateSession(const connection: WideString; flags: Integer; 
                           const connectionOptions: IDispatch): IDispatch; dispid 1;
    function CreateConnectionOptions: IDispatch; dispid 2;
    property CommandLine: WideString readonly dispid 3;
    property Error: WideString readonly dispid 4;
  end;

// *********************************************************************//
// Interface: IWSManConnectionOptions
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F704E861-9E52-464F-B786-DA5EB2320FDD}
// *********************************************************************//
  IWSManConnectionOptions = interface(IDispatch)
    ['{F704E861-9E52-464F-B786-DA5EB2320FDD}']
    function Get_UserName: WideString; safecall;
    procedure Set_UserName(const name: WideString); safecall;
    procedure Set_Password(const Param1: WideString); safecall;
    property UserName: WideString read Get_UserName write Set_UserName;
    property Password: WideString write Set_Password;
  end;

// *********************************************************************//
// DispIntf:  IWSManConnectionOptionsDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F704E861-9E52-464F-B786-DA5EB2320FDD}
// *********************************************************************//
  IWSManConnectionOptionsDisp = dispinterface
    ['{F704E861-9E52-464F-B786-DA5EB2320FDD}']
    property UserName: WideString dispid 1;
    property Password: WideString writeonly dispid 2;
  end;

// *********************************************************************//
// Interface: IWSManConnectionOptionsEx
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {EF43EDF7-2A48-4D93-9526-8BD6AB6D4A6B}
// *********************************************************************//
  IWSManConnectionOptionsEx = interface(IWSManConnectionOptions)
    ['{EF43EDF7-2A48-4D93-9526-8BD6AB6D4A6B}']
    function Get_CertificateThumbprint: WideString; safecall;
    procedure Set_CertificateThumbprint(const thumbprint: WideString); safecall;
    property CertificateThumbprint: WideString read Get_CertificateThumbprint write Set_CertificateThumbprint;
  end;

// *********************************************************************//
// DispIntf:  IWSManConnectionOptionsExDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {EF43EDF7-2A48-4D93-9526-8BD6AB6D4A6B}
// *********************************************************************//
  IWSManConnectionOptionsExDisp = dispinterface
    ['{EF43EDF7-2A48-4D93-9526-8BD6AB6D4A6B}']
    property CertificateThumbprint: WideString dispid 3;
    property UserName: WideString dispid 1;
    property Password: WideString writeonly dispid 2;
  end;

// *********************************************************************//
// Interface: IWSManConnectionOptionsEx2
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F500C9EC-24EE-48AB-B38D-FC9A164C658E}
// *********************************************************************//
  IWSManConnectionOptionsEx2 = interface(IWSManConnectionOptionsEx)
    ['{F500C9EC-24EE-48AB-B38D-FC9A164C658E}']
    procedure SetProxy(accessType: Integer; authenticationMechanism: Integer; 
                       const UserName: WideString; const Password: WideString); safecall;
    function ProxyIEConfig: Integer; safecall;
    function ProxyWinHttpConfig: Integer; safecall;
    function ProxyAutoDetect: Integer; safecall;
    function ProxyNoProxyServer: Integer; safecall;
    function ProxyAuthenticationUseNegotiate: Integer; safecall;
    function ProxyAuthenticationUseBasic: Integer; safecall;
    function ProxyAuthenticationUseDigest: Integer; safecall;
  end;

// *********************************************************************//
// DispIntf:  IWSManConnectionOptionsEx2Disp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F500C9EC-24EE-48AB-B38D-FC9A164C658E}
// *********************************************************************//
  IWSManConnectionOptionsEx2Disp = dispinterface
    ['{F500C9EC-24EE-48AB-B38D-FC9A164C658E}']
    procedure SetProxy(accessType: Integer; authenticationMechanism: Integer; 
                       const UserName: WideString; const Password: WideString); dispid 4;
    function ProxyIEConfig: Integer; dispid 5;
    function ProxyWinHttpConfig: Integer; dispid 6;
    function ProxyAutoDetect: Integer; dispid 7;
    function ProxyNoProxyServer: Integer; dispid 8;
    function ProxyAuthenticationUseNegotiate: Integer; dispid 9;
    function ProxyAuthenticationUseBasic: Integer; dispid 10;
    function ProxyAuthenticationUseDigest: Integer; dispid 11;
    property CertificateThumbprint: WideString dispid 3;
    property UserName: WideString dispid 1;
    property Password: WideString writeonly dispid 2;
  end;

// *********************************************************************//
// Interface: IWSManSession
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {FC84FC58-1286-40C4-9DA0-C8EF6EC241E0}
// *********************************************************************//
  IWSManSession = interface(IDispatch)
    ['{FC84FC58-1286-40C4-9DA0-C8EF6EC241E0}']
    function Get(resourceUri: OleVariant; flags: Integer): WideString; safecall;
    function Put(resourceUri: OleVariant; const resource: WideString; flags: Integer): WideString; safecall;
    function Create(resourceUri: OleVariant; const resource: WideString; flags: Integer): WideString; safecall;
    procedure Delete(resourceUri: OleVariant; flags: Integer); safecall;
    function Invoke_(const actionUri: WideString; resourceUri: OleVariant; 
                     const parameters: WideString; flags: Integer): WideString; safecall;
    function Enumerate(resourceUri: OleVariant; const filter: WideString; 
                       const dialect: WideString; flags: Integer): IDispatch; safecall;
    function Identify(flags: Integer): WideString; safecall;
    function Get_Error: WideString; safecall;
    function Get_BatchItems: Integer; safecall;
    procedure Set_BatchItems(value: Integer); safecall;
    function Get_Timeout: Integer; safecall;
    procedure Set_Timeout(value: Integer); safecall;
    property Error: WideString read Get_Error;
    property BatchItems: Integer read Get_BatchItems write Set_BatchItems;
    property Timeout: Integer read Get_Timeout write Set_Timeout;
  end;

// *********************************************************************//
// DispIntf:  IWSManSessionDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {FC84FC58-1286-40C4-9DA0-C8EF6EC241E0}
// *********************************************************************//
  IWSManSessionDisp = dispinterface
    ['{FC84FC58-1286-40C4-9DA0-C8EF6EC241E0}']
    function Get(resourceUri: OleVariant; flags: Integer): WideString; dispid 1;
    function Put(resourceUri: OleVariant; const resource: WideString; flags: Integer): WideString; dispid 2;
    function Create(resourceUri: OleVariant; const resource: WideString; flags: Integer): WideString; dispid 3;
    procedure Delete(resourceUri: OleVariant; flags: Integer); dispid 4;
    function Invoke_(const actionUri: WideString; resourceUri: OleVariant; 
                     const parameters: WideString; flags: Integer): WideString; dispid 5;
    function Enumerate(resourceUri: OleVariant; const filter: WideString; 
                       const dialect: WideString; flags: Integer): IDispatch; dispid 6;
    function Identify(flags: Integer): WideString; dispid 7;
    property Error: WideString readonly dispid 8;
    property BatchItems: Integer dispid 9;
    property Timeout: Integer dispid 10;
  end;

// *********************************************************************//
// Interface: IWSManEnumerator
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F3457CA9-ABB9-4FA5-B850-90E8CA300E7F}
// *********************************************************************//
  IWSManEnumerator = interface(IDispatch)
    ['{F3457CA9-ABB9-4FA5-B850-90E8CA300E7F}']
    function ReadItem: WideString; safecall;
    function Get_AtEndOfStream: WordBool; safecall;
    function Get_Error: WideString; safecall;
    property AtEndOfStream: WordBool read Get_AtEndOfStream;
    property Error: WideString read Get_Error;
  end;

// *********************************************************************//
// DispIntf:  IWSManEnumeratorDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {F3457CA9-ABB9-4FA5-B850-90E8CA300E7F}
// *********************************************************************//
  IWSManEnumeratorDisp = dispinterface
    ['{F3457CA9-ABB9-4FA5-B850-90E8CA300E7F}']
    function ReadItem: WideString; dispid 1;
    property AtEndOfStream: WordBool readonly dispid 2;
    property Error: WideString readonly dispid 8;
  end;

// *********************************************************************//
// Interface: IWSManResourceLocator
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {A7A1BA28-DE41-466A-AD0A-C4059EAD7428}
// *********************************************************************//
  IWSManResourceLocator = interface(IDispatch)
    ['{A7A1BA28-DE41-466A-AD0A-C4059EAD7428}']
    procedure Set_resourceUri(const uri: WideString); safecall;
    function Get_resourceUri: WideString; safecall;
    procedure AddSelector(const resourceSelName: WideString; selValue: OleVariant); safecall;
    procedure ClearSelectors; safecall;
    function Get_FragmentPath: WideString; safecall;
    procedure Set_FragmentPath(const text: WideString); safecall;
    function Get_FragmentDialect: WideString; safecall;
    procedure Set_FragmentDialect(const text: WideString); safecall;
    procedure AddOption(const OptionName: WideString; OptionValue: OleVariant; mustComply: Integer); safecall;
    procedure Set_MustUnderstandOptions(mustUnderstand: Integer); safecall;
    function Get_MustUnderstandOptions: Integer; safecall;
    procedure ClearOptions; safecall;
    function Get_Error: WideString; safecall;
    property resourceUri: WideString read Get_resourceUri write Set_resourceUri;
    property FragmentPath: WideString read Get_FragmentPath write Set_FragmentPath;
    property FragmentDialect: WideString read Get_FragmentDialect write Set_FragmentDialect;
    property MustUnderstandOptions: Integer read Get_MustUnderstandOptions write Set_MustUnderstandOptions;
    property Error: WideString read Get_Error;
  end;

// *********************************************************************//
// DispIntf:  IWSManResourceLocatorDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {A7A1BA28-DE41-466A-AD0A-C4059EAD7428}
// *********************************************************************//
  IWSManResourceLocatorDisp = dispinterface
    ['{A7A1BA28-DE41-466A-AD0A-C4059EAD7428}']
    property resourceUri: WideString dispid 1;
    procedure AddSelector(const resourceSelName: WideString; selValue: OleVariant); dispid 2;
    procedure ClearSelectors; dispid 3;
    property FragmentPath: WideString dispid 4;
    property FragmentDialect: WideString dispid 5;
    procedure AddOption(const OptionName: WideString; OptionValue: OleVariant; mustComply: Integer); dispid 6;
    property MustUnderstandOptions: Integer dispid 7;
    procedure ClearOptions; dispid 8;
    property Error: WideString readonly dispid 9;
  end;

// *********************************************************************//
// Interface: IWSManResourceLocatorInternal
// Flags:     (400) Hidden NonExtensible OleAutomation
// GUID:      {EFFAEAD7-7EC8-4716-B9BE-F2E7E9FB4ADB}
// *********************************************************************//
  IWSManResourceLocatorInternal = interface(IUnknown)
    ['{EFFAEAD7-7EC8-4716-B9BE-F2E7E9FB4ADB}']
  end;

// *********************************************************************//
// Interface: IWSManInternal
// Flags:     (4496) Hidden NonExtensible OleAutomation Dispatchable
// GUID:      {04AE2B1D-9954-4D99-94A9-A961E72C3A13}
// *********************************************************************//
  IWSManInternal = interface(IDispatch)
    ['{04AE2B1D-9954-4D99-94A9-A961E72C3A13}']
    function ConfigSDDL(const session: IDispatch; resourceUri: OleVariant; flags: Integer; 
                        out resource: WideString): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoWSMan provides a Create and CreateRemote method to          
// create instances of the default interface IWSManEx3 exposed by              
// the CoClass WSMan. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWSMan = class
    class function Create: IWSManEx3;
    class function CreateRemote(const MachineName: string): IWSManEx3;
  end;

// *********************************************************************//
// The Class CoWSManInternal provides a Create and CreateRemote method to          
// create instances of the default interface IWSManInternal exposed by              
// the CoClass WSManInternal. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWSManInternal = class
    class function Create: IWSManInternal;
    class function CreateRemote(const MachineName: string): IWSManInternal;
  end;

implementation

uses ComObj;

class function CoWSMan.Create: IWSManEx3;
begin
  Result := CreateComObject(CLASS_WSMan) as IWSManEx3;
end;

class function CoWSMan.CreateRemote(const MachineName: string): IWSManEx3;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WSMan) as IWSManEx3;
end;

class function CoWSManInternal.Create: IWSManInternal;
begin
  Result := CreateComObject(CLASS_WSManInternal) as IWSManInternal;
end;

class function CoWSManInternal.CreateRemote(const MachineName: string): IWSManInternal;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WSManInternal) as IWSManInternal;
end;

end.
