unit WindowsPortableDeviceWCNTasks;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:55:08 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\wpdwcn.dll (1)
// LIBID: {E28C678F-84EE-4D53-B455-FB3B33205D63}
// LCID: 0
// Helpfile: 
// HelpString: Windows Portable Device WCN Tasks 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WindowsPortableDeviceWCNTasksMajorVersion = 1;
  WindowsPortableDeviceWCNTasksMinorVersion = 0;

  LIBID_WindowsPortableDeviceWCNTasks: TGUID = '{E28C678F-84EE-4D53-B455-FB3B33205D63}';

  IID_IXWizardMessageEvent: TGUID = '{777BA824-2498-4875-933A-3067DE883070}';
  IID_IXWizardTaskEvent: TGUID = '{777BA8B2-2498-4875-933A-3067DE883070}';
  CLASS_WindowsPortableDeviceTask: TGUID = '{34C219BD-85C1-4338-95E8-788A36901DC2}';
  IID_IXWizardSource: TGUID = '{777BA826-2498-4875-933A-3067DE883070}';
  IID_IXWizardTransactionEvent: TGUID = '{777BA828-2498-4875-933A-3067DE883070}';
  IID_IXWizardPageEvent: TGUID = '{777BA8C2-2498-4875-933A-3067DE883070}';
  CLASS_SettingsReviewPage: TGUID = '{FABD6EA5-AE10-4E7A-B83B-5F07ACC84214}';
  CLASS_SettingsCommitPage: TGUID = '{417BAB8B-9D22-4A88-9DA0-98C4AB6745D5}';
  CLASS_CompletionPage: TGUID = '{DAA92564-78C8-40A3-96D2-9115A76B8F29}';
  IID_IWpdPnPXAssociationManager: TGUID = '{5068B32E-DFE0-48C2-9816-4549033447DB}';
  CLASS_WpdPnPXAssociationManager: TGUID = '{BFD6C433-4B17-4F6D-A93C-B03FCC4E586E}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum tagXW_WIZARD_TYPE
type
  tagXW_WIZARD_TYPE = TOleEnum;
const
  XW_WIZARD_TYPE_NONE = $00000000;
  XW_WIZARD_TYPE_PROPERTYSHEET97 = $00000001;
  XW_WIZARD_TYPE_WIZARD97 = $00000002;
  XW_WIZARD_TYPE_AEROSMALLFIXED = $00000020;
  XW_WIZARD_TYPE_AEROSMALLRESIZE = $00000040;
  XW_WIZARD_TYPE_AEROBIGFIXED = $00000080;
  XW_WIZARD_TYPE_AEROBIGRESIZE = $000000C0;
  XW_WIZARD_TYPE_TASKPAGE = $00020000;
  XW_WIZARD_TYPE_MEDIACENTER = $02000000;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IXWizardMessageEvent = interface;
  IXWizardTaskEvent = interface;
  IXWizardSource = interface;
  IXWizardTransactionEvent = interface;
  IXWizardPageEvent = interface;
  IWpdPnPXAssociationManager = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  WindowsPortableDeviceTask = IXWizardTaskEvent;
  SettingsReviewPage = IXWizardPageEvent;
  SettingsCommitPage = IXWizardPageEvent;
  CompletionPage = IXWizardPageEvent;
  WpdPnPXAssociationManager = IWpdPnPXAssociationManager;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 
  PUserType1 = ^TGUID; {*}
  PUserType2 = ^_XWIZARD_HOST_DISPLAY_TASK_INFO; {*}

  _XWIZARD_HOST_DISPLAY_TASK_INFO = packed record
    dwVersion: LongWord;
    dwDisplayFlags: LongWord;
    guidTask: TGUID;
    pfnLoadImage: Pointer;
    hInstance: Pointer;
    pszIcon: PWideChar;
    pszViewName: PWideChar;
    pszTooltipName: PWideChar;
  end;


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;


// *********************************************************************//
// Interface: IXWizardMessageEvent
// Flags:     (0)
// GUID:      {777BA824-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizardMessageEvent = interface(IUnknown)
    ['{777BA824-2498-4875-933A-3067DE883070}']
    function OnError(var pguidOriginComponent: TGUID; dwResult: LongWord; 
                     pszOptionalMessage: PWideChar; dwMessageFlags: LongWord): HResult; stdcall;
    function OnDisplay(var pguidOriginComponent: TGUID; pszCaption: PWideChar; pszText: PWideChar; 
                       uiDialogType: SYSUINT; out piDialogResult: SYSINT; dwMessageFlags: LongWord): HResult; stdcall;
    function OnLog(var pguidOriginComponent: TGUID; pszCaption: PWideChar; pszText: PWideChar; 
                   wEventType: Word; dwMessageFlags: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IXWizardTaskEvent
// Flags:     (0)
// GUID:      {777BA8B2-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizardTaskEvent = interface(IXWizardMessageEvent)
    ['{777BA8B2-2498-4875-933A-3067DE883070}']
    function CanHostTask(var pguidParentHost: TGUID; out ppHostDisplayData: PUserType2): HResult; stdcall;
    function CanRunTask(var hwndParent: _RemotableHandle; var pguidParentHost: TGUID; 
                        eWizardType: tagXW_WIZARD_TYPE; dwUserFlags: LongWord; 
                        pszCommandLine: PWideChar; dwContextFlags: LongWord; 
                        const pIXWizardSource: IXWizardSource; out ppTaskData: Pointer): HResult; stdcall;
    function CanRegisterPage(var pguidPage: TGUID): HResult; stdcall;
    function CanUnregisterPage(var pguidPage: TGUID): HResult; stdcall;
    function CanNavigatePage(var pguidSourcePage: TGUID; var pguidTargetPage: TGUID): HResult; stdcall;
    function OnRecyclePage(var pguidPage: TGUID; var pguidPreviousPage: TGUID): HResult; stdcall;
    function OnGetWizardTypesSupported(out pdwWizardTypes: LongWord): HResult; stdcall;
    function OnApply: HResult; stdcall;
    function OnReset: HResult; stdcall;
    function OnCommit: HResult; stdcall;
    function OnAbort: HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IXWizardSource
// Flags:     (0)
// GUID:      {777BA826-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizardSource = interface(IUnknown)
    ['{777BA826-2498-4875-933A-3067DE883070}']
  end;

// *********************************************************************//
// Interface: IXWizardTransactionEvent
// Flags:     (0)
// GUID:      {777BA828-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizardTransactionEvent = interface(IUnknown)
    ['{777BA828-2498-4875-933A-3067DE883070}']
    function OnApply: HResult; stdcall;
    function OnReset: HResult; stdcall;
    function OnCommit: HResult; stdcall;
    function OnAbort: HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IXWizardPageEvent
// Flags:     (0)
// GUID:      {777BA8C2-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizardPageEvent = interface(IXWizardTransactionEvent)
    ['{777BA8C2-2498-4875-933A-3067DE883070}']
    function CanRunPage(var pguidTask: TGUID; var pguidParentPage: TGUID; 
                        eWizardType: tagXW_WIZARD_TYPE; dwUserFlags: LongWord; 
                        pszCommandLine: PWideChar; dwContextFlags: LongWord; 
                        const pIXWizardSource: IXWizardSource; out ppPageData: Pointer): HResult; stdcall;
    function CanRegisterPage(var pguidPage: TGUID): HResult; stdcall;
    function CanUnregisterPage(var pguidPage: TGUID): HResult; stdcall;
    function CanNavigateChildPage(var pguidTargetPage: TGUID): HResult; stdcall;
    function OnRecycleChildPage(var pguidPage: TGUID): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IWpdPnPXAssociationManager
// Flags:     (0)
// GUID:      {5068B32E-DFE0-48C2-9816-4549033447DB}
// *********************************************************************//
  IWpdPnPXAssociationManager = interface(IUnknown)
    ['{5068B32E-DFE0-48C2-9816-4549033447DB}']
    function AssociateDevice(const bstrRootDeviceUUID: WideString): HResult; stdcall;
    function IsAssociated(const bstrRootDeviceUUID: WideString): HResult; stdcall;
    function EnableFirewallGroup(profileTypesBitmask: Integer; const bstrGroupName: WideString): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoWindowsPortableDeviceTask provides a Create and CreateRemote method to          
// create instances of the default interface IXWizardTaskEvent exposed by              
// the CoClass WindowsPortableDeviceTask. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWindowsPortableDeviceTask = class
    class function Create: IXWizardTaskEvent;
    class function CreateRemote(const MachineName: string): IXWizardTaskEvent;
  end;

// *********************************************************************//
// The Class CoSettingsReviewPage provides a Create and CreateRemote method to          
// create instances of the default interface IXWizardPageEvent exposed by              
// the CoClass SettingsReviewPage. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoSettingsReviewPage = class
    class function Create: IXWizardPageEvent;
    class function CreateRemote(const MachineName: string): IXWizardPageEvent;
  end;

// *********************************************************************//
// The Class CoSettingsCommitPage provides a Create and CreateRemote method to          
// create instances of the default interface IXWizardPageEvent exposed by              
// the CoClass SettingsCommitPage. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoSettingsCommitPage = class
    class function Create: IXWizardPageEvent;
    class function CreateRemote(const MachineName: string): IXWizardPageEvent;
  end;

// *********************************************************************//
// The Class CoCompletionPage provides a Create and CreateRemote method to          
// create instances of the default interface IXWizardPageEvent exposed by              
// the CoClass CompletionPage. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCompletionPage = class
    class function Create: IXWizardPageEvent;
    class function CreateRemote(const MachineName: string): IXWizardPageEvent;
  end;

// *********************************************************************//
// The Class CoWpdPnPXAssociationManager provides a Create and CreateRemote method to          
// create instances of the default interface IWpdPnPXAssociationManager exposed by              
// the CoClass WpdPnPXAssociationManager. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWpdPnPXAssociationManager = class
    class function Create: IWpdPnPXAssociationManager;
    class function CreateRemote(const MachineName: string): IWpdPnPXAssociationManager;
  end;

implementation

uses ComObj;

class function CoWindowsPortableDeviceTask.Create: IXWizardTaskEvent;
begin
  Result := CreateComObject(CLASS_WindowsPortableDeviceTask) as IXWizardTaskEvent;
end;

class function CoWindowsPortableDeviceTask.CreateRemote(const MachineName: string): IXWizardTaskEvent;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WindowsPortableDeviceTask) as IXWizardTaskEvent;
end;

class function CoSettingsReviewPage.Create: IXWizardPageEvent;
begin
  Result := CreateComObject(CLASS_SettingsReviewPage) as IXWizardPageEvent;
end;

class function CoSettingsReviewPage.CreateRemote(const MachineName: string): IXWizardPageEvent;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_SettingsReviewPage) as IXWizardPageEvent;
end;

class function CoSettingsCommitPage.Create: IXWizardPageEvent;
begin
  Result := CreateComObject(CLASS_SettingsCommitPage) as IXWizardPageEvent;
end;

class function CoSettingsCommitPage.CreateRemote(const MachineName: string): IXWizardPageEvent;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_SettingsCommitPage) as IXWizardPageEvent;
end;

class function CoCompletionPage.Create: IXWizardPageEvent;
begin
  Result := CreateComObject(CLASS_CompletionPage) as IXWizardPageEvent;
end;

class function CoCompletionPage.CreateRemote(const MachineName: string): IXWizardPageEvent;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CompletionPage) as IXWizardPageEvent;
end;

class function CoWpdPnPXAssociationManager.Create: IWpdPnPXAssociationManager;
begin
  Result := CreateComObject(CLASS_WpdPnPXAssociationManager) as IWpdPnPXAssociationManager;
end;

class function CoWpdPnPXAssociationManager.CreateRemote(const MachineName: string): IWpdPnPXAssociationManager;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WpdPnPXAssociationManager) as IWpdPnPXAssociationManager;
end;

end.
