unit XPS_SHL_DLLLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:56:18 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\XPSSHHDR.dll (1)
// LIBID: {0109E0F4-91AE-4736-A2CE-9D63E89D0EF6}
// LCID: 0
// Helpfile: 
// HelpString: XPS_SHL_DLL 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  XPS_SHL_DLLLibMajorVersion = 1;
  XPS_SHL_DLLLibMinorVersion = 0;

  LIBID_XPS_SHL_DLLLib: TGUID = '{0109E0F4-91AE-4736-A2CE-9D63E89D0EF6}';

  IID_IPersist: TGUID = '{0000010C-0000-0000-C000-000000000046}';
  IID_IPersistFile: TGUID = '{0000010B-0000-0000-C000-000000000046}';
  CLASS_XPS_Metadata_Handler: TGUID = '{45670FA8-ED97-4F44-BC93-305082590BFB}';
  CLASS_XPS_Thumbnail_Handler: TGUID = '{44121072-A222-48F2-A58A-6D9AD51EBBE9}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IPersist = interface;
  IPersistFile = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  XPS_Metadata_Handler = IPersistFile;
  XPS_Thumbnail_Handler = IPersistFile;


// *********************************************************************//
// Interface: IPersist
// Flags:     (0)
// GUID:      {0000010C-0000-0000-C000-000000000046}
// *********************************************************************//
  IPersist = interface(IUnknown)
    ['{0000010C-0000-0000-C000-000000000046}']
    function GetClassID(out pClassID: TGUID): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IPersistFile
// Flags:     (0)
// GUID:      {0000010B-0000-0000-C000-000000000046}
// *********************************************************************//
  IPersistFile = interface(IPersist)
    ['{0000010B-0000-0000-C000-000000000046}']
    function IsDirty: HResult; stdcall;
    function Load(pszFileName: PWideChar; dwMode: LongWord): HResult; stdcall;
    function Save(pszFileName: PWideChar; fRemember: Integer): HResult; stdcall;
    function SaveCompleted(pszFileName: PWideChar): HResult; stdcall;
    function GetCurFile(out ppszFileName: PWideChar): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoXPS_Metadata_Handler provides a Create and CreateRemote method to          
// create instances of the default interface IPersistFile exposed by              
// the CoClass XPS_Metadata_Handler. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoXPS_Metadata_Handler = class
    class function Create: IPersistFile;
    class function CreateRemote(const MachineName: string): IPersistFile;
  end;

// *********************************************************************//
// The Class CoXPS_Thumbnail_Handler provides a Create and CreateRemote method to          
// create instances of the default interface IPersistFile exposed by              
// the CoClass XPS_Thumbnail_Handler. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoXPS_Thumbnail_Handler = class
    class function Create: IPersistFile;
    class function CreateRemote(const MachineName: string): IPersistFile;
  end;

implementation

uses ComObj;

class function CoXPS_Metadata_Handler.Create: IPersistFile;
begin
  Result := CreateComObject(CLASS_XPS_Metadata_Handler) as IPersistFile;
end;

class function CoXPS_Metadata_Handler.CreateRemote(const MachineName: string): IPersistFile;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_XPS_Metadata_Handler) as IPersistFile;
end;

class function CoXPS_Thumbnail_Handler.Create: IPersistFile;
begin
  Result := CreateComObject(CLASS_XPS_Thumbnail_Handler) as IPersistFile;
end;

class function CoXPS_Thumbnail_Handler.CreateRemote(const MachineName: string): IPersistFile;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_XPS_Thumbnail_Handler) as IPersistFile;
end;

end.
