unit icardie;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:26:12 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\icardie.dll (1)
// LIBID: {8D810F97-C1A1-49CA-9902-A7B7E58AF009}
// LCID: 0
// Helpfile: 
// HelpString: Microsoft Information Card IE Helper 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  icardieMajorVersion = 1;
  icardieMinorVersion = 0;

  LIBID_icardie: TGUID = '{8D810F97-C1A1-49CA-9902-A7B7E58AF009}';

  IID_ICardSpaceSigninHelper: TGUID = '{9B23A3F7-CE97-4509-91C2-805C3C9E6A84}';
  CLASS_CardSpaceSigninHelper: TGUID = '{19916E01-B44E-4E31-94A4-4696DF46157B}';
  CLASS_CardSpaceElementBehaviorFactory: TGUID = '{C2C4F00A-720E-4389-AEB9-E9C4B0D93C6F}';
  IID_ICardSpaceClaimCollection: TGUID = '{EB01DC81-2F21-4360-A16C-B52CDF9081D1}';
  CLASS_CardSpaceClaimCollection: TGUID = '{53001F3A-F5E1-4B90-9C9F-00E09B53C5F1}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ICardSpaceSigninHelper = interface;
  ICardSpaceSigninHelperDisp = dispinterface;
  ICardSpaceClaimCollection = interface;
  ICardSpaceClaimCollectionDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  CardSpaceSigninHelper = ICardSpaceSigninHelper;
  CardSpaceElementBehaviorFactory = IUnknown;
  CardSpaceClaimCollection = ICardSpaceClaimCollection;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  POleVariant1 = ^OleVariant; {*}

  _SERVICEIDENTITY = packed record
    Url: WideString;
    PolicyUrl: WideString;
    IdentityType: LongWord;
    Identity: PSafeArray;
  end;

  _REQUESTEDTOKENPOLICY = packed record
    Flags: LongWord;
    Recipient: _SERVICEIDENTITY;
    Issuer: _SERVICEIDENTITY;
    TokenType: WideString;
    RequiredClaims: PSafeArray;
    OptionalClaims: PSafeArray;
    PrivacyUrl: WideString;
    PrivacyVersion: OleVariant;
  end;

  _SERVICEIDENTITY2 = packed record
    Url: WideString;
    PolicyUrl: WideString;
    IdentityType: LongWord;
    Identity: PSafeArray;
  end;

  _REQUESTEDTOKENPOLICY2 = packed record
    Flags: LongWord;
    Recipient: _SERVICEIDENTITY2;
    Issuer: _SERVICEIDENTITY2;
    TokenType: WideString;
    RequiredClaims: PSafeArray;
    OptionalClaims: PSafeArray;
    PrivacyUrl: WideString;
    PrivacyVersion: OleVariant;
  end;


// *********************************************************************//
// Interface: ICardSpaceSigninHelper
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {9B23A3F7-CE97-4509-91C2-805C3C9E6A84}
// *********************************************************************//
  ICardSpaceSigninHelper = interface(IDispatch)
    ['{9B23A3F7-CE97-4509-91C2-805C3C9E6A84}']
    function Get_isInstalled: WordBool; safecall;
    function Get_PrivacyUrl: WideString; safecall;
    procedure Set_PrivacyUrl(const pUrl: WideString); safecall;
    function Get_PrivacyVersion: OleVariant; safecall;
    procedure Set_PrivacyVersion(var pVersion: OleVariant); safecall;
    function Get_Issuer: WideString; safecall;
    procedure Set_Issuer(const pUrl: WideString); safecall;
    function Get_issuerPolicy: WideString; safecall;
    procedure Set_issuerPolicy(const pUrl: WideString); safecall;
    function Get_value: WideString; safecall;
    procedure Set_value(const pValue: WideString); safecall;
    function Get_TokenType: WideString; safecall;
    procedure Set_TokenType(const pTokenType: WideString); safecall;
    function Get_RequiredClaims: IUnknown; safecall;
    function Get_OptionalClaims: IUnknown; safecall;
    property isInstalled: WordBool read Get_isInstalled;
    property PrivacyUrl: WideString read Get_PrivacyUrl write Set_PrivacyUrl;
    property Issuer: WideString read Get_Issuer write Set_Issuer;
    property issuerPolicy: WideString read Get_issuerPolicy write Set_issuerPolicy;
    property value: WideString read Get_value write Set_value;
    property TokenType: WideString read Get_TokenType write Set_TokenType;
    property RequiredClaims: IUnknown read Get_RequiredClaims;
    property OptionalClaims: IUnknown read Get_OptionalClaims;
  end;

// *********************************************************************//
// DispIntf:  ICardSpaceSigninHelperDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {9B23A3F7-CE97-4509-91C2-805C3C9E6A84}
// *********************************************************************//
  ICardSpaceSigninHelperDisp = dispinterface
    ['{9B23A3F7-CE97-4509-91C2-805C3C9E6A84}']
    property isInstalled: WordBool readonly dispid 2;
    property PrivacyUrl: WideString dispid 13;
    function PrivacyVersion: OleVariant; dispid 14;
    property Issuer: WideString dispid 4;
    property issuerPolicy: WideString dispid 9;
    property value: WideString dispid 0;
    property TokenType: WideString dispid 8;
    property RequiredClaims: IUnknown readonly dispid 12;
    property OptionalClaims: IUnknown readonly dispid 11;
  end;

// *********************************************************************//
// Interface: ICardSpaceClaimCollection
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {EB01DC81-2F21-4360-A16C-B52CDF9081D1}
// *********************************************************************//
  ICardSpaceClaimCollection = interface(IDispatch)
    ['{EB01DC81-2F21-4360-A16C-B52CDF9081D1}']
    function Get__newEnum: IUnknown; safecall;
    function item(var pVarIndex: OleVariant): OleVariant; safecall;
    function Get_length: Integer; safecall;
    procedure add(var pVarClaimUri: OleVariant); safecall;
    procedure remove(var pValue: OleVariant); safecall;
    function toString: WideString; safecall;
    procedure fromString(const pString: WideString); safecall;
    property _newEnum: IUnknown read Get__newEnum;
    property length: Integer read Get_length;
  end;

// *********************************************************************//
// DispIntf:  ICardSpaceClaimCollectionDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {EB01DC81-2F21-4360-A16C-B52CDF9081D1}
// *********************************************************************//
  ICardSpaceClaimCollectionDisp = dispinterface
    ['{EB01DC81-2F21-4360-A16C-B52CDF9081D1}']
    property _newEnum: IUnknown readonly dispid -4;
    function item(var pVarIndex: OleVariant): OleVariant; dispid 21;
    property length: Integer readonly dispid 22;
    procedure add(var pVarClaimUri: OleVariant); dispid 23;
    procedure remove(var pValue: OleVariant); dispid 24;
    function toString: WideString; dispid 25;
    procedure fromString(const pString: WideString); dispid 26;
  end;

// *********************************************************************//
// The Class CoCardSpaceSigninHelper provides a Create and CreateRemote method to          
// create instances of the default interface ICardSpaceSigninHelper exposed by              
// the CoClass CardSpaceSigninHelper. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCardSpaceSigninHelper = class
    class function Create: ICardSpaceSigninHelper;
    class function CreateRemote(const MachineName: string): ICardSpaceSigninHelper;
  end;

// *********************************************************************//
// The Class CoCardSpaceElementBehaviorFactory provides a Create and CreateRemote method to          
// create instances of the default interface IUnknown exposed by              
// the CoClass CardSpaceElementBehaviorFactory. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCardSpaceElementBehaviorFactory = class
    class function Create: IUnknown;
    class function CreateRemote(const MachineName: string): IUnknown;
  end;

// *********************************************************************//
// The Class CoCardSpaceClaimCollection provides a Create and CreateRemote method to          
// create instances of the default interface ICardSpaceClaimCollection exposed by              
// the CoClass CardSpaceClaimCollection. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCardSpaceClaimCollection = class
    class function Create: ICardSpaceClaimCollection;
    class function CreateRemote(const MachineName: string): ICardSpaceClaimCollection;
  end;

implementation

uses ComObj;

class function CoCardSpaceSigninHelper.Create: ICardSpaceSigninHelper;
begin
  Result := CreateComObject(CLASS_CardSpaceSigninHelper) as ICardSpaceSigninHelper;
end;

class function CoCardSpaceSigninHelper.CreateRemote(const MachineName: string): ICardSpaceSigninHelper;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CardSpaceSigninHelper) as ICardSpaceSigninHelper;
end;

class function CoCardSpaceElementBehaviorFactory.Create: IUnknown;
begin
  Result := CreateComObject(CLASS_CardSpaceElementBehaviorFactory) as IUnknown;
end;

class function CoCardSpaceElementBehaviorFactory.CreateRemote(const MachineName: string): IUnknown;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CardSpaceElementBehaviorFactory) as IUnknown;
end;

class function CoCardSpaceClaimCollection.Create: ICardSpaceClaimCollection;
begin
  Result := CreateComObject(CLASS_CardSpaceClaimCollection) as ICardSpaceClaimCollection;
end;

class function CoCardSpaceClaimCollection.CreateRemote(const MachineName: string): ICardSpaceClaimCollection;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CardSpaceClaimCollection) as ICardSpaceClaimCollection;
end;

end.
