unit ndfapiLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:39:18 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\ndfapi.dll (1)
// LIBID: {11DD5EA9-F8DB-4F6E-BF7C-6AADBA404A3D}
// LCID: 0
// Helpfile: 
// HelpString: ndfapi 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  ndfapiLibMajorVersion = 1;
  ndfapiLibMinorVersion = 0;

  LIBID_ndfapiLib: TGUID = '{11DD5EA9-F8DB-4F6E-BF7C-6AADBA404A3D}';

  IID_ILUALaunch: TGUID = '{870AE94C-CD50-45EE-AE5D-36210ADD3305}';
  IID_INetworkFileAccessDiagnosticsUI: TGUID = '{FB5AD46A-DD49-470D-8132-6A094056401D}';
  CLASS_NDFAPI: TGUID = '{C529C7EF-A3AF-45F2-8A47-767B33AA5CC0}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ILUALaunch = interface;
  ILUALaunchDisp = dispinterface;
  INetworkFileAccessDiagnosticsUI = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  NDFAPI = ILUALaunch;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;


// *********************************************************************//
// Interface: ILUALaunch
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {870AE94C-CD50-45EE-AE5D-36210ADD3305}
// *********************************************************************//
  ILUALaunch = interface(IDispatch)
    ['{870AE94C-CD50-45EE-AE5D-36210ADD3305}']
    procedure Launch(guidIncident: TGUID; guidRepair: TGUID; rootCauseIndex: SYSUINT; 
                     incidentType: SYSUINT); safecall;
  end;

// *********************************************************************//
// DispIntf:  ILUALaunchDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {870AE94C-CD50-45EE-AE5D-36210ADD3305}
// *********************************************************************//
  ILUALaunchDisp = dispinterface
    ['{870AE94C-CD50-45EE-AE5D-36210ADD3305}']
    procedure Launch(guidIncident: {??TGUID}OleVariant; guidRepair: {??TGUID}OleVariant; 
                     rootCauseIndex: SYSUINT; incidentType: SYSUINT); dispid 1;
  end;

// *********************************************************************//
// Interface: INetworkFileAccessDiagnosticsUI
// Flags:     (0)
// GUID:      {FB5AD46A-DD49-470D-8132-6A094056401D}
// *********************************************************************//
  INetworkFileAccessDiagnosticsUI = interface(IUnknown)
    ['{FB5AD46A-DD49-470D-8132-6A094056401D}']
    function Show(var hwndOwner: _RemotableHandle; pszServer: PWideChar; pszPath: PWideChar; 
                  hrToDiagnose: HResult): HResult; stdcall;
    function IsDiagnosableResult(hrToDiagnose: HResult; pszFile: PWideChar): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoNDFAPI provides a Create and CreateRemote method to          
// create instances of the default interface ILUALaunch exposed by              
// the CoClass NDFAPI. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoNDFAPI = class
    class function Create: ILUALaunch;
    class function CreateRemote(const MachineName: string): ILUALaunch;
  end;

implementation

uses ComObj;

class function CoNDFAPI.Create: ILUALaunch;
begin
  Result := CreateComObject(CLASS_NDFAPI) as ILUALaunch;
end;

class function CoNDFAPI.CreateRemote(const MachineName: string): ILUALaunch;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_NDFAPI) as ILUALaunch;
end;

end.
