unit DiskQuotaTypeLibrary;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:22:18 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\dskquota.dll (1)
// LIBID: {7988B57C-EC89-11CF-9C00-00AA00A14F56}
// LCID: 0
// Helpfile: 
// HelpString: Microsoft Disk Quota Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  DiskQuotaTypeLibraryMajorVersion = 1;
  DiskQuotaTypeLibraryMinorVersion = 0;

  LIBID_DiskQuotaTypeLibrary: TGUID = '{7988B57C-EC89-11CF-9C00-00AA00A14F56}';

  IID_DIDiskQuotaUser: TGUID = '{7988B57A-EC89-11CF-9C00-00AA00A14F56}';
  DIID_DIDiskQuotaControlEvents: TGUID = '{7988B581-EC89-11CF-9C00-00AA00A14F56}';
  IID_DIDiskQuotaControl: TGUID = '{7988B575-EC89-11CF-9C00-00AA00A14F56}';
  IID_IDiskQuotaControlEvents: TGUID = '{7988B579-EC89-11CF-9C00-00AA00A14F56}';
  CLASS_DiskQuotaControl: TGUID = '{7988B571-EC89-11CF-9C00-00AA00A14F56}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum AccountStatusConstants
type
  AccountStatusConstants = TOleEnum;
const
  dqAcctResolved = $00000000;
  dqAcctUnavailable = $00000001;
  dqAcctDeleted = $00000002;
  dqAcctInvalid = $00000003;
  dqAcctUnknown = $00000004;
  dqAcctUnresolved = $00000005;

// Constants for enum QuotaStateConstants
type
  QuotaStateConstants = TOleEnum;
const
  dqStateDisable = $00000000;
  dqStateTrack = $00000001;
  dqStateEnforce = $00000002;

// Constants for enum UserNameResolutionConstants
type
  UserNameResolutionConstants = TOleEnum;
const
  dqResolveNone = $00000000;
  dqResolveSync = $00000001;
  dqResolveAsync = $00000002;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  DIDiskQuotaUser = interface;
  DIDiskQuotaUserDisp = dispinterface;
  DIDiskQuotaControlEvents = dispinterface;
  DIDiskQuotaControl = interface;
  DIDiskQuotaControlDisp = dispinterface;
  IDiskQuotaControlEvents = interface;
  IDiskQuotaControlEventsDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  DiskQuotaControl = DIDiskQuotaControl;


// *********************************************************************//
// Interface: DIDiskQuotaUser
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B57A-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  DIDiskQuotaUser = interface(IDispatch)
    ['{7988B57A-EC89-11CF-9C00-00AA00A14F56}']
    function Get_ID: Integer; safecall;
    function Get_AccountContainerName: WideString; safecall;
    function Get_LogonName: WideString; safecall;
    function Get_DisplayName: WideString; safecall;
    function Get_QuotaThreshold: Double; safecall;
    procedure Set_QuotaThreshold(pThreshold: Double); safecall;
    function Get_QuotaThresholdText: WideString; safecall;
    function Get_QuotaLimit: Double; safecall;
    procedure Set_QuotaLimit(pLimit: Double); safecall;
    function Get_QuotaLimitText: WideString; safecall;
    function Get_QuotaUsed: Double; safecall;
    function Get_QuotaUsedText: WideString; safecall;
    function Get_AccountStatus: AccountStatusConstants; safecall;
    procedure Invalidate; safecall;
    property ID: Integer read Get_ID;
    property AccountContainerName: WideString read Get_AccountContainerName;
    property LogonName: WideString read Get_LogonName;
    property DisplayName: WideString read Get_DisplayName;
    property QuotaThreshold: Double read Get_QuotaThreshold write Set_QuotaThreshold;
    property QuotaThresholdText: WideString read Get_QuotaThresholdText;
    property QuotaLimit: Double read Get_QuotaLimit write Set_QuotaLimit;
    property QuotaLimitText: WideString read Get_QuotaLimitText;
    property QuotaUsed: Double read Get_QuotaUsed;
    property QuotaUsedText: WideString read Get_QuotaUsedText;
    property AccountStatus: AccountStatusConstants read Get_AccountStatus;
  end;

// *********************************************************************//
// DispIntf:  DIDiskQuotaUserDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B57A-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  DIDiskQuotaUserDisp = dispinterface
    ['{7988B57A-EC89-11CF-9C00-00AA00A14F56}']
    property ID: Integer readonly dispid 1610743808;
    property AccountContainerName: WideString readonly dispid 1610743809;
    property LogonName: WideString readonly dispid 1610743810;
    property DisplayName: WideString readonly dispid 1610743811;
    property QuotaThreshold: Double dispid 1610743812;
    property QuotaThresholdText: WideString readonly dispid 1610743814;
    property QuotaLimit: Double dispid 1610743815;
    property QuotaLimitText: WideString readonly dispid 1610743817;
    property QuotaUsed: Double readonly dispid 1610743818;
    property QuotaUsedText: WideString readonly dispid 1610743819;
    property AccountStatus: AccountStatusConstants readonly dispid 1610743820;
    procedure Invalidate; dispid 1610743821;
  end;

// *********************************************************************//
// DispIntf:  DIDiskQuotaControlEvents
// Flags:     (4224) NonExtensible Dispatchable
// GUID:      {7988B581-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  DIDiskQuotaControlEvents = dispinterface
    ['{7988B581-EC89-11CF-9C00-00AA00A14F56}']
    procedure OnUserNameChanged(const pUser: DIDiskQuotaUser); dispid 1;
  end;

// *********************************************************************//
// Interface: DIDiskQuotaControl
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B575-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  DIDiskQuotaControl = interface(IDispatch)
    ['{7988B575-EC89-11CF-9C00-00AA00A14F56}']
    procedure Set_QuotaState(pState: QuotaStateConstants); safecall;
    function Get_QuotaState: QuotaStateConstants; safecall;
    function Get_QuotaFileIncomplete: WordBool; safecall;
    function Get_QuotaFileRebuilding: WordBool; safecall;
    procedure Set_LogQuotaThreshold(pbLogThreshold: WordBool); safecall;
    function Get_LogQuotaThreshold: WordBool; safecall;
    procedure Set_LogQuotaLimit(pbLogLimit: WordBool); safecall;
    function Get_LogQuotaLimit: WordBool; safecall;
    procedure Set_DefaultQuotaThreshold(pThreshold: Double); safecall;
    function Get_DefaultQuotaThreshold: Double; safecall;
    function Get_DefaultQuotaThresholdText: WideString; safecall;
    procedure Set_DefaultQuotaLimit(pLimit: Double); safecall;
    function Get_DefaultQuotaLimit: Double; safecall;
    function Get_DefaultQuotaLimitText: WideString; safecall;
    procedure Set_UserNameResolution(pResolutionType: UserNameResolutionConstants); safecall;
    function Get_UserNameResolution: UserNameResolutionConstants; safecall;
    procedure Initialize(const path: WideString; bReadWrite: WordBool); safecall;
    procedure ShutdownNameResolution; safecall;
    function AddUser(const LogonName: WideString): DIDiskQuotaUser; safecall;
    procedure DeleteUser(const pUser: DIDiskQuotaUser); safecall;
    function FindUser(const LogonName: WideString): DIDiskQuotaUser; safecall;
    procedure InvalidateSidNameCache; safecall;
    procedure GiveUserNameResolutionPriority(const pUser: DIDiskQuotaUser); safecall;
    function TranslateLogonNameToSID(const LogonName: WideString): WideString; safecall;
    function _NewEnum: IDispatch; safecall;
    property QuotaState: QuotaStateConstants read Get_QuotaState write Set_QuotaState;
    property QuotaFileIncomplete: WordBool read Get_QuotaFileIncomplete;
    property QuotaFileRebuilding: WordBool read Get_QuotaFileRebuilding;
    property LogQuotaThreshold: WordBool read Get_LogQuotaThreshold write Set_LogQuotaThreshold;
    property LogQuotaLimit: WordBool read Get_LogQuotaLimit write Set_LogQuotaLimit;
    property DefaultQuotaThreshold: Double read Get_DefaultQuotaThreshold write Set_DefaultQuotaThreshold;
    property DefaultQuotaThresholdText: WideString read Get_DefaultQuotaThresholdText;
    property DefaultQuotaLimit: Double read Get_DefaultQuotaLimit write Set_DefaultQuotaLimit;
    property DefaultQuotaLimitText: WideString read Get_DefaultQuotaLimitText;
    property UserNameResolution: UserNameResolutionConstants read Get_UserNameResolution write Set_UserNameResolution;
  end;

// *********************************************************************//
// DispIntf:  DIDiskQuotaControlDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B575-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  DIDiskQuotaControlDisp = dispinterface
    ['{7988B575-EC89-11CF-9C00-00AA00A14F56}']
    property QuotaState: QuotaStateConstants dispid 1610743808;
    property QuotaFileIncomplete: WordBool readonly dispid 1610743810;
    property QuotaFileRebuilding: WordBool readonly dispid 1610743811;
    property LogQuotaThreshold: WordBool dispid 1610743812;
    property LogQuotaLimit: WordBool dispid 1610743814;
    property DefaultQuotaThreshold: Double dispid 1610743816;
    property DefaultQuotaThresholdText: WideString readonly dispid 1610743818;
    property DefaultQuotaLimit: Double dispid 1610743819;
    property DefaultQuotaLimitText: WideString readonly dispid 1610743821;
    property UserNameResolution: UserNameResolutionConstants dispid 1610743822;
    procedure Initialize(const path: WideString; bReadWrite: WordBool); dispid 1610743824;
    procedure ShutdownNameResolution; dispid 1610743825;
    function AddUser(const LogonName: WideString): DIDiskQuotaUser; dispid 1610743826;
    procedure DeleteUser(const pUser: DIDiskQuotaUser); dispid 1610743827;
    function FindUser(const LogonName: WideString): DIDiskQuotaUser; dispid 1610743828;
    procedure InvalidateSidNameCache; dispid 1610743829;
    procedure GiveUserNameResolutionPriority(const pUser: DIDiskQuotaUser); dispid 1610743830;
    function TranslateLogonNameToSID(const LogonName: WideString): WideString; dispid 1610743831;
    function _NewEnum: IDispatch; dispid -4;
  end;

// *********************************************************************//
// Interface: IDiskQuotaControlEvents
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B579-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  IDiskQuotaControlEvents = interface(IDispatch)
    ['{7988B579-EC89-11CF-9C00-00AA00A14F56}']
    procedure OnUserNameChanged(const pUser: DIDiskQuotaUser); safecall;
  end;

// *********************************************************************//
// DispIntf:  IDiskQuotaControlEventsDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {7988B579-EC89-11CF-9C00-00AA00A14F56}
// *********************************************************************//
  IDiskQuotaControlEventsDisp = dispinterface
    ['{7988B579-EC89-11CF-9C00-00AA00A14F56}']
    procedure OnUserNameChanged(const pUser: DIDiskQuotaUser); dispid 1610743808;
  end;

// *********************************************************************//
// The Class CoDiskQuotaControl provides a Create and CreateRemote method to          
// create instances of the default interface DIDiskQuotaControl exposed by              
// the CoClass DiskQuotaControl. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoDiskQuotaControl = class
    class function Create: DIDiskQuotaControl;
    class function CreateRemote(const MachineName: string): DIDiskQuotaControl;
  end;

implementation

uses ComObj;

class function CoDiskQuotaControl.Create: DIDiskQuotaControl;
begin
  Result := CreateComObject(CLASS_DiskQuotaControl) as DIDiskQuotaControl;
end;

class function CoDiskQuotaControl.CreateRemote(const MachineName: string): DIDiskQuotaControl;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_DiskQuotaControl) as DIDiskQuotaControl;
end;

end.
