unit NetworkPolicy;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:26:00 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\iasnap.dll (1)
// LIBID: {6BC098A0-0CE6-11D1-BAAE-00C04FC2E20D}
// LCID: 0
// Helpfile: 
// HelpString: IAS Network Access Policy 1.0
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  NetworkPolicyMajorVersion = 1;
  NetworkPolicyMinorVersion = 0;

  LIBID_NetworkPolicy: TGUID = '{6BC098A0-0CE6-11D1-BAAE-00C04FC2E20D}';

  IID_ICondition: TGUID = '{6BC098A1-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IRequest: TGUID = '{6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IRequestSource: TGUID = '{6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IConditionText: TGUID = '{6BC098A2-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_AttributeMatch: TGUID = '{6BC098A4-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_NTGroups: TGUID = '{6BC098A5-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_TimeOfDay: TGUID = '{6BC098A6-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IRequestHandler: TGUID = '{6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IIasComponent: TGUID = '{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}';
  IID_IQualityControl: TGUID = '{6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_PolicyEnforcer: TGUID = '{6BC098A7-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_MachineNTGroups: TGUID = '{6BC096E0-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_UserNTGroups: TGUID = '{6BC096E1-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_SHV: TGUID = '{6BC096E2-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_EAPTypes: TGUID = '{6BC098AC-0CE6-11D1-BAAE-00C04FC2E20D}';
  CLASS_MachineInventory: TGUID = '{6B750899-F157-47D7-9C08-257E7A35141D}';
  CLASS_AbsoluteTime: TGUID = '{6BC098AD-0CE6-11D1-BAAE-00C04FC2E20D}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum _IAS_LOGICAL_TOKEN
type
  _IAS_LOGICAL_TOKEN = TOleEnum;
const
  IAS_LOGICAL_TRUE = $00000000;
  IAS_LOGICAL_FALSE = $00000001;
  IAS_LOGICAL_NOT = $00000002;
  IAS_LOGICAL_AND = $00000003;
  IAS_LOGICAL_OR = $00000004;
  IAS_LOGICAL_XOR = $00000005;
  IAS_LOGICAL_LEFT_PAREN = $00000006;
  IAS_LOGICAL_RIGHT_PAREN = $00000007;
  IAS_LOGICAL_NUM_TOKENS = $00000008;

// Constants for enum _IASPROTOCOL
type
  _IASPROTOCOL = TOleEnum;
const
  IAS_PROTOCOL_INVALID = $00000000;
  IAS_PROTOCOL_NONE = $00000001;
  IAS_PROTOCOL_RADIUS = $00000002;
  IAS_PROTOCOL_TACACSPLUS = $00000003;
  IAS_PROTOCOL_LDAP = $00000004;
  IAS_PROTOCOL_RAS = $00000005;

// Constants for enum _IASREQUESTSTATUS
type
  _IASREQUESTSTATUS = TOleEnum;
const
  IAS_REQUEST_STATUS_ABORT = $00000000;
  IAS_REQUEST_STATUS_CONTINUE = $00000001;
  IAS_REQUEST_STATUS_HANDLED = $00000002;
  IAS_REQUEST_STATUS_INVALID = $00000003;

// Constants for enum _IASRESPONSE
type
  _IASRESPONSE = TOleEnum;
const
  IAS_RESPONSE_INVALID = $00000000;
  IAS_RESPONSE_ACCESS_ACCEPT = $00000001;
  IAS_RESPONSE_ACCESS_REJECT = $00000002;
  IAS_RESPONSE_ACCESS_CHALLENGE = $00000003;
  IAS_RESPONSE_ACCOUNTING = $00000004;
  IAS_RESPONSE_DISCARD_PACKET = $00000005;
  IAS_RESPONSE_FORWARD_PACKET = $000003E7;
  IAS_RESPONSE_RAS = $000003E8;
  IAS_RESPONSE_MAX = $00000800;

// Constants for enum _QUALITYSTATUS
type
  _QUALITYSTATUS = TOleEnum;
const
  QUALITY_STATUS_INOPERABLE = $00000001;
  QUALITY_STATUS_FLOODED = $00000002;
  QUALITY_STATUS_READY = $00000003;
  QUALITY_STATUS_UNKNOWN = $00000004;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  ICondition = interface;
  IRequest = interface;
  IRequestSource = interface;
  IConditionText = interface;
  IRequestHandler = interface;
  IRequestHandlerDisp = dispinterface;
  IIasComponent = interface;
  IIasComponentDisp = dispinterface;
  IQualityControl = interface;
  IQualityControlDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  AttributeMatch = ICondition;
  NTGroups = ICondition;
  TimeOfDay = ICondition;
  PolicyEnforcer = IRequestHandler;
  MachineNTGroups = ICondition;
  UserNTGroups = ICondition;
  SHV = ICondition;
  EAPTypes = ICondition;
  MachineInventory = ICondition;
  AbsoluteTime = ICondition;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  POleVariant1 = ^OleVariant; {*}

  IASREQUESTSTATUS = _IASREQUESTSTATUS; 

// *********************************************************************//
// Interface: ICondition
// Flags:     (256) OleAutomation
// GUID:      {6BC098A1-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  ICondition = interface(IUnknown)
    ['{6BC098A1-0CE6-11D1-BAAE-00C04FC2E20D}']
    function IsTrue(const pRequest: IRequest; out pVal: WordBool): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IRequest
// Flags:     (0)
// GUID:      {6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequest = interface(IUnknown)
    ['{6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D}']
    function Get_Request(out pVal: Integer): HResult; stdcall;
    function Set_Request(pVal: Integer): HResult; stdcall;
    function Get_Response(out pVal: Integer): HResult; stdcall;
    function Get_Reason(out pVal: Integer): HResult; stdcall;
    function Get_Protocol(out pVal: _IASPROTOCOL): HResult; stdcall;
    function Set_Protocol(pVal: _IASPROTOCOL): HResult; stdcall;
    function Get_Source(out pVal: IRequestSource): HResult; stdcall;
    function Set_Source(const pVal: IRequestSource): HResult; stdcall;
    function Get_RoutingType(out pVal: Integer): HResult; stdcall;
    function Set_RoutingType(pVal: Integer): HResult; stdcall;
    function SetResponse(eResponse: _IASRESPONSE; lReason: Integer): HResult; stdcall;
    function ReturnToSource(eStatus: IASREQUESTSTATUS): HResult; stdcall;
    function Get_ErrorCode(out pVal: HResult): HResult; stdcall;
    function Set_ErrorCode(pVal: HResult): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IRequestSource
// Flags:     (256) OleAutomation
// GUID:      {6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequestSource = interface(IUnknown)
    ['{6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D}']
    function OnRequestComplete(const pRequest: IRequest; eStatus: IASREQUESTSTATUS): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IConditionText
// Flags:     (256) OleAutomation
// GUID:      {6BC098A2-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IConditionText = interface(IUnknown)
    ['{6BC098A2-0CE6-11D1-BAAE-00C04FC2E20D}']
    function Get_ConditionText(out pVal: WideString): HResult; stdcall;
    function Set_ConditionText(const pVal: WideString): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IRequestHandler
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequestHandler = interface(IDispatch)
    ['{6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure OnRequest(const pRequest: IRequest); safecall;
  end;

// *********************************************************************//
// DispIntf:  IRequestHandlerDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IRequestHandlerDisp = dispinterface
    ['{6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure OnRequest(const pRequest: IRequest); dispid 1;
  end;

// *********************************************************************//
// Interface: IIasComponent
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IIasComponent = interface(IDispatch)
    ['{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure Initialize; safecall;
    procedure Shutdown; safecall;
    procedure GetProperty(Id: Integer; var pValue: OleVariant); safecall;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); safecall;
    procedure InitNew; safecall;
    procedure Suspend; safecall;
    procedure Resume; safecall;
  end;

// *********************************************************************//
// DispIntf:  IIasComponentDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IIasComponentDisp = dispinterface
    ['{6BC096B4-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure Initialize; dispid 1;
    procedure Shutdown; dispid 2;
    procedure GetProperty(Id: Integer; var pValue: OleVariant); dispid 3;
    procedure PutProperty(Id: Integer; var pValue: OleVariant); dispid 4;
    procedure InitNew; dispid 5;
    procedure Suspend; dispid 6;
    procedure Resume; dispid 7;
  end;

// *********************************************************************//
// Interface: IQualityControl
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IQualityControl = interface(IDispatch)
    ['{6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure OnQualityNotify(eQualityStatus: _QUALITYSTATUS; lObjectID: Integer); safecall;
    procedure SetQualityNotify(const pQualityControl: IQualityControl); safecall;
  end;

// *********************************************************************//
// DispIntf:  IQualityControlDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D}
// *********************************************************************//
  IQualityControlDisp = dispinterface
    ['{6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D}']
    procedure OnQualityNotify(eQualityStatus: _QUALITYSTATUS; lObjectID: Integer); dispid 1610743808;
    procedure SetQualityNotify(const pQualityControl: IQualityControl); dispid 1610743809;
  end;

// *********************************************************************//
// The Class CoAttributeMatch provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass AttributeMatch. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoAttributeMatch = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoNTGroups provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass NTGroups. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoNTGroups = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoTimeOfDay provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass TimeOfDay. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoTimeOfDay = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoPolicyEnforcer provides a Create and CreateRemote method to          
// create instances of the default interface IRequestHandler exposed by              
// the CoClass PolicyEnforcer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoPolicyEnforcer = class
    class function Create: IRequestHandler;
    class function CreateRemote(const MachineName: string): IRequestHandler;
  end;

// *********************************************************************//
// The Class CoMachineNTGroups provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass MachineNTGroups. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoMachineNTGroups = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoUserNTGroups provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass UserNTGroups. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoUserNTGroups = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoSHV provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass SHV. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoSHV = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoEAPTypes provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass EAPTypes. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoEAPTypes = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoMachineInventory provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass MachineInventory. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoMachineInventory = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

// *********************************************************************//
// The Class CoAbsoluteTime provides a Create and CreateRemote method to          
// create instances of the default interface ICondition exposed by              
// the CoClass AbsoluteTime. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoAbsoluteTime = class
    class function Create: ICondition;
    class function CreateRemote(const MachineName: string): ICondition;
  end;

implementation

uses ComObj;

class function CoAttributeMatch.Create: ICondition;
begin
  Result := CreateComObject(CLASS_AttributeMatch) as ICondition;
end;

class function CoAttributeMatch.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_AttributeMatch) as ICondition;
end;

class function CoNTGroups.Create: ICondition;
begin
  Result := CreateComObject(CLASS_NTGroups) as ICondition;
end;

class function CoNTGroups.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_NTGroups) as ICondition;
end;

class function CoTimeOfDay.Create: ICondition;
begin
  Result := CreateComObject(CLASS_TimeOfDay) as ICondition;
end;

class function CoTimeOfDay.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_TimeOfDay) as ICondition;
end;

class function CoPolicyEnforcer.Create: IRequestHandler;
begin
  Result := CreateComObject(CLASS_PolicyEnforcer) as IRequestHandler;
end;

class function CoPolicyEnforcer.CreateRemote(const MachineName: string): IRequestHandler;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_PolicyEnforcer) as IRequestHandler;
end;

class function CoMachineNTGroups.Create: ICondition;
begin
  Result := CreateComObject(CLASS_MachineNTGroups) as ICondition;
end;

class function CoMachineNTGroups.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_MachineNTGroups) as ICondition;
end;

class function CoUserNTGroups.Create: ICondition;
begin
  Result := CreateComObject(CLASS_UserNTGroups) as ICondition;
end;

class function CoUserNTGroups.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_UserNTGroups) as ICondition;
end;

class function CoSHV.Create: ICondition;
begin
  Result := CreateComObject(CLASS_SHV) as ICondition;
end;

class function CoSHV.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_SHV) as ICondition;
end;

class function CoEAPTypes.Create: ICondition;
begin
  Result := CreateComObject(CLASS_EAPTypes) as ICondition;
end;

class function CoEAPTypes.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_EAPTypes) as ICondition;
end;

class function CoMachineInventory.Create: ICondition;
begin
  Result := CreateComObject(CLASS_MachineInventory) as ICondition;
end;

class function CoMachineInventory.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_MachineInventory) as ICondition;
end;

class function CoAbsoluteTime.Create: ICondition;
begin
  Result := CreateComObject(CLASS_AbsoluteTime) as ICondition;
end;

class function CoAbsoluteTime.CreateRemote(const MachineName: string): ICondition;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_AbsoluteTime) as ICondition;
end;

end.
