unit PortableDeviceConnectApiLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:44:14 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\PortableDeviceConnectApi.dll (1)
// LIBID: {8FE73967-AAE2-4D77-9921-0C4962631056}
// LCID: 0
// Helpfile: 
// HelpString: PortableDeviceConnectApiLib 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  PortableDeviceConnectApiLibMajorVersion = 1;
  PortableDeviceConnectApiLibMinorVersion = 0;

  LIBID_PortableDeviceConnectApiLib: TGUID = '{8FE73967-AAE2-4D77-9921-0C4962631056}';

  IID_IEnumPortableDeviceConnectors: TGUID = '{BFDEF549-9247-454F-BD82-06FE80853FAA}';
  CLASS_EnumBthMtpConnectors: TGUID = '{A1570149-E645-4F43-8B0D-409B061DB2FC}';
  IID_IPortableDeviceConnector: TGUID = '{625E2DF8-6392-4CF0-9AD1-3CFA5F17775C}';
  IID_IConnectionRequestCallback: TGUID = '{272C9AE0-7161-4AE0-91BD-9F448EE9C427}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IEnumPortableDeviceConnectors = interface;
  IPortableDeviceConnector = interface;
  IConnectionRequestCallback = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  EnumBthMtpConnectors = IEnumPortableDeviceConnectors;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PUserType1 = ^_DEVPROPKEY; {*}
  PByte1 = ^Byte; {*}

  _DEVPROPKEY = packed record
    fmtid: TGUID;
    pid: LongWord;
  end;


// *********************************************************************//
// Interface: IEnumPortableDeviceConnectors
// Flags:     (0)
// GUID:      {BFDEF549-9247-454F-BD82-06FE80853FAA}
// *********************************************************************//
  IEnumPortableDeviceConnectors = interface(IUnknown)
    ['{BFDEF549-9247-454F-BD82-06FE80853FAA}']
    function Next(cRequested: SYSUINT; out pConnectors: IPortableDeviceConnector; 
                  var pcFetched: SYSUINT): HResult; stdcall;
    function Skip(cConnectors: SYSUINT): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out ppEnum: IEnumPortableDeviceConnectors): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IPortableDeviceConnector
// Flags:     (0)
// GUID:      {625E2DF8-6392-4CF0-9AD1-3CFA5F17775C}
// *********************************************************************//
  IPortableDeviceConnector = interface(IUnknown)
    ['{625E2DF8-6392-4CF0-9AD1-3CFA5F17775C}']
    function Connect(const pCallback: IConnectionRequestCallback): HResult; stdcall;
    function Disconnect(const pCallback: IConnectionRequestCallback): HResult; stdcall;
    function Cancel(const pCallback: IConnectionRequestCallback): HResult; stdcall;
    function GetProperty(var pPropertyKey: _DEVPROPKEY; out pPropertyType: LongWord; 
                         out ppData: PByte1; out pcbData: SYSUINT): HResult; stdcall;
    function SetProperty(var pPropertyKey: _DEVPROPKEY; PropertyType: LongWord; var pData: Byte; 
                         cbData: SYSUINT): HResult; stdcall;
    function GetPnPID(out ppwszPnPID: PWideChar): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IConnectionRequestCallback
// Flags:     (0)
// GUID:      {272C9AE0-7161-4AE0-91BD-9F448EE9C427}
// *********************************************************************//
  IConnectionRequestCallback = interface(IUnknown)
    ['{272C9AE0-7161-4AE0-91BD-9F448EE9C427}']
    function OnComplete(hrStatus: HResult): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoEnumBthMtpConnectors provides a Create and CreateRemote method to          
// create instances of the default interface IEnumPortableDeviceConnectors exposed by              
// the CoClass EnumBthMtpConnectors. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoEnumBthMtpConnectors = class
    class function Create: IEnumPortableDeviceConnectors;
    class function CreateRemote(const MachineName: string): IEnumPortableDeviceConnectors;
  end;

implementation

uses ComObj;

class function CoEnumBthMtpConnectors.Create: IEnumPortableDeviceConnectors;
begin
  Result := CreateComObject(CLASS_EnumBthMtpConnectors) as IEnumPortableDeviceConnectors;
end;

class function CoEnumBthMtpConnectors.CreateRemote(const MachineName: string): IEnumPortableDeviceConnectors;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_EnumBthMtpConnectors) as IEnumPortableDeviceConnectors;
end;

end.
