unit RendezvousSessionLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 3:52:55 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: rendezvousSession.tlb (1)
// LIBID: {EFD856A4-5A85-4A1B-ADD5-2EADACE6F6A2}
// LCID: 0
// Helpfile: 
// HelpString: Rendezvous 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  RendezvousSessionLibMajorVersion = 1;
  RendezvousSessionLibMinorVersion = 0;

  LIBID_RendezvousSessionLib: TGUID = '{EFD856A4-5A85-4A1B-ADD5-2EADACE6F6A2}';

  IID_IRendezvousSession: TGUID = '{9BA4B1DD-8B0C-48B7-9E7C-2F25857C8DF5}';
  DIID_DRendezvousSessionEvents: TGUID = '{3FA19CF8-64C4-4F53-AE60-635B3806ECA6}';
  IID_IRendezvousApplication: TGUID = '{4F4D070B-A275-49FB-B10D-8EC26387B50D}';
  CLASS_RendezvousApplication: TGUID = '{0B7E019A-B5DE-47FA-8966-9082F82FB192}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum __MIDL___MIDL_itf_rendezvoussession_0000_0000_0001
type
  __MIDL___MIDL_itf_rendezvoussession_0000_0000_0001 = TOleEnum;
const
  RSS_UNKNOWN = $00000000;
  RSS_READY = $00000001;
  RSS_INVITATION = $00000002;
  RSS_ACCEPTED = $00000003;
  RSS_CONNECTED = $00000004;
  RSS_CANCELLED = $00000005;
  RSS_DECLINED = $00000006;
  RSS_TERMINATED = $00000007;

// Constants for enum __MIDL___MIDL_itf_rendezvoussession_0000_0000_0002
type
  __MIDL___MIDL_itf_rendezvoussession_0000_0000_0002 = TOleEnum;
const
  RSF_NONE = $00000000;
  RSF_INVITER = $00000001;
  RSF_INVITEE = $00000002;
  RSF_ORIGINAL_INVITER = $00000004;
  RSF_REMOTE_LEGACYSESSION = $00000008;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IRendezvousSession = interface;
  DRendezvousSessionEvents = dispinterface;
  IRendezvousApplication = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  RendezvousApplication = IRendezvousApplication;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//

  RENDEZVOUS_SESSION_STATE = __MIDL___MIDL_itf_rendezvoussession_0000_0000_0001; 
  RENDEZVOUS_SESSION_FLAGS = __MIDL___MIDL_itf_rendezvoussession_0000_0000_0002; 

// *********************************************************************//
// Interface: IRendezvousSession
// Flags:     (256) OleAutomation
// GUID:      {9BA4B1DD-8B0C-48B7-9E7C-2F25857C8DF5}
// *********************************************************************//
  IRendezvousSession = interface(IUnknown)
    ['{9BA4B1DD-8B0C-48B7-9E7C-2F25857C8DF5}']
    function Get_State(out pSessionState: RENDEZVOUS_SESSION_STATE): HResult; stdcall;
    function Get_RemoteUser(out bstrUserName: WideString): HResult; stdcall;
    function Get_Flags(out pFlags: Integer): HResult; stdcall;
    function SendContextData(const bstrData: WideString): HResult; stdcall;
    function Terminate(hr: HResult; const bstrAppData: WideString): HResult; stdcall;
  end;

// *********************************************************************//
// DispIntf:  DRendezvousSessionEvents
// Flags:     (4096) Dispatchable
// GUID:      {3FA19CF8-64C4-4F53-AE60-635B3806ECA6}
// *********************************************************************//
  DRendezvousSessionEvents = dispinterface
    ['{3FA19CF8-64C4-4F53-AE60-635B3806ECA6}']
    procedure OnStateChanged(prevState: RENDEZVOUS_SESSION_STATE); dispid 5;
    procedure OnTermination(lReturnCode: Integer; const bstrData: WideString); dispid 6;
    procedure OnContextData(const bstrData: WideString); dispid 7;
    procedure OnSendError(lReturnCode: Integer); dispid 8;
  end;

// *********************************************************************//
// Interface: IRendezvousApplication
// Flags:     (256) OleAutomation
// GUID:      {4F4D070B-A275-49FB-B10D-8EC26387B50D}
// *********************************************************************//
  IRendezvousApplication = interface(IUnknown)
    ['{4F4D070B-A275-49FB-B10D-8EC26387B50D}']
    function SetRendezvousSession(const pRendezvousSession: IUnknown): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoRendezvousApplication provides a Create and CreateRemote method to          
// create instances of the default interface IRendezvousApplication exposed by              
// the CoClass RendezvousApplication. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoRendezvousApplication = class
    class function Create: IRendezvousApplication;
    class function CreateRemote(const MachineName: string): IRendezvousApplication;
  end;

implementation

uses ComObj;

class function CoRendezvousApplication.Create: IRendezvousApplication;
begin
  Result := CreateComObject(CLASS_RendezvousApplication) as IRendezvousApplication;
end;

class function CoRendezvousApplication.CreateRemote(const MachineName: string): IRendezvousApplication;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_RendezvousApplication) as IRendezvousApplication;
end;

end.
