unit ScriptSigner;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:55:29 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\wshext.dll (1)
// LIBID: {95CEF0E5-A4ED-4703-B501-AE70A153697A}
// LCID: 0
// Helpfile: 
// HelpString: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  ScriptSignerMajorVersion = 1;
  ScriptSignerMinorVersion = 0;

  LIBID_ScriptSigner: TGUID = '{95CEF0E5-A4ED-4703-B501-AE70A153697A}';

  IID_IScriptSigningControl: TGUID = '{97D8B206-3401-4006-B872-F95A679D7CA3}';
  CLASS_Signer: TGUID = '{7E48C5CF-72F6-4C84-9F43-B04B87B31243}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IScriptSigningControl = interface;
  IScriptSigningControlDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Signer = IScriptSigningControl;


// *********************************************************************//
// Interface: IScriptSigningControl
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {97D8B206-3401-4006-B872-F95A679D7CA3}
// *********************************************************************//
  IScriptSigningControl = interface(IDispatch)
    ['{97D8B206-3401-4006-B872-F95A679D7CA3}']
    function Sign(const FileExtension: WideString; const Text: WideString; 
                  const Certificate: WideString; const Store: WideString): WideString; safecall;
    procedure SignFile(const FileName: WideString; const Certificate: WideString; 
                       const Store: WideString); safecall;
    function Verify(const FileExtension: WideString; const Text: WideString; ShowUI: WordBool): WordBool; safecall;
    function VerifyFile(const FileName: WideString; ShowUI: WordBool): WordBool; safecall;
  end;

// *********************************************************************//
// DispIntf:  IScriptSigningControlDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {97D8B206-3401-4006-B872-F95A679D7CA3}
// *********************************************************************//
  IScriptSigningControlDisp = dispinterface
    ['{97D8B206-3401-4006-B872-F95A679D7CA3}']
    function Sign(const FileExtension: WideString; const Text: WideString; 
                  const Certificate: WideString; const Store: WideString): WideString; dispid 1;
    procedure SignFile(const FileName: WideString; const Certificate: WideString; 
                       const Store: WideString); dispid 2;
    function Verify(const FileExtension: WideString; const Text: WideString; ShowUI: WordBool): WordBool; dispid 3;
    function VerifyFile(const FileName: WideString; ShowUI: WordBool): WordBool; dispid 4;
  end;

// *********************************************************************//
// The Class CoSigner provides a Create and CreateRemote method to          
// create instances of the default interface IScriptSigningControl exposed by              
// the CoClass Signer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoSigner = class
    class function Create: IScriptSigningControl;
    class function CreateRemote(const MachineName: string): IScriptSigningControl;
  end;

implementation

uses ComObj;

class function CoSigner.Create: IScriptSigningControl;
begin
  Result := CreateComObject(CLASS_Signer) as IScriptSigningControl;
end;

class function CoSigner.CreateRemote(const MachineName: string): IScriptSigningControl;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Signer) as IScriptSigningControl;
end;

end.
