unit VssEventLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:23:23 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\eventcls.dll (1)
// LIBID: {3DE641EF-0556-4D4A-98D5-7DBD8AD5D70F}
// LCID: 0
// Helpfile: 
// HelpString: VssEvent 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  VssEventLibMajorVersion = 1;
  VssEventLibMinorVersion = 0;

  LIBID_VssEventLib: TGUID = '{3DE641EF-0556-4D4A-98D5-7DBD8AD5D70F}';

  IID_IVssWriter: TGUID = '{6050B110-CE87-4126-A114-50AEFCFC95F8}';
  CLASS_VssEvent: TGUID = '{FAF53CC4-BD73-4E36-83F1-2B23F46E513E}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IVssWriter = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  VssEvent = IVssWriter;


// *********************************************************************//
// Interface: IVssWriter
// Flags:     (256) OleAutomation
// GUID:      {6050B110-CE87-4126-A114-50AEFCFC95F8}
// *********************************************************************//
  IVssWriter = interface(IUnknown)
    ['{6050B110-CE87-4126-A114-50AEFCFC95F8}']
    function RequestWriterInfo(const bstrSnapshotSetId: WideString; bWriterMetadata: Integer; 
                               bWriterState: Integer; const pWriterCallback: IDispatch): HResult; stdcall;
    function PrepareForBackup(const bstrSnapshotSetId: WideString; const pWriterCallback: IDispatch): HResult; stdcall;
    function PrepareForSnapshot(const bstrSnapshotSetId: WideString; 
                                const pWriterCallback: IDispatch; const VolumeNamesList: WideString): HResult; stdcall;
    function Freeze(const bstrSnapshotSetId: WideString; nApplicationLevel: SYSINT): HResult; stdcall;
    function Thaw(const bstrSnapshotSetId: WideString): HResult; stdcall;
    function PostSnapshot(const bstrSnapshotSetId: WideString; const pWriterCallback: IDispatch; 
                          const SnapshotDevicesList: WideString): HResult; stdcall;
    function BackupComplete(const bstrSnapshotSetId: WideString; const pWriterCallback: IDispatch): HResult; stdcall;
    function BackupShutdown(const bstrSnapshotSetId: WideString): HResult; stdcall;
    function Abort(const bstrSnapshotSetId: WideString): HResult; stdcall;
    function PreRestore(const pWriterCallback: IDispatch): HResult; stdcall;
    function PostRestore(const pWriterCallback: IDispatch): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoVssEvent provides a Create and CreateRemote method to          
// create instances of the default interface IVssWriter exposed by              
// the CoClass VssEvent. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoVssEvent = class
    class function Create: IVssWriter;
    class function CreateRemote(const MachineName: string): IVssWriter;
  end;

implementation

uses ComObj;

class function CoVssEvent.Create: IVssWriter;
begin
  Result := CreateComObject(CLASS_VssEvent) as IVssWriter;
end;

class function CoVssEvent.CreateRemote(const MachineName: string): IVssWriter;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_VssEvent) as IVssWriter;
end;

end.
