unit WMDMLogLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:54:22 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\wmdmlog.dll (1)
// LIBID: {110A3201-5A79-11D3-8D78-444553540000}
// LCID: 0
// Helpfile: 
// HelpString: WmdmLog 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WMDMLogLibMajorVersion = 1;
  WMDMLogLibMinorVersion = 0;

  LIBID_WMDMLogLib: TGUID = '{110A3201-5A79-11D3-8D78-444553540000}';

  IID_IWMDMLogger: TGUID = '{110A3200-5A79-11D3-8D78-444553540000}';
  CLASS_WMDMLogger: TGUID = '{110A3202-5A79-11D3-8D78-444553540000}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IWMDMLogger = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  WMDMLogger = IWMDMLogger;


// *********************************************************************//
// Interface: IWMDMLogger
// Flags:     (0)
// GUID:      {110A3200-5A79-11D3-8D78-444553540000}
// *********************************************************************//
  IWMDMLogger = interface(IUnknown)
    ['{110A3200-5A79-11D3-8D78-444553540000}']
    function IsEnabled(out pfEnabled: Integer): HResult; stdcall;
    function Enable(fEnable: Integer): HResult; stdcall;
    function GetLogFileName(pszFilename: PChar; nMaxChars: SYSUINT): HResult; stdcall;
    function SetLogFileName(pszFilename: PChar): HResult; stdcall;
    function LogString(dwFlags: LongWord; pszSrcName: PChar; pszLog: PChar): HResult; stdcall;
    function LogDword(dwFlags: LongWord; pszSrcName: PChar; pszLogFormat: PChar; dwLog: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function GetSizeParams(out pdwMaxSize: LongWord; out pdwShrinkToSize: LongWord): HResult; stdcall;
    function SetSizeParams(dwMaxSize: LongWord; dwShrinkToSize: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoWMDMLogger provides a Create and CreateRemote method to          
// create instances of the default interface IWMDMLogger exposed by              
// the CoClass WMDMLogger. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoWMDMLogger = class
    class function Create: IWMDMLogger;
    class function CreateRemote(const MachineName: string): IWMDMLogger;
  end;

implementation

uses ComObj;

class function CoWMDMLogger.Create: IWMDMLogger;
begin
  Result := CreateComObject(CLASS_WMDMLogger) as IWMDMLogger;
end;

class function CoWMDMLogger.CreateRemote(const MachineName: string): IWMDMLogger;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_WMDMLogger) as IWMDMLogger;
end;

end.
