unit WindowsInstaller;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:36:35 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\msi.dll (1)
// LIBID: {000C1092-0000-0000-C000-000000000046}
// LCID: 409
// Helpfile: C:\Windows\system32\Msi.CHM
// HelpString: Microsoft Windows Installer Object Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// Errors:
//   Hint: TypeInfo 'Record' changed to 'Record_'
//   Hint: Member 'Property' of 'Session' changed to 'Property_'
//   Hint: Parameter 'Record' of Session.FormatRecord changed to 'Record_'
//   Hint: Parameter 'Record' of Session.Message changed to 'Record_'
//   Hint: Parameter 'Property' of Session.ProductProperty changed to 'Property_'
//   Hint: Parameter 'File' of Database.Import changed to 'File_'
//   Hint: Parameter 'File' of Database.Export changed to 'File_'
//   Hint: Member 'Property' of 'SummaryInfo' changed to 'Property_'
//   Hint: Parameter 'Record' of View.Modify changed to 'Record_'
//   Hint: Member 'Property' of 'UIPreview' changed to 'Property_'
//   Hint: Parameter 'Property' of Product.SourceListInfo changed to 'Property_'
//   Hint: Parameter 'Property' of Product.SourceListInfo changed to 'Property_'
//   Hint: Parameter 'Property' of Patch.SourceListInfo changed to 'Property_'
//   Hint: Parameter 'Property' of Patch.SourceListInfo changed to 'Property_'
//   Hint: Parameter 'Property' of Patch.PatchProperty changed to 'Property_'
//   Hint: TypeInfo 'Record' changed to 'Record_'
//   Hint: Member 'Property' of 'Session' changed to 'Property_'
//   Hint: Member 'Property' of 'SummaryInfo' changed to 'Property_'
//   Hint: Member 'Property' of 'UIPreview' changed to 'Property_'
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  WindowsInstallerMajorVersion = 1;
  WindowsInstallerMinorVersion = 0;

  LIBID_WindowsInstaller: TGUID = '{000C1092-0000-0000-C000-000000000046}';

  DIID_Installer: TGUID = '{000C1090-0000-0000-C000-000000000046}';
  DIID_Record_: TGUID = '{000C1093-0000-0000-C000-000000000046}';
  DIID_Session: TGUID = '{000C109E-0000-0000-C000-000000000046}';
  DIID_Database: TGUID = '{000C109D-0000-0000-C000-000000000046}';
  DIID_SummaryInfo: TGUID = '{000C109B-0000-0000-C000-000000000046}';
  DIID_View: TGUID = '{000C109C-0000-0000-C000-000000000046}';
  DIID_UIPreview: TGUID = '{000C109A-0000-0000-C000-000000000046}';
  DIID_FeatureInfo: TGUID = '{000C109F-0000-0000-C000-000000000046}';
  DIID_RecordList: TGUID = '{000C1096-0000-0000-C000-000000000046}';
  DIID_StringList: TGUID = '{000C1095-0000-0000-C000-000000000046}';
  DIID_Product: TGUID = '{000C10A0-0000-0000-C000-000000000046}';
  DIID_Patch: TGUID = '{000C10A1-0000-0000-C000-000000000046}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum MsiUILevel
type
  MsiUILevel = TOleEnum;
const
  msiUILevelNoChange = $00000000;
  msiUILevelDefault = $00000001;
  msiUILevelNone = $00000002;
  msiUILevelBasic = $00000003;
  msiUILevelReduced = $00000004;
  msiUILevelFull = $00000005;
  msiUILevelHideCancel = $00000020;
  msiUILevelProgressOnly = $00000040;
  msiUILevelEndDialog = $00000080;
  msiUILevelSourceResOnly = $00000100;

// Constants for enum MsiReadStream
type
  MsiReadStream = TOleEnum;
const
  msiReadStreamInteger = $00000000;
  msiReadStreamBytes = $00000001;
  msiReadStreamAnsi = $00000002;
  msiReadStreamDirect = $00000003;

// Constants for enum MsiRunMode
type
  MsiRunMode = TOleEnum;
const
  msiRunModeAdmin = $00000000;
  msiRunModeAdvertise = $00000001;
  msiRunModeMaintenance = $00000002;
  msiRunModeRollbackEnabled = $00000003;
  msiRunModeLogEnabled = $00000004;
  msiRunModeOperations = $00000005;
  msiRunModeRebootAtEnd = $00000006;
  msiRunModeRebootNow = $00000007;
  msiRunModeCabinet = $00000008;
  msiRunModeSourceShortNames = $00000009;
  msiRunModeTargetShortNames = $0000000A;
  msiRunModeWindows9x = $0000000C;
  msiRunModeZawEnabled = $0000000D;
  msiRunModeScheduled = $00000010;
  msiRunModeRollback = $00000011;
  msiRunModeCommit = $00000012;

// Constants for enum MsiDatabaseState
type
  MsiDatabaseState = TOleEnum;
const
  msiDatabaseStateRead = $00000000;
  msiDatabaseStateWrite = $00000001;

// Constants for enum MsiViewModify
type
  MsiViewModify = TOleEnum;
const
  msiViewModifySeek = $FFFFFFFF;
  msiViewModifyRefresh = $00000000;
  msiViewModifyInsert = $00000001;
  msiViewModifyUpdate = $00000002;
  msiViewModifyAssign = $00000003;
  msiViewModifyReplace = $00000004;
  msiViewModifyMerge = $00000005;
  msiViewModifyDelete = $00000006;
  msiViewModifyInsertTemporary = $00000007;
  msiViewModifyValidate = $00000008;
  msiViewModifyValidateNew = $00000009;
  msiViewModifyValidateField = $0000000A;
  msiViewModifyValidateDelete = $0000000B;

// Constants for enum MsiColumnInfo
type
  MsiColumnInfo = TOleEnum;
const
  msiColumnInfoNames = $00000000;
  msiColumnInfoTypes = $00000001;

// Constants for enum MsiTransformError
type
  MsiTransformError = TOleEnum;
const
  msiTransformErrorNone = $00000000;
  msiTransformErrorAddExistingRow = $00000001;
  msiTransformErrorDeleteNonExistingRow = $00000002;
  msiTransformErrorAddExistingTable = $00000004;
  msiTransformErrorDeleteNonExistingTable = $00000008;
  msiTransformErrorUpdateNonExistingRow = $00000010;
  msiTransformErrorChangeCodePage = $00000020;
  msiTransformErrorViewTransform = $00000100;

// Constants for enum MsiEvaluateCondition
type
  MsiEvaluateCondition = TOleEnum;
const
  msiEvaluateConditionFalse = $00000000;
  msiEvaluateConditionTrue = $00000001;
  msiEvaluateConditionNone = $00000002;
  msiEvaluateConditionError = $00000003;

// Constants for enum MsiTransformValidation
type
  MsiTransformValidation = TOleEnum;
const
  msiTransformValidationNone = $00000000;
  msiTransformValidationLanguage = $00000001;
  msiTransformValidationProduct = $00000002;
  msiTransformValidationPlatform = $00000004;
  msiTransformValidationMajorVer = $00000008;
  msiTransformValidationMinorVer = $00000010;
  msiTransformValidationUpdateVer = $00000020;
  msiTransformValidationLess = $00000040;
  msiTransformValidationLessOrEqual = $00000080;
  msiTransformValidationEqual = $00000100;
  msiTransformValidationGreaterOrEqual = $00000200;
  msiTransformValidationGreater = $00000400;
  msiTransformValidationUpgradeCode = $00000800;

// Constants for enum MsiDoActionStatus
type
  MsiDoActionStatus = TOleEnum;
const
  msiDoActionStatusNoAction = $00000000;
  msiDoActionStatusSuccess = $00000001;
  msiDoActionStatusUserExit = $00000002;
  msiDoActionStatusFailure = $00000003;
  msiDoActionStatusSuspend = $00000004;
  msiDoActionStatusFinished = $00000005;
  msiDoActionStatusWrongState = $00000006;
  msiDoActionStatusBadActionData = $00000007;

// Constants for enum MsiMessageStatus
type
  MsiMessageStatus = TOleEnum;
const
  msiMessageStatusError = $FFFFFFFF;
  msiMessageStatusNone = $00000000;
  msiMessageStatusOk = $00000001;
  msiMessageStatusCancel = $00000002;
  msiMessageStatusAbort = $00000003;
  msiMessageStatusRetry = $00000004;
  msiMessageStatusIgnore = $00000005;
  msiMessageStatusYes = $00000006;
  msiMessageStatusNo = $00000007;

// Constants for enum MsiMessageType
type
  MsiMessageType = TOleEnum;
const
  msiMessageTypeFatalExit = $00000000;
  msiMessageTypeError = $01000000;
  msiMessageTypeWarning = $02000000;
  msiMessageTypeUser = $03000000;
  msiMessageTypeInfo = $04000000;
  msiMessageTypeFilesInUse = $05000000;
  msiMessageTypeResolveSource = $06000000;
  msiMessageTypeOutOfDiskSpace = $07000000;
  msiMessageTypeActionStart = $08000000;
  msiMessageTypeActionData = $09000000;
  msiMessageTypeProgress = $0A000000;
  msiMessageTypeCommonData = $0B000000;
  msiMessageTypeOk = $00000000;
  msiMessageTypeOkCancel = $00000001;
  msiMessageTypeAbortRetryIgnore = $00000002;
  msiMessageTypeYesNoCancel = $00000003;
  msiMessageTypeYesNo = $00000004;
  msiMessageTypeRetryCancel = $00000005;
  msiMessageTypeDefault1 = $00000000;
  msiMessageTypeDefault2 = $00000100;
  msiMessageTypeDefault3 = $00000200;

// Constants for enum MsiInstallState
type
  MsiInstallState = TOleEnum;
const
  msiInstallStateNotUsed = $FFFFFFF9;
  msiInstallStateBadConfig = $FFFFFFFA;
  msiInstallStateIncomplete = $FFFFFFFB;
  msiInstallStateSourceAbsent = $FFFFFFFC;
  msiInstallStateInvalidArg = $FFFFFFFE;
  msiInstallStateUnknown = $FFFFFFFF;
  msiInstallStateBroken = $00000000;
  msiInstallStateAdvertised = $00000001;
  msiInstallStateRemoved = $00000001;
  msiInstallStateAbsent = $00000002;
  msiInstallStateLocal = $00000003;
  msiInstallStateSource = $00000004;
  msiInstallStateDefault = $00000005;

// Constants for enum MsiCostTree
type
  MsiCostTree = TOleEnum;
const
  msiCostTreeSelfOnly = $00000000;
  msiCostTreeChildren = $00000001;
  msiCostTreeParents = $00000002;

// Constants for enum MsiReinstallMode
type
  MsiReinstallMode = TOleEnum;
const
  msiReinstallModeFileMissing = $00000002;
  msiReinstallModeFileOlderVersion = $00000004;
  msiReinstallModeFileEqualVersion = $00000008;
  msiReinstallModeFileExact = $00000010;
  msiReinstallModeFileVerify = $00000020;
  msiReinstallModeFileReplace = $00000040;
  msiReinstallModeMachineData = $00000080;
  msiReinstallModeUserData = $00000100;
  msiReinstallModeShortcut = $00000200;
  msiReinstallModePackage = $00000400;

// Constants for enum MsiInstallType
type
  MsiInstallType = TOleEnum;
const
  msiInstallTypeDefault = $00000000;
  msiInstallTypeNetworkImage = $00000001;
  msiInstallTypeSingleInstance = $00000002;

// Constants for enum MsiInstallMode
type
  MsiInstallMode = TOleEnum;
const
  msiInstallModeNoSourceResolution = $FFFFFFFD;
  msiInstallModeNoDetection = $FFFFFFFE;
  msiInstallModeExisting = $FFFFFFFF;
  msiInstallModeDefault = $00000000;

// Constants for enum MsiSignatureInfo
type
  MsiSignatureInfo = TOleEnum;
const
  msiSignatureInfoCertificate = $00000000;
  msiSignatureInfoHash = $00000001;

// Constants for enum MsiInstallContext
type
  MsiInstallContext = TOleEnum;
const
  msiInstallContextFirstVisible = $00000000;
  msiInstallContextUserManaged = $00000001;
  msiInstallContextUser = $00000002;
  msiInstallContextMachine = $00000004;
  msiInstallContextAllUserManaged = $00000008;

// Constants for enum MsiInstallSourceType
type
  MsiInstallSourceType = TOleEnum;
const
  msiInstallSourceTypeUnknown = $00000000;
  msiInstallSourceTypeNetwork = $00000001;
  msiInstallSourceTypeURL = $00000002;
  msiInstallSourceTypeMedia = $00000004;

// Constants for enum MsiAssemblyType
type
  MsiAssemblyType = TOleEnum;
const
  msiProvideAssemblyNet = $00000000;
  msiProvideAssemblyWin32 = $00000001;

// Constants for enum MsiProductScriptInfo
type
  MsiProductScriptInfo = TOleEnum;
const
  msiProductScriptInfoProductCode = $00000000;
  msiProductScriptInfoProductLanguage = $00000001;
  msiProductScriptInfoProductVersion = $00000002;
  msiProductScriptInfoProductName = $00000003;
  msiProductScriptInfoPackageName = $00000004;

// Constants for enum MsiAdvertiseProductContext
type
  MsiAdvertiseProductContext = TOleEnum;
const
  msiAdvertiseProductMachine = $00000000;
  msiAdvertiseProductUser = $00000001;

// Constants for enum Constants
type
  Constants = TOleEnum;
const
  msiDatabaseNullInteger = $80000000;

// Constants for enum MsiOpenDatabaseMode
type
  MsiOpenDatabaseMode = TOleEnum;
const
  msiOpenDatabaseModeReadOnly = $00000000;
  msiOpenDatabaseModeTransact = $00000001;
  msiOpenDatabaseModeDirect = $00000002;
  msiOpenDatabaseModeCreate = $00000003;
  msiOpenDatabaseModeCreateDirect = $00000004;
  msiOpenDatabaseModePatchFile = $00000020;

// Constants for enum MsiSignatureOption
type
  MsiSignatureOption = TOleEnum;
const
  msiSignatureOptionInvalidHashFatal = $00000001;

// Constants for enum MsiAdvertiseProductPlatform
type
  MsiAdvertiseProductPlatform = TOleEnum;
const
  msiAdvertiseCurrentPlatform = $00000000;
  msiAdvertiseX86Platform = $00000001;
  msiAdvertiseIA64Platform = $00000002;
  msiAdvertiseX64Platform = $00000004;

// Constants for enum MsiAdvertiseProductOptions
type
  MsiAdvertiseProductOptions = TOleEnum;
const
  msiAdvertiseDefault = $00000000;
  msiAdvertiseSingleInstance = $00000001;

// Constants for enum MsiAdvertiseScriptFlags
type
  MsiAdvertiseScriptFlags = TOleEnum;
const
  msiAdvertiseScriptCacheInfo = $00000001;
  msiAdvertiseScriptShortcuts = $00000004;
  msiAdvertiseScriptMachineAssign = $00000008;
  msiAdvertiseScriptConfigurationRegistration = $00000020;
  msiAdvertiseScriptValidateTransformsList = $00000040;
  msiAdvertiseScriptClassInfoRegistration = $00000080;
  msiAdvertiseScriptExtensionInfoRegistration = $00000100;
  msiAdvertiseScriptAppInfo = $00000180;
  msiAdvertiseScriptRegData = $000001A0;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  Installer = dispinterface;
  Record_ = dispinterface;
  Session = dispinterface;
  Database = dispinterface;
  SummaryInfo = dispinterface;
  View = dispinterface;
  UIPreview = dispinterface;
  FeatureInfo = dispinterface;
  RecordList = dispinterface;
  StringList = dispinterface;
  Product = dispinterface;
  Patch = dispinterface;

// *********************************************************************//
// DispIntf:  Installer
// Flags:     (4096) Dispatchable
// GUID:      {000C1090-0000-0000-C000-000000000046}
// *********************************************************************//
  Installer = dispinterface
    ['{000C1090-0000-0000-C000-000000000046}']
    function OpenPackage(PackagePath: OleVariant; Options: Integer): Session; dispid 2;
    function OpenProduct(const ProductCode: WideString): Session; dispid 3;
    property Version: WideString readonly dispid 9;
    function CreateRecord(Count: Integer): Record_; dispid 1;
    procedure EnableLog(const LogMode: WideString; const LogFile: WideString); dispid 7;
    procedure InstallProduct(const PackagePath: WideString; const PropertyValues: WideString); dispid 8;
    function OpenDatabase(const DatabasePath: WideString; OpenMode: OleVariant): Database; dispid 4;
    function FileVersion(const FilePath: WideString; Language: OleVariant): WideString; dispid 16;
    function RegistryValue(Root: OleVariant; const Key: WideString; Value: OleVariant): WideString; dispid 11;
    function FileAttributes(const FilePath: WideString): Integer; dispid 13;
    function ProvideQualifiedComponent(const Category: WideString; const Qualifier: WideString; 
                                       InstallMode: Integer): WideString; dispid 32;
    function LastErrorRecord: Record_; dispid 10;
    property Environment[const Variable: WideString]: WideString dispid 12;
    function FileSize(const FilePath: WideString): Integer; dispid 15;
    property SummaryInformation[const PackagePath: WideString; UpdateCount: Integer]: SummaryInfo readonly dispid 5;
    property ProductState[const Product: WideString]: MsiInstallState readonly dispid 17;
    property ProductInfo[const Product: WideString; const Attribute: WideString]: WideString readonly dispid 18;
    procedure ConfigureProduct(const Product: WideString; InstallLevel: Integer; 
                               InstallState: MsiInstallState); dispid 19;
    procedure ReinstallProduct(const Product: WideString; ReinstallMode: MsiReinstallMode); dispid 20;
    procedure CollectUserInfo(const Product: WideString); dispid 21;
    procedure ApplyPatch(const PatchPackage: WideString; const InstallPackage: WideString; 
                         InstallType: MsiInstallType; const CommandLine: WideString); dispid 22;
    property FeatureParent[const Product: WideString; const Feature: WideString]: WideString readonly dispid 23;
    property FeatureState[const Product: WideString; const Feature: WideString]: MsiInstallState readonly dispid 24;
    procedure UseFeature(const Product: WideString; const Feature: WideString; 
                         InstallMode: MsiInstallMode); dispid 25;
    property FeatureUsageCount[const Product: WideString; const Feature: WideString]: Integer readonly dispid 26;
    property FeatureUsageDate[const Product: WideString; const Feature: WideString]: TDateTime readonly dispid 27;
    procedure ConfigureFeature(const Product: WideString; const Feature: WideString; 
                               InstallState: MsiInstallState); dispid 28;
    procedure ReinstallFeature(const Product: WideString; const Feature: WideString; 
                               ReinstallMode: MsiReinstallMode); dispid 29;
    function ProvideComponent(const Product: WideString; const Feature: WideString; 
                              const Component: WideString; InstallMode: Integer): WideString; dispid 30;
    property ComponentPath[const Product: WideString; const Component: WideString]: WideString readonly dispid 31;
    property QualifierDescription[const Category: WideString; const Qualifier: WideString]: WideString readonly dispid 33;
    property ComponentQualifiers[const Category: WideString]: StringList readonly dispid 34;
    property Products: StringList readonly dispid 35;
    property Features[const Product: WideString]: StringList readonly dispid 36;
    property Components: StringList readonly dispid 37;
    property ComponentClients[const Component: WideString]: StringList readonly dispid 38;
    property Patches[const Product: WideString]: StringList readonly dispid 39;
    property RelatedProducts[const UpgradeCode: WideString]: StringList readonly dispid 40;
    property PatchInfo[const Patch: WideString; const Attribute: WideString]: WideString readonly dispid 41;
    property PatchTransforms[const Product: WideString; const Patch: WideString]: WideString readonly dispid 42;
    procedure AddSource(const Product: WideString; const User: WideString; const Source: WideString); dispid 43;
    procedure ClearSourceList(const Product: WideString; const User: WideString); dispid 44;
    procedure ForceSourceListResolution(const Product: WideString; const User: WideString); dispid 45;
    property GetShortcutTarget[const ShortcutPath: WideString]: Record_ readonly dispid 46;
    function FileHash(const FilePath: WideString; Options: Integer): Record_; dispid 47;
    function FileSignatureInfo(const FilePath: WideString; Options: Integer; 
                               Format: MsiSignatureInfo): {??PSafeArray}OleVariant; dispid 48;
    procedure RemovePatches(const PatchList: WideString; const Product: WideString; 
                            UninstallType: MsiInstallType; const PropertyList: WideString); dispid 49;
    procedure ApplyMultiplePatches(const PatchPackage: WideString; const Product: WideString; 
                                   const PropertiesList: WideString); dispid 51;
    property Product[const Product: WideString; const UserSid: WideString; 
                     iContext: MsiInstallContext]: Product readonly dispid 53;
    property Patch[const PatchCode: WideString; const ProductCode: WideString; 
                   const UserSid: WideString; iContext: MsiInstallContext]: Patch readonly dispid 56;
    property ProductsEx[const Product: WideString; const UserSid: WideString; Contexts: Integer]: RecordList readonly dispid 52;
    property PatchesEx[const Product: WideString; const UserSid: WideString; Contexts: Integer; 
                       filter: Integer]: RecordList readonly dispid 55;
    function ExtractPatchXMLData(const PatchPath: WideString): WideString; dispid 57;
    property ProductCode[const Component: WideString]: WideString readonly dispid 58;
    property ProductElevated[const Product: WideString]: WordBool readonly dispid 59;
    function ProvideAssembly(const Assembly: WideString; const Context: WideString; 
                             InstallMode: Integer; AssemblyInfo: MsiAssemblyType): WideString; dispid 60;
    property ProductInfoFromScript[const ScriptFile: WideString; ProductInfo: MsiProductScriptInfo]: OleVariant readonly dispid 61;
    procedure AdvertiseProduct(const PackagePath: WideString; iContext: MsiAdvertiseProductContext; 
                               const Transforms: WideString; Language: Integer; Options: Integer); dispid 62;
    procedure CreateAdvertiseScript(const PackagePath: WideString; 
                                    const ScriptFilePath: WideString; const Transforms: WideString; 
                                    Language: Integer; Platform: Integer; Options: Integer); dispid 63;
    procedure AdvertiseScript(const ScriptPath: WideString; ScriptFlags: Integer; 
                              RemoveItems: WordBool); dispid 64;
    property PatchFiles[const Product: WideString; const PatchPackages: WideString]: StringList readonly dispid 65;
    property UILevel: MsiUILevel dispid 6;
  end;

// *********************************************************************//
// DispIntf:  Record_
// Flags:     (4096) Dispatchable
// GUID:      {000C1093-0000-0000-C000-000000000046}
// *********************************************************************//
  Record_ = dispinterface
    ['{000C1093-0000-0000-C000-000000000046}']
    property StringData[Field: Integer]: WideString dispid 1;
    property IntegerData[Field: Integer]: Integer dispid 2;
    procedure SetStream(Field: Integer; const FilePath: WideString); dispid 3;
    function ReadStream(Field: Integer; Length: Integer; Format: MsiReadStream): WideString; dispid 4;
    property FieldCount: Integer readonly dispid 0;
    property IsNull[Field: Integer]: WordBool readonly dispid 6;
    property DataSize[Field: Integer]: Integer readonly dispid 5;
    procedure ClearData; dispid 7;
    function FormatText: WideString; dispid 8;
  end;

// *********************************************************************//
// DispIntf:  Session
// Flags:     (4096) Dispatchable
// GUID:      {000C109E-0000-0000-C000-000000000046}
// *********************************************************************//
  Session = dispinterface
    ['{000C109E-0000-0000-C000-000000000046}']
    property Installer: Installer readonly dispid 1;
    property Property_[const Name: WideString]: WideString dispid 2;
    property Language: Integer readonly dispid 3;
    property Mode[Flag: MsiRunMode]: WordBool dispid 4;
    property Database: Database readonly dispid 5;
    property SourcePath[const Folder: WideString]: WideString readonly dispid 6;
    property TargetPath[const Folder: WideString]: WideString dispid 7;
    function DoAction(const Action: WideString): MsiDoActionStatus; dispid 8;
    function Sequence(const Table: WideString; Mode: OleVariant): MsiDoActionStatus; dispid 9;
    function EvaluateCondition(const Expression: WideString): MsiEvaluateCondition; dispid 10;
    function FormatRecord(const Record_: Record_): WideString; dispid 11;
    function Message(Kind: MsiMessageType; const Record_: Record_): MsiMessageStatus; dispid 12;
    property FeatureCurrentState[const Feature: WideString]: MsiInstallState readonly dispid 13;
    property FeatureRequestState[const Feature: WideString]: MsiInstallState dispid 14;
    property FeatureValidStates[const Feature: WideString]: Integer readonly dispid 15;
    property FeatureCost[const Feature: WideString; CostTree: MsiCostTree; State: MsiInstallState]: Integer readonly dispid 16;
    property ComponentCurrentState[const Component: WideString]: MsiInstallState readonly dispid 17;
    property ComponentRequestState[const Component: WideString]: MsiInstallState dispid 18;
    procedure SetInstallLevel(Level: Integer); dispid 19;
    property VerifyDiskSpace: WordBool readonly dispid 20;
    property ProductProperty[const Property_: WideString]: WideString readonly dispid 21;
    property FeatureInfo[const Feature: WideString]: FeatureInfo readonly dispid 22;
    property ComponentCosts[const Component: WideString; State: MsiInstallState]: RecordList readonly dispid 23;
  end;

// *********************************************************************//
// DispIntf:  Database
// Flags:     (4096) Dispatchable
// GUID:      {000C109D-0000-0000-C000-000000000046}
// *********************************************************************//
  Database = dispinterface
    ['{000C109D-0000-0000-C000-000000000046}']
    property DatabaseState: MsiDatabaseState readonly dispid 1;
    property SummaryInformation[UpdateCount: Integer]: SummaryInfo readonly dispid 2;
    function OpenView(const Sql: WideString): View; dispid 3;
    procedure Commit; dispid 4;
    property PrimaryKeys[const Table: WideString]: Record_ readonly dispid 5;
    procedure Import(const Folder: WideString; const File_: WideString); dispid 6;
    procedure Export(const Table: WideString; const Folder: WideString; const File_: WideString); dispid 7;
    function Merge(const Database: Database; const ErrorTable: WideString): WordBool; dispid 8;
    function GenerateTransform(const ReferenceDatabase: Database; const TransformFile: WideString): WordBool; dispid 9;
    procedure ApplyTransform(const TransformFile: WideString; ErrorConditions: MsiTransformError); dispid 10;
    function EnableUIPreview: UIPreview; dispid 11;
    property TablePersistent[const Table: WideString]: MsiEvaluateCondition readonly dispid 12;
    procedure CreateTransformSummaryInfo(const ReferenceDatabase: Database; 
                                         const TransformFile: WideString; 
                                         ErrorConditions: MsiTransformError; 
                                         Validation: MsiTransformValidation); dispid 13;
  end;

// *********************************************************************//
// DispIntf:  SummaryInfo
// Flags:     (4096) Dispatchable
// GUID:      {000C109B-0000-0000-C000-000000000046}
// *********************************************************************//
  SummaryInfo = dispinterface
    ['{000C109B-0000-0000-C000-000000000046}']
    property Property_[Pid: Integer]: OleVariant dispid 1;
    property PropertyCount: Integer readonly dispid 2;
    procedure Persist; dispid 3;
  end;

// *********************************************************************//
// DispIntf:  View
// Flags:     (4096) Dispatchable
// GUID:      {000C109C-0000-0000-C000-000000000046}
// *********************************************************************//
  View = dispinterface
    ['{000C109C-0000-0000-C000-000000000046}']
    procedure Execute(const Params: Record_); dispid 1;
    function Fetch: Record_; dispid 2;
    procedure Modify(Mode: MsiViewModify; const Record_: Record_); dispid 3;
    property ColumnInfo[Info: MsiColumnInfo]: Record_ readonly dispid 5;
    procedure Close; dispid 4;
    function GetError: WideString; dispid 6;
  end;

// *********************************************************************//
// DispIntf:  UIPreview
// Flags:     (4096) Dispatchable
// GUID:      {000C109A-0000-0000-C000-000000000046}
// *********************************************************************//
  UIPreview = dispinterface
    ['{000C109A-0000-0000-C000-000000000046}']
    property Property_[const Name: WideString]: WideString dispid 1;
    procedure ViewDialog(const Dialog: WideString); dispid 2;
    procedure ViewBillboard(const Control: WideString; const Billboard: WideString); dispid 3;
  end;

// *********************************************************************//
// DispIntf:  FeatureInfo
// Flags:     (4096) Dispatchable
// GUID:      {000C109F-0000-0000-C000-000000000046}
// *********************************************************************//
  FeatureInfo = dispinterface
    ['{000C109F-0000-0000-C000-000000000046}']
    property Title: WideString readonly dispid 1;
    property Description: WideString readonly dispid 2;
    property Attributes: Integer dispid 3;
  end;

// *********************************************************************//
// DispIntf:  RecordList
// Flags:     (4096) Dispatchable
// GUID:      {000C1096-0000-0000-C000-000000000046}
// *********************************************************************//
  RecordList = dispinterface
    ['{000C1096-0000-0000-C000-000000000046}']
    function _NewEnum: IUnknown; dispid -4;
    property Item[Index: Integer]: Record_ readonly dispid 0; default;
    property Count: Integer readonly dispid 1;
  end;

// *********************************************************************//
// DispIntf:  StringList
// Flags:     (4096) Dispatchable
// GUID:      {000C1095-0000-0000-C000-000000000046}
// *********************************************************************//
  StringList = dispinterface
    ['{000C1095-0000-0000-C000-000000000046}']
    function _NewEnum: IUnknown; dispid -4;
    property Item[Index: Integer]: WideString readonly dispid 0; default;
    property Count: Integer readonly dispid 1;
  end;

// *********************************************************************//
// DispIntf:  Product
// Flags:     (4096) Dispatchable
// GUID:      {000C10A0-0000-0000-C000-000000000046}
// *********************************************************************//
  Product = dispinterface
    ['{000C10A0-0000-0000-C000-000000000046}']
    property ProductCode: WideString readonly dispid 1;
    property UserSid: WideString readonly dispid 2;
    property Context: MsiInstallContext readonly dispid 3;
    property State: MsiInstallState readonly dispid 4;
    property InstallProperty[const Name: WideString]: WideString readonly dispid 5;
    property ComponentState[const Component: WideString]: MsiInstallState readonly dispid 6;
    property FeatureState[const Feature: WideString]: MsiInstallState readonly dispid 7;
    property Sources[SourceType: Integer]: StringList readonly dispid 14;
    property MediaDisks: RecordList readonly dispid 15;
    procedure SourceListAddSource(iSourceType: MsiInstallSourceType; const Source: WideString; 
                                  dwIndex: Integer); dispid 8;
    procedure SourceListAddMediaDisk(dwDiskId: Integer; const VolumeLabel: WideString; 
                                     const DiskPrompt: WideString); dispid 9;
    procedure SourceListClearSource(iSourceType: MsiInstallSourceType; const Source: WideString); dispid 10;
    procedure SourceListClearMediaDisk(iDiskId: Integer); dispid 11;
    procedure SourceListClearAll(iSourceType: MsiInstallSourceType); dispid 12;
    procedure SourceListForceResolution; dispid 13;
    property SourceListInfo[const Property_: WideString]: WideString dispid 16;
  end;

// *********************************************************************//
// DispIntf:  Patch
// Flags:     (4096) Dispatchable
// GUID:      {000C10A1-0000-0000-C000-000000000046}
// *********************************************************************//
  Patch = dispinterface
    ['{000C10A1-0000-0000-C000-000000000046}']
    property PatchCode: WideString readonly dispid 1;
    property ProductCode: WideString readonly dispid 2;
    property UserSid: WideString readonly dispid 3;
    property Context: MsiInstallContext readonly dispid 4;
    property State: MsiInstallState readonly dispid 5;
    property Sources[SourceType: Integer]: StringList readonly dispid 12;
    property MediaDisks: RecordList readonly dispid 13;
    procedure SourceListAddSource(iSourceType: MsiInstallSourceType; const Source: WideString; 
                                  dwIndex: Integer); dispid 6;
    procedure SourceListAddMediaDisk(dwDiskId: Integer; const VolumeLabel: WideString; 
                                     const DiskPrompt: WideString); dispid 7;
    procedure SourceListClearSource(iSourceType: MsiInstallSourceType; const Source: WideString); dispid 8;
    procedure SourceListClearMediaDisk(iDiskId: Integer); dispid 9;
    procedure SourceListClearAll(iSourceType: MsiInstallSourceType); dispid 10;
    procedure SourceListForceResolution; dispid 11;
    property SourceListInfo[const Property_: WideString]: WideString dispid 14;
    property PatchProperty[const Property_: WideString]: WideString readonly dispid 15;
  end;

implementation

uses ComObj;

end.
