unit XWizard;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:56:19 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\xwizards.dll (1)
// LIBID: {777BA800-2498-4875-933A-3067DE883070}
// LCID: 0
// Helpfile: 
// HelpString: XWizard 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  XWizardMajorVersion = 1;
  XWizardMinorVersion = 0;

  LIBID_XWizard: TGUID = '{777BA800-2498-4875-933A-3067DE883070}';

  IID_IXWizard: TGUID = '{777BA87A-2498-4875-933A-3067DE883070}';
  CLASS_CXWizard: TGUID = '{777BA87C-2498-4875-933A-3067DE883070}';
  IID_IEnumXWizardHost: TGUID = '{777BA8AE-2498-4875-933A-3067DE883070}';
  IID_IEnumXWizardTask: TGUID = '{777BA8BE-2498-4875-933A-3067DE883070}';
  IID_IEnumXWizardPage: TGUID = '{777BA8CE-2498-4875-933A-3067DE883070}';
  IID_IXMLDOMParseError: TGUID = '{3EFAA426-272F-11D2-836F-0000F87A7782}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum tagXW_WIZARD_TYPE
type
  tagXW_WIZARD_TYPE = TOleEnum;
const
  XW_WIZARD_TYPE_NONE = $00000000;
  XW_WIZARD_TYPE_PROPERTYSHEET97 = $00000001;
  XW_WIZARD_TYPE_WIZARD97 = $00000002;
  XW_WIZARD_TYPE_AEROSMALLFIXED = $00000020;
  XW_WIZARD_TYPE_AEROSMALLRESIZE = $00000040;
  XW_WIZARD_TYPE_AEROBIGFIXED = $00000080;
  XW_WIZARD_TYPE_AEROBIGRESIZE = $000000C0;
  XW_WIZARD_TYPE_TASKPAGE = $00020000;
  XW_WIZARD_TYPE_MEDIACENTER = $02000000;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IXWizard = interface;
  IEnumXWizardHost = interface;
  IEnumXWizardTask = interface;
  IEnumXWizardPage = interface;
  IXMLDOMParseError = interface;
  IXMLDOMParseErrorDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  CXWizard = IXWizard;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 
  PUserType1 = ^TGUID; {*}
  PUserType2 = ^_XWIZARD_HOST_DISPLAY_TASK_INFO; {*}

  _XWIZARD_HOST_DISPLAY_TASK_INFO = packed record
    dwVersion: LongWord;
    dwDisplayFlags: LongWord;
    guidTask: TGUID;
    pfnLoadImage: Pointer;
    hInstance: Pointer;
    pszIcon: PWideChar;
    pszViewName: PWideChar;
    pszTooltipName: PWideChar;
  end;


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;


// *********************************************************************//
// Interface: IXWizard
// Flags:     (0)
// GUID:      {777BA87A-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IXWizard = interface(IUnknown)
    ['{777BA87A-2498-4875-933A-3067DE883070}']
    function RegisterHost(var pguidHost: TGUID; pszModuleFileName: PWideChar; 
                          pszFriendlyName: PWideChar; dwBehaviorFlags: LongWord): HResult; stdcall;
    function RegisterTaskWithHost(var pguidParentHost: TGUID; var pguidChildTask: TGUID; 
                                  pszChildModuleFileName: PWideChar; pszFriendlyName: PWideChar; 
                                  dwBehaviorFlags: LongWord; dwUserFlags: LongWord; 
                                  pszCommandLine: PWideChar): HResult; stdcall;
    function RegisterPageWithTask(var pguidParentTask: TGUID; var pguidChildPage: TGUID; 
                                  pszChildModuleFileName: PWideChar; pszFriendlyName: PWideChar; 
                                  dwBehaviorFlags: LongWord; dwUserFlags: LongWord; 
                                  pszCommandLine: PWideChar): HResult; stdcall;
    function RegisterPageWithPage(var pguidParentPage: TGUID; var pguidChildPage: TGUID; 
                                  pszChildModuleFileName: PWideChar; pszFriendlyName: PWideChar; 
                                  dwBehaviorFlags: LongWord; dwUserFlags: LongWord; 
                                  pszCommandLine: PWideChar): HResult; stdcall;
    function UnregisterHost(var pguidHost: TGUID; fUnregisterFromCOM: Integer): HResult; stdcall;
    function UnregisterTask(var pguidTask: TGUID; fUnregisterFromCOM: Integer): HResult; stdcall;
    function UnregisterPage(var pguidPage: TGUID; fUnregisterFromCOM: Integer): HResult; stdcall;
    function UnregisterHostTaskLink(var pguidParentHost: TGUID; var pguidChildTask: TGUID): HResult; stdcall;
    function UnregisterTaskPageLink(var pguidParentTask: TGUID; var pguidChildPage: TGUID): HResult; stdcall;
    function UnregisterPagesLink(var pguidParentPage: TGUID; var pguidChildPage: TGUID): HResult; stdcall;
    function EnumHosts(dwEnumerationFlags: LongWord; out ppenum: IEnumXWizardHost): HResult; stdcall;
    function EnumChildTasksOfHost(var pguidParentHost: TGUID; dwEnumerationFlags: LongWord; 
                                  out ppenum: IEnumXWizardTask): HResult; stdcall;
    function EnumParentHostsOfTask(var pguidChildTask: TGUID; dwEnumerationFlags: LongWord; 
                                   out ppenum: IEnumXWizardHost): HResult; stdcall;
    function EnumChildPagesOfTask(var pguidParentTask: TGUID; dwEnumerationFlags: LongWord; 
                                  out ppenum: IEnumXWizardPage): HResult; stdcall;
    function EnumParentTasksOfPage(var pguidChildPage: TGUID; dwEnumerationFlags: LongWord; 
                                   out ppenum: IEnumXWizardTask): HResult; stdcall;
    function EnumParentPagesOfPage(var pguidChildPage: TGUID; dwEnumerationFlags: LongWord; 
                                   out ppenum: IEnumXWizardPage): HResult; stdcall;
    function EnumChildPagesOfPage(var pguidParentPage: TGUID; dwEnumerationFlags: LongWord; 
                                  out ppenum: IEnumXWizardPage): HResult; stdcall;
    function GetWizardTypesSupported(var pguidTask: TGUID; out pdwWizardTypes: LongWord): HResult; stdcall;
    function GetHostInfo(var pguidParentHost: TGUID; var pguidTask: TGUID; 
                         out ppHostDisplayData: PUserType2): HResult; stdcall;
    function RunWizard(var hwndParent: _RemotableHandle; var pguidParentHost: TGUID; 
                       var pguidTask: TGUID; eWizardType: tagXW_WIZARD_TYPE; dwUserFlags: LongWord; 
                       pszCommandLine: PWideChar; var hUserContext: Pointer; 
                       dwContextFlags: LongWord): HResult; stdcall;
    function ProcessXMLFile(var hwndParent: _RemotableHandle; pszXMLFileName: PWideChar; 
                            dwImportFlags: LongWord; out ppParseError: IXMLDOMParseError): HResult; stdcall;
    function ExportXMLFile(pszXMLFileName: PWideChar; dwExportFlags: LongWord): HResult; stdcall;
    function GetWrapperCLSID(var pclsidComponent: TGUID): HResult; stdcall;
    function GetWrappedCLSID(var pclsidComponent: TGUID): HResult; stdcall;
    function SetInternalValue(dwValueIndex: LongWord; var hValue: Pointer): HResult; stdcall;
    function GetInternalValue(dwValueIndex: LongWord; out phValue: Pointer): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IEnumXWizardHost
// Flags:     (0)
// GUID:      {777BA8AE-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IEnumXWizardHost = interface(IUnknown)
    ['{777BA8AE-2498-4875-933A-3067DE883070}']
    function Next(celt: LongWord; out rgelt: PUserType1; out pceltFetched: LongWord): HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out ppenum: IEnumXWizardHost): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IEnumXWizardTask
// Flags:     (0)
// GUID:      {777BA8BE-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IEnumXWizardTask = interface(IUnknown)
    ['{777BA8BE-2498-4875-933A-3067DE883070}']
    function Next(celt: LongWord; out rgelt: PUserType1; out pceltFetched: LongWord): HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out ppenum: IEnumXWizardTask): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IEnumXWizardPage
// Flags:     (0)
// GUID:      {777BA8CE-2498-4875-933A-3067DE883070}
// *********************************************************************//
  IEnumXWizardPage = interface(IUnknown)
    ['{777BA8CE-2498-4875-933A-3067DE883070}']
    function Next(celt: LongWord; out rgelt: PUserType1; out pceltFetched: LongWord): HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out ppenum: IEnumXWizardPage): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IXMLDOMParseError
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {3EFAA426-272F-11D2-836F-0000F87A7782}
// *********************************************************************//
  IXMLDOMParseError = interface(IDispatch)
    ['{3EFAA426-272F-11D2-836F-0000F87A7782}']
    function Get_errorCode: Integer; safecall;
    function Get_url: WideString; safecall;
    function Get_reason: WideString; safecall;
    function Get_srcText: WideString; safecall;
    function Get_line: Integer; safecall;
    function Get_linepos: Integer; safecall;
    function Get_filepos: Integer; safecall;
    property errorCode: Integer read Get_errorCode;
    property url: WideString read Get_url;
    property reason: WideString read Get_reason;
    property srcText: WideString read Get_srcText;
    property line: Integer read Get_line;
    property linepos: Integer read Get_linepos;
    property filepos: Integer read Get_filepos;
  end;

// *********************************************************************//
// DispIntf:  IXMLDOMParseErrorDisp
// Flags:     (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID:      {3EFAA426-272F-11D2-836F-0000F87A7782}
// *********************************************************************//
  IXMLDOMParseErrorDisp = dispinterface
    ['{3EFAA426-272F-11D2-836F-0000F87A7782}']
    property errorCode: Integer readonly dispid 0;
    property url: WideString readonly dispid 179;
    property reason: WideString readonly dispid 180;
    property srcText: WideString readonly dispid 181;
    property line: Integer readonly dispid 182;
    property linepos: Integer readonly dispid 183;
    property filepos: Integer readonly dispid 184;
  end;

// *********************************************************************//
// The Class CoCXWizard provides a Create and CreateRemote method to          
// create instances of the default interface IXWizard exposed by              
// the CoClass CXWizard. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoCXWizard = class
    class function Create: IXWizard;
    class function CreateRemote(const MachineName: string): IXWizard;
  end;

implementation

uses ComObj;

class function CoCXWizard.Create: IXWizard;
begin
  Result := CreateComObject(CLASS_CXWizard) as IXWizard;
end;

class function CoCXWizard.CreateRemote(const MachineName: string): IXWizard;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CXWizard) as IXWizard;
end;

end.
