unit dtshLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:22:32 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\dtsh.dll (1)
// LIBID: {1FDA955A-61FF-11DA-978C-0008744FAAB7}
// LCID: 0
// Helpfile: 
// HelpString: Detection And Sharing 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// Errors:
//   Hint: Enum Member 'On' of '_DtshState' changed to 'On_'
//   Hint: Enum Member 'On' of '_DtshState' changed to 'On_'
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  dtshLibMajorVersion = 1;
  dtshLibMinorVersion = 0;

  LIBID_dtshLib: TGUID = '{1FDA955A-61FF-11DA-978C-0008744FAAB7}';

  IID_IDetectionAndSharing: TGUID = '{1FDA955C-61FF-11DA-978C-0008744FAAB7}';
  CLASS_DetectionAndSharing: TGUID = '{1FDA955B-61FF-11DA-978C-0008744FAAB7}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum _DtshType
type
  _DtshType = TOleEnum;
const
  Discovery = $00000000;
  FileSharing = $00000001;
  MediaSharing = $00000002;
  DiscoveryAndFileSharing = $00000003;
  All = $00000004;
  DtshTypeMax = $00000005;

// Constants for enum _DtshState
type
  _DtshState = TOleEnum;
const
  Off = $00000000;
  On_ = $00000001;
  Custom = $00000002;

// Constants for enum _DtshAction
type
  _DtshAction = TOleEnum;
const
  Toggle = $00000000;
  TurnOffAndEnableFw = $00000001;
  TurnOnAndDisableFwBlockAllIncoming = $00000002;
  NoneFwDisabled = $00000003;
  NoneFwGpOverride = $00000004;
  NoneThirdPartyFwInstalled = $00000005;

// Constants for enum NET_FW_PROFILE_TYPE2_
type
  NET_FW_PROFILE_TYPE2_ = TOleEnum;
const
  NET_FW_PROFILE2_DOMAIN = $00000001;
  NET_FW_PROFILE2_PRIVATE = $00000002;
  NET_FW_PROFILE2_PUBLIC = $00000004;
  NET_FW_PROFILE2_ALL = $7FFFFFFF;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IDetectionAndSharing = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  DetectionAndSharing = IDetectionAndSharing;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 

  DtshType = _DtshType; 
  DtshState = _DtshState; 
  DtshAction = _DtshAction; 

  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = packed record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;


// *********************************************************************//
// Interface: IDetectionAndSharing
// Flags:     (128) NonExtensible
// GUID:      {1FDA955C-61FF-11DA-978C-0008744FAAB7}
// *********************************************************************//
  IDetectionAndSharing = interface(IUnknown)
    ['{1FDA955C-61FF-11DA-978C-0008744FAAB7}']
    function GetStatus(DtshType: DtshType; out pState: DtshState; var pAvailableAction: DtshAction): HResult; stdcall;
    function TurnOn(var hwndParent: _RemotableHandle; DtshType: DtshType; bOn: Integer): HResult; stdcall;
    function GetCurrentFwProfile(out pFwProfileType: NET_FW_PROFILE_TYPE2_): HResult; stdcall;
    function GetStatusForProfile(fwProfileType: NET_FW_PROFILE_TYPE2_; DtshType: DtshType; 
                                 out pState: DtshState; var pAvailableAction: DtshAction): HResult; stdcall;
    function TurnOnForProfile(var hwndParent: _RemotableHandle; 
                              fwProfileType: NET_FW_PROFILE_TYPE2_; DtshType: DtshType; bOn: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoDetectionAndSharing provides a Create and CreateRemote method to          
// create instances of the default interface IDetectionAndSharing exposed by              
// the CoClass DetectionAndSharing. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoDetectionAndSharing = class
    class function Create: IDetectionAndSharing;
    class function CreateRemote(const MachineName: string): IDetectionAndSharing;
  end;

implementation

uses ComObj;

class function CoDetectionAndSharing.Create: IDetectionAndSharing;
begin
  Result := CreateComObject(CLASS_DetectionAndSharing) as IDetectionAndSharing;
end;

class function CoDetectionAndSharing.CreateRemote(const MachineName: string): IDetectionAndSharing;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_DetectionAndSharing) as IDetectionAndSharing;
end;

end.
