unit gameuxLib;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 10/3/2014 4:24:43 AM from Type Library described below.

// ************************************************************************  //
// Type Lib: c:\windows\system32\gameux.dll (1)
// LIBID: {1DE6CE3D-EA69-4671-941F-26F789F39C5B}
// LCID: 0
// Helpfile: 
// HelpString: gameux public 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  gameuxLibMajorVersion = 1;
  gameuxLibMinorVersion = 0;

  LIBID_gameuxLib: TGUID = '{1DE6CE3D-EA69-4671-941F-26F789F39C5B}';

  IID_IGameExplorer: TGUID = '{E7B2FB72-D728-49B3-A5F2-18EBF5F1349E}';
  CLASS_GameExplorer: TGUID = '{9A5EA990-3034-4D6F-9128-01F3C61022BC}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum GAME_INSTALL_SCOPE
type
  GAME_INSTALL_SCOPE = TOleEnum;
const
  GIS_NOT_INSTALLED = $00000001;
  GIS_CURRENT_USER = $00000002;
  GIS_ALL_USERS = $00000003;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IGameExplorer = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  GameExplorer = IGameExplorer;


// *********************************************************************//
// Interface: IGameExplorer
// Flags:     (0)
// GUID:      {E7B2FB72-D728-49B3-A5F2-18EBF5F1349E}
// *********************************************************************//
  IGameExplorer = interface(IUnknown)
    ['{E7B2FB72-D728-49B3-A5F2-18EBF5F1349E}']
    function AddGame(const bstrGDFBinaryPath: WideString; 
                     const bstrGameInstallDirectory: WideString; installScope: GAME_INSTALL_SCOPE; 
                     var pguidInstanceID: TGUID): HResult; stdcall;
    function RemoveGame(guidInstanceID: TGUID): HResult; stdcall;
    function UpdateGame(guidInstanceID: TGUID): HResult; stdcall;
    function VerifyAccess(const bstrGDFBinaryPath: WideString; out pfHasAccess: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// The Class CoGameExplorer provides a Create and CreateRemote method to          
// create instances of the default interface IGameExplorer exposed by              
// the CoClass GameExplorer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoGameExplorer = class
    class function Create: IGameExplorer;
    class function CreateRemote(const MachineName: string): IGameExplorer;
  end;

implementation

uses ComObj;

class function CoGameExplorer.Create: IGameExplorer;
begin
  Result := CreateComObject(CLASS_GameExplorer) as IGameExplorer;
end;

class function CoGameExplorer.CreateRemote(const MachineName: string): IGameExplorer;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_GameExplorer) as IGameExplorer;
end;

end.
